/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_ESIAPPIDHIER
#define GEN_PASS_DECL_ESIBUILDMANIFEST
#define GEN_PASS_DECL_ESICLEANMETADATA
#define GEN_PASS_DECL_ESICONNECTSERVICES
#define GEN_PASS_DECL_LOWERESIBUNDLES
#define GEN_PASS_DECL_LOWERESIPORTS
#define GEN_PASS_DECL_LOWERESITOPHYSICAL
#define GEN_PASS_DECL_LOWERESITYPES
#define GEN_PASS_DECL_LOWERESITOHW
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ESIAppIDHier
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESIAPPIDHIER
struct ESIAppIDHierOptions {
  std::string top;
};
#undef GEN_PASS_DECL_ESIAPPIDHIER
#endif // GEN_PASS_DECL_ESIAPPIDHIER
#ifdef GEN_PASS_DEF_ESIAPPIDHIER
namespace impl {

template <typename DerivedT>
class ESIAppIDHierBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIAppIDHierBase;

  ESIAppIDHierBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIAppIDHierBase(const ESIAppIDHierBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-appid-hier");
  }
  ::llvm::StringRef getArgument() const override { return "esi-appid-hier"; }

  ::llvm::StringRef getDescription() const override { return "Build an AppID based hierarchy rooted at top module 'top'"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIAppIDHier");
  }
  ::llvm::StringRef getName() const override { return "ESIAppIDHier"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIAppIDHierBase<DerivedT>)

  ESIAppIDHierBase(const ESIAppIDHierOptions &options) : ESIAppIDHierBase() {
    top = options.top;
  }
protected:
  ::mlir::Pass::Option<std::string> top{*this, "top", ::llvm::cl::desc("Root module of the instance hierarchy")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESIAPPIDHIER
#endif // GEN_PASS_DEF_ESIAPPIDHIER

//===----------------------------------------------------------------------===//
// ESIBuildManifest
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESIBUILDMANIFEST
struct ESIBuildManifestOptions {
  std::string top;
};
#undef GEN_PASS_DECL_ESIBUILDMANIFEST
#endif // GEN_PASS_DECL_ESIBUILDMANIFEST
#ifdef GEN_PASS_DEF_ESIBUILDMANIFEST
namespace impl {

template <typename DerivedT>
class ESIBuildManifestBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIBuildManifestBase;

  ESIBuildManifestBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIBuildManifestBase(const ESIBuildManifestBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-build-manifest");
  }
  ::llvm::StringRef getArgument() const override { return "esi-build-manifest"; }

  ::llvm::StringRef getDescription() const override { return "Build a manifest of an ESI system"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIBuildManifest");
  }
  ::llvm::StringRef getName() const override { return "ESIBuildManifest"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIBuildManifestBase<DerivedT>)

  ESIBuildManifestBase(const ESIBuildManifestOptions &options) : ESIBuildManifestBase() {
    top = options.top;
  }
protected:
  ::mlir::Pass::Option<std::string> top{*this, "top", ::llvm::cl::desc("Root module of the instance hierarchy")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESIBUILDMANIFEST
#endif // GEN_PASS_DEF_ESIBUILDMANIFEST

//===----------------------------------------------------------------------===//
// ESICleanMetadata
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESICLEANMETADATA
#undef GEN_PASS_DECL_ESICLEANMETADATA
#endif // GEN_PASS_DECL_ESICLEANMETADATA
#ifdef GEN_PASS_DEF_ESICLEANMETADATA
namespace impl {

template <typename DerivedT>
class ESICleanMetadataBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESICleanMetadataBase;

  ESICleanMetadataBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESICleanMetadataBase(const ESICleanMetadataBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-clean-metadata");
  }
  ::llvm::StringRef getArgument() const override { return "esi-clean-metadata"; }

  ::llvm::StringRef getDescription() const override { return "Clean up ESI service metadata"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESICleanMetadata");
  }
  ::llvm::StringRef getName() const override { return "ESICleanMetadata"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESICleanMetadataBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESICLEANMETADATA
#endif // GEN_PASS_DEF_ESICLEANMETADATA

//===----------------------------------------------------------------------===//
// ESIConnectServices
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ESICONNECTSERVICES
#undef GEN_PASS_DECL_ESICONNECTSERVICES
#endif // GEN_PASS_DECL_ESICONNECTSERVICES
#ifdef GEN_PASS_DEF_ESICONNECTSERVICES
namespace impl {

template <typename DerivedT>
class ESIConnectServicesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIConnectServicesBase;

  ESIConnectServicesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIConnectServicesBase(const ESIConnectServicesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-connect-services");
  }
  ::llvm::StringRef getArgument() const override { return "esi-connect-services"; }

  ::llvm::StringRef getDescription() const override { return "Connect up ESI service requests to service providers"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIConnectServices");
  }
  ::llvm::StringRef getName() const override { return "ESIConnectServices"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::sv::SVDialect>();
    registry.insert<circt::seq::SeqDialect>();
    registry.insert<circt::comb::CombDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIConnectServicesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ESICONNECTSERVICES
#endif // GEN_PASS_DEF_ESICONNECTSERVICES

//===----------------------------------------------------------------------===//
// LowerESIBundles
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESIBUNDLES
#undef GEN_PASS_DECL_LOWERESIBUNDLES
#endif // GEN_PASS_DECL_LOWERESIBUNDLES
#ifdef GEN_PASS_DEF_LOWERESIBUNDLES
namespace impl {

template <typename DerivedT>
class LowerESIBundlesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIBundlesBase;

  LowerESIBundlesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIBundlesBase(const LowerESIBundlesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-bundles");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-bundles"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI bundles to channels."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIBundles");
  }
  ::llvm::StringRef getName() const override { return "LowerESIBundles"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIBundlesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESIBUNDLES
#endif // GEN_PASS_DEF_LOWERESIBUNDLES

//===----------------------------------------------------------------------===//
// LowerESIPorts
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESIPORTS
#undef GEN_PASS_DECL_LOWERESIPORTS
#endif // GEN_PASS_DECL_LOWERESIPORTS
#ifdef GEN_PASS_DEF_LOWERESIPORTS
namespace impl {

template <typename DerivedT>
class LowerESIPortsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIPortsBase;

  LowerESIPortsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIPortsBase(const LowerESIPortsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-ports");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-ports"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI input and/or output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIPorts");
  }
  ::llvm::StringRef getName() const override { return "LowerESIPorts"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::comb::CombDialect>();
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIPortsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESIPORTS
#endif // GEN_PASS_DEF_LOWERESIPORTS

//===----------------------------------------------------------------------===//
// LowerESIToPhysical
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESITOPHYSICAL
#undef GEN_PASS_DECL_LOWERESITOPHYSICAL
#endif // GEN_PASS_DECL_LOWERESITOPHYSICAL
#ifdef GEN_PASS_DEF_LOWERESITOPHYSICAL
namespace impl {

template <typename DerivedT>
class LowerESIToPhysicalBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIToPhysicalBase;

  LowerESIToPhysicalBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIToPhysicalBase(const LowerESIToPhysicalBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-physical");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-physical"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI abstract Ops to ESI physical ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIToPhysical");
  }
  ::llvm::StringRef getName() const override { return "LowerESIToPhysical"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIToPhysicalBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESITOPHYSICAL
#endif // GEN_PASS_DEF_LOWERESITOPHYSICAL

//===----------------------------------------------------------------------===//
// LowerESITypes
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESITYPES
#undef GEN_PASS_DECL_LOWERESITYPES
#endif // GEN_PASS_DECL_LOWERESITYPES
#ifdef GEN_PASS_DEF_LOWERESITYPES
namespace impl {

template <typename DerivedT>
class LowerESITypesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESITypesBase;

  LowerESITypesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESITypesBase(const LowerESITypesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-types");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-types"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI high level types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESITypes");
  }
  ::llvm::StringRef getName() const override { return "LowerESITypes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESITypesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESITYPES
#endif // GEN_PASS_DEF_LOWERESITYPES

//===----------------------------------------------------------------------===//
// LowerESItoHW
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERESITOHW
struct LowerESItoHWOptions {
  std::string platform;
};
#undef GEN_PASS_DECL_LOWERESITOHW
#endif // GEN_PASS_DECL_LOWERESITOHW
#ifdef GEN_PASS_DEF_LOWERESITOHW
namespace impl {

template <typename DerivedT>
class LowerESItoHWBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESItoHWBase;

  LowerESItoHWBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESItoHWBase(const LowerESItoHWBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-hw");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-hw"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI to HW where possible and SV elsewhere."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESItoHW");
  }
  ::llvm::StringRef getName() const override { return "LowerESItoHW"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::comb::CombDialect>();
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESItoHWBase<DerivedT>)

  LowerESItoHWBase(const LowerESItoHWOptions &options) : LowerESItoHWBase() {
    platform = options.platform;
  }
protected:
  ::mlir::Pass::Option<std::string> platform{*this, "platform", ::llvm::cl::desc("Target this platform")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERESITOHW
#endif // GEN_PASS_DEF_LOWERESITOHW
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ESIAppIDHier Registration
//===----------------------------------------------------------------------===//

inline void registerESIAppIDHier() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIAppIDHierPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESIAppIDHierPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIAppIDHierPass();
  });
}

//===----------------------------------------------------------------------===//
// ESIBuildManifest Registration
//===----------------------------------------------------------------------===//

inline void registerESIBuildManifest() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIBuildManifestPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESIBuildManifestPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIBuildManifestPass();
  });
}

//===----------------------------------------------------------------------===//
// ESICleanMetadata Registration
//===----------------------------------------------------------------------===//

inline void registerESICleanMetadata() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESICleanMetadataPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESICleanMetadataPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESICleanMetadataPass();
  });
}

//===----------------------------------------------------------------------===//
// ESIConnectServices Registration
//===----------------------------------------------------------------------===//

inline void registerESIConnectServices() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIConnectServicesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerESIConnectServicesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIConnectServicesPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESIBundles Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESIBundles() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIBundleLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESIBundlesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIBundleLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESIPorts Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESIPorts() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPortLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESIPortsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPortLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESIToPhysical Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESIToPhysical() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPhysicalLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESIToPhysicalPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESIPhysicalLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESITypes Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESITypes() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESITypeLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESITypesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESITypeLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerESItoHW Registration
//===----------------------------------------------------------------------===//

inline void registerLowerESItoHW() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESItoHWPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerESItoHWPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::esi::createESItoHWPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerESIAppIDHier();
  registerESIBuildManifest();
  registerESICleanMetadata();
  registerESIConnectServices();
  registerLowerESIBundles();
  registerLowerESIPorts();
  registerLowerESIToPhysical();
  registerLowerESITypes();
  registerLowerESItoHW();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ESIAppIDHierBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIAppIDHierBase;

  ESIAppIDHierBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIAppIDHierBase(const ESIAppIDHierBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-appid-hier");
  }
  ::llvm::StringRef getArgument() const override { return "esi-appid-hier"; }

  ::llvm::StringRef getDescription() const override { return "Build an AppID based hierarchy rooted at top module 'top'"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIAppIDHier");
  }
  ::llvm::StringRef getName() const override { return "ESIAppIDHier"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIAppIDHierBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> top{*this, "top", ::llvm::cl::desc("Root module of the instance hierarchy")};
};

template <typename DerivedT>
class ESIBuildManifestBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIBuildManifestBase;

  ESIBuildManifestBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIBuildManifestBase(const ESIBuildManifestBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-build-manifest");
  }
  ::llvm::StringRef getArgument() const override { return "esi-build-manifest"; }

  ::llvm::StringRef getDescription() const override { return "Build a manifest of an ESI system"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIBuildManifest");
  }
  ::llvm::StringRef getName() const override { return "ESIBuildManifest"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIBuildManifestBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> top{*this, "top", ::llvm::cl::desc("Root module of the instance hierarchy")};
};

template <typename DerivedT>
class ESICleanMetadataBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESICleanMetadataBase;

  ESICleanMetadataBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESICleanMetadataBase(const ESICleanMetadataBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-clean-metadata");
  }
  ::llvm::StringRef getArgument() const override { return "esi-clean-metadata"; }

  ::llvm::StringRef getDescription() const override { return "Clean up ESI service metadata"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESICleanMetadata");
  }
  ::llvm::StringRef getName() const override { return "ESICleanMetadata"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESICleanMetadataBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ESIConnectServicesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ESIConnectServicesBase;

  ESIConnectServicesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ESIConnectServicesBase(const ESIConnectServicesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("esi-connect-services");
  }
  ::llvm::StringRef getArgument() const override { return "esi-connect-services"; }

  ::llvm::StringRef getDescription() const override { return "Connect up ESI service requests to service providers"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ESIConnectServices");
  }
  ::llvm::StringRef getName() const override { return "ESIConnectServices"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::sv::SVDialect>();
    registry.insert<circt::seq::SeqDialect>();
    registry.insert<circt::comb::CombDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ESIConnectServicesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESIBundlesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIBundlesBase;

  LowerESIBundlesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIBundlesBase(const LowerESIBundlesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-bundles");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-bundles"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI bundles to channels."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIBundles");
  }
  ::llvm::StringRef getName() const override { return "LowerESIBundles"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIBundlesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESIPortsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIPortsBase;

  LowerESIPortsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIPortsBase(const LowerESIPortsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-ports");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-ports"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI input and/or output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIPorts");
  }
  ::llvm::StringRef getName() const override { return "LowerESIPorts"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::comb::CombDialect>();
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIPortsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESIToPhysicalBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESIToPhysicalBase;

  LowerESIToPhysicalBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESIToPhysicalBase(const LowerESIToPhysicalBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-physical");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-physical"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI abstract Ops to ESI physical ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESIToPhysical");
  }
  ::llvm::StringRef getName() const override { return "LowerESIToPhysical"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESIToPhysicalBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESITypesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESITypesBase;

  LowerESITypesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESITypesBase(const LowerESITypesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-types");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-types"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI high level types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESITypes");
  }
  ::llvm::StringRef getName() const override { return "LowerESITypes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESITypesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerESItoHWBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerESItoHWBase;

  LowerESItoHWBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerESItoHWBase(const LowerESItoHWBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-esi-to-hw");
  }
  ::llvm::StringRef getArgument() const override { return "lower-esi-to-hw"; }

  ::llvm::StringRef getDescription() const override { return "Lower ESI to HW where possible and SV elsewhere."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerESItoHW");
  }
  ::llvm::StringRef getName() const override { return "LowerESItoHW"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::comb::CombDialect>();
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerESItoHWBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> platform{*this, "platform", ::llvm::cl::desc("Target this platform")};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
