/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace circt {
namespace esi {
class ListType;
class ChannelType;
class ChannelBundleType;
class WindowType;
class WindowFrameType;
class WindowFieldType;
class AnyType;
namespace detail {
struct ListTypeStorage;
} // namespace detail
class ListType : public ::mlir::Type::TypeBase<ListType, ::mlir::Type, detail::ListTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "esi.list";
  static ListType get(::mlir::MLIRContext *context, Type elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"list"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  Type getElementType() const;
};
namespace detail {
struct ChannelTypeStorage;
} // namespace detail
class ChannelType : public ::mlir::Type::TypeBase<ChannelType, ::mlir::Type, detail::ChannelTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "esi.channel";
  static ChannelType get(::mlir::MLIRContext *context, Type inner, ::circt::esi::ChannelSignaling signaling);
  static ChannelType get(::mlir::MLIRContext *context, Type type);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"channel"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  Type getInner() const;
  ::circt::esi::ChannelSignaling getSignaling() const;
};
namespace detail {
struct ChannelBundleTypeStorage;
} // namespace detail
class ChannelBundleType : public ::mlir::Type::TypeBase<ChannelBundleType, ::mlir::Type, detail::ChannelBundleTypeStorage> {
public:
  using Base::Base;
  // Get a channel bundle with the same types and names but the directions
  // reversed.
  ChannelBundleType getReversed() const;

  // Return the opposite direction.
  static ChannelDirection flip(ChannelDirection dir) {
    return dir == ChannelDirection::from
                             ? ChannelDirection::to
                             : ChannelDirection::from;
  }
  static constexpr ::llvm::StringLiteral name = "esi.bundle";
  static ChannelBundleType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<BundledChannel> channels, ::mlir::UnitAttr resettable);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"bundle"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<BundledChannel> getChannels() const;
  ::mlir::UnitAttr getResettable() const;
};
namespace detail {
struct WindowTypeStorage;
} // namespace detail
class WindowType : public ::mlir::Type::TypeBase<WindowType, ::mlir::Type, detail::WindowTypeStorage> {
public:
  using Base::Base;
  /// Get the union which realizes this window during lowering.
  circt::hw::UnionType getLoweredType() const;
  static constexpr ::llvm::StringLiteral name = "esi.window";
  using Base::getChecked;
  static WindowType get(::mlir::MLIRContext *context, StringAttr name, mlir::Type into, ::llvm::ArrayRef<WindowFrameType> frames);
  static WindowType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, StringAttr name, mlir::Type into, ::llvm::ArrayRef<WindowFrameType> frames);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, StringAttr name, mlir::Type into, ::llvm::ArrayRef<WindowFrameType> frames);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"window"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  StringAttr getName() const;
  mlir::Type getInto() const;
  ::llvm::ArrayRef<WindowFrameType> getFrames() const;
};
namespace detail {
struct WindowFrameTypeStorage;
} // namespace detail
class WindowFrameType : public ::mlir::Type::TypeBase<WindowFrameType, ::mlir::Type, detail::WindowFrameTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "esi.window.frame";
  static WindowFrameType get(::mlir::MLIRContext *context, StringAttr name, ::llvm::ArrayRef<WindowFieldType> members);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"window.frame"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  StringAttr getName() const;
  ::llvm::ArrayRef<WindowFieldType> getMembers() const;
};
namespace detail {
struct WindowFieldTypeStorage;
} // namespace detail
class WindowFieldType : public ::mlir::Type::TypeBase<WindowFieldType, ::mlir::Type, detail::WindowFieldTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "esi.window.field";
  static WindowFieldType get(::mlir::MLIRContext *context, StringAttr fieldName, uint64_t numItems);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"window.field"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  StringAttr getFieldName() const;
  uint64_t getNumItems() const;
};
class AnyType : public ::mlir::Type::TypeBase<AnyType, ::mlir::Type, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static AnyType get(MLIRContext *context);
  static constexpr ::llvm::StringLiteral name = "esi.any";
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"any"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
};
} // namespace esi
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::ListType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::ChannelType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::ChannelBundleType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::WindowType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::WindowFrameType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::WindowFieldType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::esi::AnyType)

#endif  // GET_TYPEDEF_CLASSES

