/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: Ibis.td                                                              *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace ibis {
// Ibis port direction
enum class Direction : uint32_t {
  Input = 0,
  Output = 1,
};

::std::optional<Direction> symbolizeDirection(uint32_t);
::llvm::StringRef stringifyDirection(Direction);
::std::optional<Direction> symbolizeDirection(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForDirection() {
  return 1;
}


inline ::llvm::StringRef stringifyEnum(Direction enumValue) {
  return stringifyDirection(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<Direction> symbolizeEnum<Direction>(::llvm::StringRef str) {
  return symbolizeDirection(str);
}

class DirectionAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = Direction;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static DirectionAttr get(::mlir::MLIRContext *context, Direction val);
  Direction getValue() const;
};
} // namespace ibis
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::circt::ibis::Direction, ::circt::ibis::Direction> {
  template <typename ParserT>
  static FailureOr<::circt::ibis::Direction> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Ibis port direction");

    // Symbolize the keyword.
    if (::std::optional<::circt::ibis::Direction> attr = ::circt::ibis::symbolizeEnum<::circt::ibis::Direction>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid Ibis port direction specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::circt::ibis::Direction value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::circt::ibis::Direction> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::circt::ibis::Direction getEmptyKey() {
    return static_cast<::circt::ibis::Direction>(StorageInfo::getEmptyKey());
  }

  static inline ::circt::ibis::Direction getTombstoneKey() {
    return static_cast<::circt::ibis::Direction>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::circt::ibis::Direction &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::circt::ibis::Direction &lhs, const ::circt::ibis::Direction &rhs) {
    return lhs == rhs;
  }
};
}

namespace circt {
namespace ibis {
// path direction
enum class PathDirection : uint32_t {
  Parent = 0,
  Child = 1,
};

::std::optional<PathDirection> symbolizePathDirection(uint32_t);
::llvm::StringRef stringifyPathDirection(PathDirection);
::std::optional<PathDirection> symbolizePathDirection(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForPathDirection() {
  return 1;
}


inline ::llvm::StringRef stringifyEnum(PathDirection enumValue) {
  return stringifyPathDirection(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<PathDirection> symbolizeEnum<PathDirection>(::llvm::StringRef str) {
  return symbolizePathDirection(str);
}

class PathDirectionAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = PathDirection;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static PathDirectionAttr get(::mlir::MLIRContext *context, PathDirection val);
  PathDirection getValue() const;
};
} // namespace ibis
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::circt::ibis::PathDirection, ::circt::ibis::PathDirection> {
  template <typename ParserT>
  static FailureOr<::circt::ibis::PathDirection> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for path direction");

    // Symbolize the keyword.
    if (::std::optional<::circt::ibis::PathDirection> attr = ::circt::ibis::symbolizeEnum<::circt::ibis::PathDirection>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid path direction specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::circt::ibis::PathDirection value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::circt::ibis::PathDirection> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::circt::ibis::PathDirection getEmptyKey() {
    return static_cast<::circt::ibis::PathDirection>(StorageInfo::getEmptyKey());
  }

  static inline ::circt::ibis::PathDirection getTombstoneKey() {
    return static_cast<::circt::ibis::PathDirection>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::circt::ibis::PathDirection &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::circt::ibis::PathDirection &lhs, const ::circt::ibis::PathDirection &rhs) {
    return lhs == rhs;
  }
};
}

