/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Definitions                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

/// Returns the result types of this block from the point of view of inside the block
llvm::SmallVector<Type> circt::ibis::BlockOpInterface::getInternalResultTypes() {
      return getImpl()->getInternalResultTypes(getImpl(), getOperation());
  }
/// Returns the type of the method.
::mlir::FunctionType circt::ibis::MethodLikeOpInterface::getFunctionType() {
      return getImpl()->getFunctionType(getImpl(), getOperation());
  }
/// Returns the name of the method.
::mlir::StringAttr circt::ibis::MethodLikeOpInterface::getMethodName() {
      return getImpl()->getMethodName(getImpl(), getOperation());
  }
/// Returns the data type of the port.
mlir::Type circt::ibis::PortOpInterface::getPortType() {
      return getImpl()->getPortType(getImpl(), getOperation());
  }
/// Returns the name of the port
mlir::StringAttr circt::ibis::PortOpInterface::getPortName() {
      return getImpl()->getPortName(getImpl(), getOperation());
  }
/// Returns the `!ibis.portref` value defined by the op
mlir::TypedValue<PortRefType> circt::ibis::PortOpInterface::getPort() {
      return getImpl()->getPort(getImpl(), getOperation());
  }
/// Returns the body of the scope
mlir::Block*circt::ibis::ScopeOpInterface::getBodyBlock() {
      return getImpl()->getBodyBlock(getImpl(), getOperation());
  }
/// Returns `%this` of the scope
mlir::TypedValue<ScopeRefType> circt::ibis::ScopeOpInterface::getThis() {
      return getImpl()->getThis(getImpl(), getOperation());
  }
/// Returns the `ThisOp` of this scope
Operation*circt::ibis::ScopeOpInterface::getThisOp() {
      return getImpl()->getThisOp(getImpl(), getOperation());
  }
/// Returns the symbol name of the scope
mlir::StringAttr circt::ibis::ScopeOpInterface::getScopeName() {
      return getImpl()->getScopeName(getImpl(), getOperation());
  }
/// Lookup an inner symbol in the scope
Operation*circt::ibis::ScopeOpInterface::lookupInnerSym(llvm::StringRef symName) {
      return getImpl()->lookupInnerSym(getImpl(), getOperation(), symName);
  }
/// Lookup a port in the scope
ibis::PortOpInterface circt::ibis::ScopeOpInterface::lookupPort(llvm::StringRef portName) {
      return getImpl()->lookupPort(getImpl(), getOperation(), portName);
  }
/// Returns the name of this symbol.
::mlir::StringAttr circt::ibis::ScopeOpInterface::getNameAttr() {
      return getImpl()->implSymbolOpInterface->getNameAttr(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Sets the name of this symbol.
void circt::ibis::ScopeOpInterface::setName(::mlir::StringAttr name) {
      return getImpl()->implSymbolOpInterface->setName(getImpl()->implSymbolOpInterface, getOperation(), name);
  }
/// Gets the visibility of this symbol.
mlir::SymbolTable::Visibility circt::ibis::ScopeOpInterface::getVisibility() {
      return getImpl()->implSymbolOpInterface->getVisibility(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Returns true if this symbol has nested visibility.
bool circt::ibis::ScopeOpInterface::isNested() {
      return getImpl()->implSymbolOpInterface->isNested(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Returns true if this symbol has private visibility.
bool circt::ibis::ScopeOpInterface::isPrivate() {
      return getImpl()->implSymbolOpInterface->isPrivate(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Returns true if this symbol has public visibility.
bool circt::ibis::ScopeOpInterface::isPublic() {
      return getImpl()->implSymbolOpInterface->isPublic(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Sets the visibility of this symbol.
void circt::ibis::ScopeOpInterface::setVisibility(mlir::SymbolTable::Visibility vis) {
      return getImpl()->implSymbolOpInterface->setVisibility(getImpl()->implSymbolOpInterface, getOperation(), vis);
  }
/// Sets the visibility of this symbol to be nested.
void circt::ibis::ScopeOpInterface::setNested() {
      return getImpl()->implSymbolOpInterface->setNested(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Sets the visibility of this symbol to be private.
void circt::ibis::ScopeOpInterface::setPrivate() {
      return getImpl()->implSymbolOpInterface->setPrivate(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Sets the visibility of this symbol to be public.
void circt::ibis::ScopeOpInterface::setPublic() {
      return getImpl()->implSymbolOpInterface->setPublic(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Get all of the uses of the current symbol that are nested within the
/// given operation 'from'.
/// Note: See mlir::SymbolTable::getSymbolUses for more details.
::std::optional<::mlir::SymbolTable::UseRange> circt::ibis::ScopeOpInterface::getSymbolUses(::mlir::Operation * from) {
      return getImpl()->implSymbolOpInterface->getSymbolUses(getImpl()->implSymbolOpInterface, getOperation(), from);
  }
/// Return if the current symbol is known to have no uses that are nested
/// within the given operation 'from'.
/// Note: See mlir::SymbolTable::symbolKnownUseEmpty for more details.
bool circt::ibis::ScopeOpInterface::symbolKnownUseEmpty(::mlir::Operation * from) {
      return getImpl()->implSymbolOpInterface->symbolKnownUseEmpty(getImpl()->implSymbolOpInterface, getOperation(), from);
  }
/// Attempt to replace all uses of the current symbol with the provided
/// symbol 'newSymbol' that are nested within the given operation 'from'.
/// Note: See mlir::SymbolTable::replaceAllSymbolUses for more details.
::mlir::LogicalResult circt::ibis::ScopeOpInterface::replaceAllSymbolUses(::mlir::StringAttr newSymbol, ::mlir::Operation * from) {
      return getImpl()->implSymbolOpInterface->replaceAllSymbolUses(getImpl()->implSymbolOpInterface, getOperation(), newSymbol, from);
  }
/// Returns true if this operation optionally defines a symbol based on the
/// presence of the symbol name.
bool circt::ibis::ScopeOpInterface::isOptionalSymbol() {
      return getImpl()->implSymbolOpInterface->isOptionalSymbol(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Returns true if this operation can be discarded if it has no remaining
/// symbol uses.
bool circt::ibis::ScopeOpInterface::canDiscardOnUseEmpty() {
      return getImpl()->implSymbolOpInterface->canDiscardOnUseEmpty(getImpl()->implSymbolOpInterface, getOperation());
  }
/// Returns true if this operation is a declaration of a symbol (as opposed
/// to a definition).
bool circt::ibis::ScopeOpInterface::isDeclaration() {
      return getImpl()->implSymbolOpInterface->isDeclaration(getImpl()->implSymbolOpInterface, getOperation());
  }
