/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: LLHD.td                                                              *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace llhd {
// allowed 64-bit signless integer cases: 0, 1, 2, 3, 4
enum class RegMode : uint64_t {
  low = 0,
  high = 1,
  rise = 2,
  fall = 3,
  both = 4,
};

::std::optional<RegMode> symbolizeRegMode(uint64_t);
::llvm::StringRef stringifyRegMode(RegMode);
::std::optional<RegMode> symbolizeRegMode(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForRegMode() {
  return 4;
}


inline ::llvm::StringRef stringifyEnum(RegMode enumValue) {
  return stringifyRegMode(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<RegMode> symbolizeEnum<RegMode>(::llvm::StringRef str) {
  return symbolizeRegMode(str);
}

class RegModeAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = RegMode;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static RegModeAttr get(::mlir::MLIRContext *context, RegMode val);
  RegMode getValue() const;
};
} // namespace llhd
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::circt::llhd::RegMode, ::circt::llhd::RegMode> {
  template <typename ParserT>
  static FailureOr<::circt::llhd::RegMode> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for allowed 64-bit signless integer cases: 0, 1, 2, 3, 4");

    // Symbolize the keyword.
    if (::std::optional<::circt::llhd::RegMode> attr = ::circt::llhd::symbolizeEnum<::circt::llhd::RegMode>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid allowed 64-bit signless integer cases: 0, 1, 2, 3, 4 specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::circt::llhd::RegMode value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::circt::llhd::RegMode> {
  using StorageInfo = ::llvm::DenseMapInfo<uint64_t>;

  static inline ::circt::llhd::RegMode getEmptyKey() {
    return static_cast<::circt::llhd::RegMode>(StorageInfo::getEmptyKey());
  }

  static inline ::circt::llhd::RegMode getTombstoneKey() {
    return static_cast<::circt::llhd::RegMode>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::circt::llhd::RegMode &val) {
    return StorageInfo::getHashValue(static_cast<uint64_t>(val));
  }

  static bool isEqual(const ::circt::llhd::RegMode &lhs, const ::circt::llhd::RegMode &rhs) {
    return lhs == rhs;
  }
};
}

