/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_EARLYCODEMOTION
#define GEN_PASS_DECL_FUNCTIONELIMINATION
#define GEN_PASS_DECL_MEMORYTOBLOCKARGUMENT
#define GEN_PASS_DECL_PROCESSLOWERING
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// EarlyCodeMotion
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EARLYCODEMOTION
#undef GEN_PASS_DECL_EARLYCODEMOTION
#endif // GEN_PASS_DECL_EARLYCODEMOTION
#ifdef GEN_PASS_DEF_EARLYCODEMOTION
namespace impl {

template <typename DerivedT>
class EarlyCodeMotionBase : public ::mlir::OperationPass<llhd::ProcOp> {
public:
  using Base = EarlyCodeMotionBase;

  EarlyCodeMotionBase() : ::mlir::OperationPass<llhd::ProcOp>(::mlir::TypeID::get<DerivedT>()) {}
  EarlyCodeMotionBase(const EarlyCodeMotionBase &other) : ::mlir::OperationPass<llhd::ProcOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-early-code-motion");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-early-code-motion"; }

  ::llvm::StringRef getDescription() const override { return "Move side-effect-free instructions and llhd.prb up in the CFG"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("EarlyCodeMotion");
  }
  ::llvm::StringRef getName() const override { return "EarlyCodeMotion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(EarlyCodeMotionBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_EARLYCODEMOTION
#endif // GEN_PASS_DEF_EARLYCODEMOTION

//===----------------------------------------------------------------------===//
// FunctionElimination
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FUNCTIONELIMINATION
#undef GEN_PASS_DECL_FUNCTIONELIMINATION
#endif // GEN_PASS_DECL_FUNCTIONELIMINATION
#ifdef GEN_PASS_DEF_FUNCTIONELIMINATION
namespace impl {

template <typename DerivedT>
class FunctionEliminationBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = FunctionEliminationBase;

  FunctionEliminationBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FunctionEliminationBase(const FunctionEliminationBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-function-elimination");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-function-elimination"; }

  ::llvm::StringRef getDescription() const override { return "Deletes all functions."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FunctionElimination");
  }
  ::llvm::StringRef getName() const override { return "FunctionElimination"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FunctionEliminationBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_FUNCTIONELIMINATION
#endif // GEN_PASS_DEF_FUNCTIONELIMINATION

//===----------------------------------------------------------------------===//
// MemoryToBlockArgument
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_MEMORYTOBLOCKARGUMENT
#undef GEN_PASS_DECL_MEMORYTOBLOCKARGUMENT
#endif // GEN_PASS_DECL_MEMORYTOBLOCKARGUMENT
#ifdef GEN_PASS_DEF_MEMORYTOBLOCKARGUMENT
namespace impl {

template <typename DerivedT>
class MemoryToBlockArgumentBase : public ::mlir::OperationPass<llhd::ProcOp> {
public:
  using Base = MemoryToBlockArgumentBase;

  MemoryToBlockArgumentBase() : ::mlir::OperationPass<llhd::ProcOp>(::mlir::TypeID::get<DerivedT>()) {}
  MemoryToBlockArgumentBase(const MemoryToBlockArgumentBase &other) : ::mlir::OperationPass<llhd::ProcOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-memory-to-block-argument");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-memory-to-block-argument"; }

  ::llvm::StringRef getDescription() const override { return "Promote memory to block arguments."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MemoryToBlockArgument");
  }
  ::llvm::StringRef getName() const override { return "MemoryToBlockArgument"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MemoryToBlockArgumentBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_MEMORYTOBLOCKARGUMENT
#endif // GEN_PASS_DEF_MEMORYTOBLOCKARGUMENT

//===----------------------------------------------------------------------===//
// ProcessLowering
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PROCESSLOWERING
#undef GEN_PASS_DECL_PROCESSLOWERING
#endif // GEN_PASS_DECL_PROCESSLOWERING
#ifdef GEN_PASS_DEF_PROCESSLOWERING
namespace impl {

template <typename DerivedT>
class ProcessLoweringBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ProcessLoweringBase;

  ProcessLoweringBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ProcessLoweringBase(const ProcessLoweringBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-process-lowering");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-process-lowering"; }

  ::llvm::StringRef getDescription() const override { return "Lowers LLHD Processes to Entities."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ProcessLowering");
  }
  ::llvm::StringRef getName() const override { return "ProcessLowering"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ProcessLoweringBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PROCESSLOWERING
#endif // GEN_PASS_DEF_PROCESSLOWERING
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// EarlyCodeMotion Registration
//===----------------------------------------------------------------------===//

inline void registerEarlyCodeMotion() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createEarlyCodeMotionPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerEarlyCodeMotionPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createEarlyCodeMotionPass();
  });
}

//===----------------------------------------------------------------------===//
// FunctionElimination Registration
//===----------------------------------------------------------------------===//

inline void registerFunctionElimination() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createFunctionEliminationPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFunctionEliminationPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createFunctionEliminationPass();
  });
}

//===----------------------------------------------------------------------===//
// MemoryToBlockArgument Registration
//===----------------------------------------------------------------------===//

inline void registerMemoryToBlockArgument() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createMemoryToBlockArgumentPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerMemoryToBlockArgumentPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createMemoryToBlockArgumentPass();
  });
}

//===----------------------------------------------------------------------===//
// ProcessLowering Registration
//===----------------------------------------------------------------------===//

inline void registerProcessLowering() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createProcessLoweringPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerProcessLoweringPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::llhd::createProcessLoweringPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerEarlyCodeMotion();
  registerFunctionElimination();
  registerMemoryToBlockArgument();
  registerProcessLowering();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class EarlyCodeMotionBase : public ::mlir::OperationPass<llhd::ProcOp> {
public:
  using Base = EarlyCodeMotionBase;

  EarlyCodeMotionBase() : ::mlir::OperationPass<llhd::ProcOp>(::mlir::TypeID::get<DerivedT>()) {}
  EarlyCodeMotionBase(const EarlyCodeMotionBase &other) : ::mlir::OperationPass<llhd::ProcOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-early-code-motion");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-early-code-motion"; }

  ::llvm::StringRef getDescription() const override { return "Move side-effect-free instructions and llhd.prb up in the CFG"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("EarlyCodeMotion");
  }
  ::llvm::StringRef getName() const override { return "EarlyCodeMotion"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(EarlyCodeMotionBase<DerivedT>)

protected:
};

template <typename DerivedT>
class FunctionEliminationBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = FunctionEliminationBase;

  FunctionEliminationBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FunctionEliminationBase(const FunctionEliminationBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-function-elimination");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-function-elimination"; }

  ::llvm::StringRef getDescription() const override { return "Deletes all functions."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FunctionElimination");
  }
  ::llvm::StringRef getName() const override { return "FunctionElimination"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FunctionEliminationBase<DerivedT>)

protected:
};

template <typename DerivedT>
class MemoryToBlockArgumentBase : public ::mlir::OperationPass<llhd::ProcOp> {
public:
  using Base = MemoryToBlockArgumentBase;

  MemoryToBlockArgumentBase() : ::mlir::OperationPass<llhd::ProcOp>(::mlir::TypeID::get<DerivedT>()) {}
  MemoryToBlockArgumentBase(const MemoryToBlockArgumentBase &other) : ::mlir::OperationPass<llhd::ProcOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-memory-to-block-argument");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-memory-to-block-argument"; }

  ::llvm::StringRef getDescription() const override { return "Promote memory to block arguments."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MemoryToBlockArgument");
  }
  ::llvm::StringRef getName() const override { return "MemoryToBlockArgument"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MemoryToBlockArgumentBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ProcessLoweringBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ProcessLoweringBase;

  ProcessLoweringBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ProcessLoweringBase(const ProcessLoweringBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("llhd-process-lowering");
  }
  ::llvm::StringRef getArgument() const override { return "llhd-process-lowering"; }

  ::llvm::StringRef getDescription() const override { return "Lowers LLHD Processes to Entities."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ProcessLowering");
  }
  ::llvm::StringRef getName() const override { return "ProcessLowering"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ProcessLoweringBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
