/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_FREEZEPATHS
#define GEN_PASS_DECL_LINKMODULES
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// FreezePaths
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FREEZEPATHS
#undef GEN_PASS_DECL_FREEZEPATHS
#endif // GEN_PASS_DECL_FREEZEPATHS
#ifdef GEN_PASS_DEF_FREEZEPATHS
namespace impl {

template <typename DerivedT>
class FreezePathsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FreezePathsBase;

  FreezePathsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FreezePathsBase(const FreezePathsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("om-freeze-paths");
  }
  ::llvm::StringRef getArgument() const override { return "om-freeze-paths"; }

  ::llvm::StringRef getDescription() const override { return "Hard code all path information"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FreezePaths");
  }
  ::llvm::StringRef getName() const override { return "FreezePaths"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FreezePathsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_FREEZEPATHS
#endif // GEN_PASS_DEF_FREEZEPATHS

//===----------------------------------------------------------------------===//
// LinkModules
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LINKMODULES
#undef GEN_PASS_DECL_LINKMODULES
#endif // GEN_PASS_DECL_LINKMODULES
#ifdef GEN_PASS_DEF_LINKMODULES
namespace impl {

template <typename DerivedT>
class LinkModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LinkModulesBase;

  LinkModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LinkModulesBase(const LinkModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("om-link-modules");
  }
  ::llvm::StringRef getArgument() const override { return "om-link-modules"; }

  ::llvm::StringRef getDescription() const override { return "Link separated OM modules into a single module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LinkModules");
  }
  ::llvm::StringRef getName() const override { return "LinkModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LinkModulesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LINKMODULES
#endif // GEN_PASS_DEF_LINKMODULES
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// FreezePaths Registration
//===----------------------------------------------------------------------===//

inline void registerFreezePaths() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::om::createFreezePathsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFreezePathsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::om::createFreezePathsPass();
  });
}

//===----------------------------------------------------------------------===//
// LinkModules Registration
//===----------------------------------------------------------------------===//

inline void registerLinkModules() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::om::createOMLinkModulesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLinkModulesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::om::createOMLinkModulesPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerFreezePaths();
  registerLinkModules();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class FreezePathsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FreezePathsBase;

  FreezePathsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FreezePathsBase(const FreezePathsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("om-freeze-paths");
  }
  ::llvm::StringRef getArgument() const override { return "om-freeze-paths"; }

  ::llvm::StringRef getDescription() const override { return "Hard code all path information"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FreezePaths");
  }
  ::llvm::StringRef getName() const override { return "FreezePaths"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FreezePathsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LinkModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LinkModulesBase;

  LinkModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LinkModulesBase(const LinkModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("om-link-modules");
  }
  ::llvm::StringRef getArgument() const override { return "om-link-modules"; }

  ::llvm::StringRef getDescription() const override { return "Link separated OM modules into a single module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LinkModules");
  }
  ::llvm::StringRef getName() const override { return "LinkModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LinkModulesBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
