/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: Pipeline.td                                                          *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::pipeline::LatencyOp,
::circt::pipeline::LatencyReturnOp,
::circt::pipeline::ReturnOp,
::circt::pipeline::ScheduledPipelineOp,
::circt::pipeline::StageOp,
::circt::pipeline::UnscheduledPipelineOp
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace pipeline {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Pipeline0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((true))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be variadic of any type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Pipeline1(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger(1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be 1-bit signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Pipeline2(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::seq::ClockType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be A type for clock-carrying wires, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Pipeline3(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger(1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be variadic of 1-bit signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() >= 1))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 32-bit signless integer attribute whose minimum value is 1";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Pipeline0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline1(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::mlir::StringAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: string attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline1(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Pipeline1(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline2(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: string array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline2(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Pipeline2(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline3(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::BoolAttr>(attr))); }))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 1-bit boolean array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline3(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Pipeline3(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline4(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))); }))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit integer array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Pipeline4(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Pipeline4(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_Pipeline0(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItems(region, 1)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with 1 blocks";
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_Pipeline1(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((true))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: any region";
  }
  return ::mlir::success();
}
} // namespace pipeline
} // namespace circt
namespace circt {
namespace pipeline {

//===----------------------------------------------------------------------===//
// ::circt::pipeline::LatencyOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
LatencyOpGenericAdaptorBase::LatencyOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("pipeline.latency", odsAttrs.getContext());
}

LatencyOpGenericAdaptorBase::LatencyOpGenericAdaptorBase(LatencyOp op) : LatencyOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> LatencyOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr LatencyOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr LatencyOpGenericAdaptorBase::getLatencyAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, LatencyOp::getLatencyAttrName(*odsOpName)));
  return attr;
}

uint32_t LatencyOpGenericAdaptorBase::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

::mlir::Region &LatencyOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange LatencyOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
LatencyOpAdaptor::LatencyOpAdaptor(LatencyOp op) : LatencyOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult LatencyOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_latency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.latency' op ""requires attribute 'latency'");
    if (namedAttrIt->getName() == LatencyOp::getLatencyAttrName(*odsOpName)) {
      tblgen_latency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (tblgen_latency && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_latency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_latency).getType().isSignlessInteger(32)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_latency).getInt() >= 1))))
    return emitError(loc, "'pipeline.latency' op ""attribute 'latency' failed to satisfy constraint: 32-bit signless integer attribute whose minimum value is 1");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> LatencyOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range LatencyOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> LatencyOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range LatencyOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range LatencyOp::getResults() {
  return getODSResults(0);
}

::mlir::Region &LatencyOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::IntegerAttr LatencyOp::getLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getLatencyAttrName()));
}

uint32_t LatencyOp::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

void LatencyOp::setLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getLatencyAttrName(), attr);
}

void LatencyOp::setLatency(uint32_t attrValue) {
  (*this)->setAttr(getLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(32), attrValue));
}

void LatencyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange results, ::mlir::IntegerAttr latency) {
  odsState.addAttribute(getLatencyAttrName(odsState.name), latency);
  (void)odsState.addRegion();
  odsState.addTypes(results);
}

void LatencyOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange results, uint32_t latency) {
  odsState.addAttribute(getLatencyAttrName(odsState.name), odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), latency));
  (void)odsState.addRegion();
  odsState.addTypes(results);
}

void LatencyOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  for (unsigned i = 0; i != 1; ++i)
    (void)odsState.addRegion();
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult LatencyOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_latency;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'latency'");
    if (namedAttrIt->getName() == getLatencyAttrName()) {
      tblgen_latency = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline0(*this, tblgen_latency, "latency")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_Pipeline0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult LatencyOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult LatencyOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::IntegerAttr latencyAttr;
  ::llvm::SmallVector<::mlir::Type, 1> resultsTypes;
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();

  if (parser.parseCustomAttributeWithFallback(latencyAttr, parser.getBuilder().getIntegerType(32))) {
    return ::mlir::failure();
  }
  if (latencyAttr) result.attributes.append("latency", latencyAttr);
  if (parser.parseArrow())
    return ::mlir::failure();
  if (parser.parseLParen())
    return ::mlir::failure();

  if (parser.parseTypeList(resultsTypes))
    return ::mlir::failure();
  if (parser.parseRParen())
    return ::mlir::failure();

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();

  ensureTerminator(*bodyRegion, parser.getBuilder(), result.location);
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(bodyRegion));
  result.addTypes(resultsTypes);
  return ::mlir::success();
}

void LatencyOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getLatencyAttr());
  _odsPrinter << ' ' << "->";
  _odsPrinter << ' ' << "(";
  _odsPrinter << getResults().getTypes();
  _odsPrinter << ")";
  _odsPrinter << ' ';

  {
    bool printTerminator = true;
    if (auto *term = getBody().empty() ? nullptr : getBody().begin()->getTerminator()) {
      printTerminator = !term->getAttrDictionary().empty() ||
                        term->getNumOperands() != 0 ||
                        term->getNumResults() != 0;
    }
    _odsPrinter.printRegion(getBody(), /*printEntryBlockArgs=*/true,
      /*printBlockTerminators=*/printTerminator);
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("latency");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace pipeline
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::pipeline::LatencyOp)

namespace circt {
namespace pipeline {

//===----------------------------------------------------------------------===//
// ::circt::pipeline::LatencyReturnOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
LatencyReturnOpGenericAdaptorBase::LatencyReturnOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("pipeline.latency.return", odsAttrs.getContext());
}

LatencyReturnOpGenericAdaptorBase::LatencyReturnOpGenericAdaptorBase(LatencyReturnOp op) : LatencyReturnOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> LatencyReturnOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr LatencyReturnOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
LatencyReturnOpAdaptor::LatencyReturnOpAdaptor(LatencyReturnOp op) : LatencyReturnOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult LatencyReturnOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> LatencyReturnOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range LatencyReturnOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range LatencyReturnOp::getInputs() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange LatencyReturnOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> LatencyReturnOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range LatencyReturnOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void LatencyReturnOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState) {
 return; 
}

void LatencyReturnOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange inputs) {
  odsState.addOperands(inputs);
}

void LatencyReturnOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult LatencyReturnOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult LatencyReturnOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult LatencyReturnOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> inputsOperands;
  ::llvm::SMLoc inputsOperandsLoc;
  (void)inputsOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> inputsTypes;

  inputsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(inputsOperands))
    return ::mlir::failure();
  if (!inputsOperands.empty()) {
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (::mlir::succeeded(parser.parseOptionalColon())) {

  if (parser.parseTypeList(inputsTypes))
    return ::mlir::failure();
  }
  if (parser.resolveOperands(inputsOperands, inputsTypes, inputsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void LatencyReturnOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (!getInputs().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << getInputs();
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  if (!getInputs().empty()) {
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getInputs().getTypes();
  }
}

} // namespace pipeline
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::pipeline::LatencyReturnOp)

namespace circt {
namespace pipeline {

//===----------------------------------------------------------------------===//
// ::circt::pipeline::ReturnOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ReturnOpGenericAdaptorBase::ReturnOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("pipeline.return", odsAttrs.getContext());
}

ReturnOpGenericAdaptorBase::ReturnOpGenericAdaptorBase(ReturnOp op) : ReturnOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ReturnOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ReturnOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
ReturnOpAdaptor::ReturnOpAdaptor(ReturnOp op) : ReturnOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ReturnOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ReturnOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ReturnOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ReturnOp::getInputs() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange ReturnOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ReturnOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ReturnOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

void ReturnOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState) {
 return; 
}

void ReturnOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange inputs) {
  odsState.addOperands(inputs);
}

void ReturnOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ReturnOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ReturnOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult ReturnOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> inputsOperands;
  ::llvm::SMLoc inputsOperandsLoc;
  (void)inputsOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> inputsTypes;

  inputsOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperandList(inputsOperands))
    return ::mlir::failure();
  if (!inputsOperands.empty()) {
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (::mlir::succeeded(parser.parseOptionalColon())) {

  if (parser.parseTypeList(inputsTypes))
    return ::mlir::failure();
  }
  if (parser.resolveOperands(inputsOperands, inputsTypes, inputsOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ReturnOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (!getInputs().empty()) {
    _odsPrinter << ' ';
    _odsPrinter << getInputs();
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  if (!getInputs().empty()) {
    _odsPrinter << ' ' << ":";
    _odsPrinter << ' ';
    _odsPrinter << getInputs().getTypes();
  }
}

} // namespace pipeline
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::pipeline::ReturnOp)

namespace circt {
namespace pipeline {

//===----------------------------------------------------------------------===//
// ::circt::pipeline::ScheduledPipelineOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ScheduledPipelineOpGenericAdaptorBase::ScheduledPipelineOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("pipeline.scheduled", odsAttrs.getContext());
}

ScheduledPipelineOpGenericAdaptorBase::ScheduledPipelineOpGenericAdaptorBase(ScheduledPipelineOp op) : ScheduledPipelineOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ScheduledPipelineOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, ScheduledPipelineOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, ScheduledPipelineOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr ScheduledPipelineOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr ScheduledPipelineOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 2, ScheduledPipelineOp::getNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > ScheduledPipelineOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr ScheduledPipelineOpGenericAdaptorBase::getInputNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, ScheduledPipelineOp::getInputNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr ScheduledPipelineOpGenericAdaptorBase::getInputNames() {
  auto attr = getInputNamesAttr();
  return attr;
}

::mlir::ArrayAttr ScheduledPipelineOpGenericAdaptorBase::getOutputNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, ScheduledPipelineOp::getOutputNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr ScheduledPipelineOpGenericAdaptorBase::getOutputNames() {
  auto attr = getOutputNamesAttr();
  return attr;
}

::mlir::ArrayAttr ScheduledPipelineOpGenericAdaptorBase::getStallabilityAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 3, odsAttrs.end() - 0, ScheduledPipelineOp::getStallabilityAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > ScheduledPipelineOpGenericAdaptorBase::getStallability() {
  auto attr = getStallabilityAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::Region &ScheduledPipelineOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange ScheduledPipelineOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
ScheduledPipelineOpAdaptor::ScheduledPipelineOpAdaptor(ScheduledPipelineOp op) : ScheduledPipelineOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ScheduledPipelineOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.scheduled' op ""requires attribute 'inputNames'");
    if (namedAttrIt->getName() == ScheduledPipelineOp::getInputNamesAttrName(*odsOpName)) {
      tblgen_inputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operandSegmentSizes;
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.scheduled' op ""requires attribute 'operandSegmentSizes'");
    if (namedAttrIt->getName() == ScheduledPipelineOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operandSegmentSizes = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == ScheduledPipelineOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_outputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.scheduled' op ""requires attribute 'outputNames'");
    if (namedAttrIt->getName() == ScheduledPipelineOp::getOutputNamesAttrName(*odsOpName)) {
      tblgen_outputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_stallability;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == ScheduledPipelineOp::getStallabilityAttrName(*odsOpName)) {
      tblgen_stallability = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operandSegmentSizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 5)
      return emitError(loc, "'pipeline.scheduled' op ""'operandSegmentSizes' attribute for specifying operand segments must have 5 "
                "elements, but got ") << numElements;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'pipeline.scheduled' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inputNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_inputNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_inputNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'pipeline.scheduled' op ""attribute 'inputNames' failed to satisfy constraint: string array attribute");

  if (tblgen_outputNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_outputNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_outputNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'pipeline.scheduled' op ""attribute 'outputNames' failed to satisfy constraint: string array attribute");

  if (tblgen_stallability && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_stallability))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_stallability), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::BoolAttr>(attr))); }))))
    return emitError(loc, "'pipeline.scheduled' op ""attribute 'stallability' failed to satisfy constraint: 1-bit boolean array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ScheduledPipelineOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range ScheduledPipelineOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range ScheduledPipelineOp::getInputs() {
  return getODSOperands(0);
}

::mlir::TypedValue<::mlir::IntegerType> ScheduledPipelineOp::getStall() {
  auto operands = getODSOperands(1);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::TypedValue<::circt::seq::ClockType> ScheduledPipelineOp::getClock() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ScheduledPipelineOp::getReset() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(3).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ScheduledPipelineOp::getGo() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::MutableOperandRange ScheduledPipelineOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange ScheduledPipelineOp::getStallMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::OpOperand &ScheduledPipelineOp::getClockMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ScheduledPipelineOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(3);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ScheduledPipelineOp::getGoMutable() {
  auto range = getODSOperandIndexAndLength(4);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> ScheduledPipelineOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true, false};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 1) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range ScheduledPipelineOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range ScheduledPipelineOp::getDataOutputs() {
  return getODSResults(0);
}

::mlir::TypedValue<::mlir::IntegerType> ScheduledPipelineOp::getDone() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

::mlir::Region &ScheduledPipelineOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::StringAttr ScheduledPipelineOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 2, getNameAttrName()));
}

::std::optional< ::llvm::StringRef > ScheduledPipelineOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr ScheduledPipelineOp::getInputNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getInputNamesAttrName()));
}

::mlir::ArrayAttr ScheduledPipelineOp::getInputNames() {
  auto attr = getInputNamesAttr();
  return attr;
}

::mlir::ArrayAttr ScheduledPipelineOp::getOutputNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getOutputNamesAttrName()));
}

::mlir::ArrayAttr ScheduledPipelineOp::getOutputNames() {
  auto attr = getOutputNamesAttr();
  return attr;
}

::mlir::ArrayAttr ScheduledPipelineOp::getStallabilityAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 3, (*this)->getAttrs().end() - 0, getStallabilityAttrName()));
}

::std::optional< ::mlir::ArrayAttr > ScheduledPipelineOp::getStallability() {
  auto attr = getStallabilityAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

void ScheduledPipelineOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void ScheduledPipelineOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void ScheduledPipelineOp::setInputNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getInputNamesAttrName(), attr);
}

void ScheduledPipelineOp::setOutputNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getOutputNamesAttrName(), attr);
}

void ScheduledPipelineOp::setStallabilityAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getStallabilityAttrName(), attr);
}

::mlir::Attribute ScheduledPipelineOp::removeNameAttr() {
return (*this)->removeAttr(getNameAttrName());
}

::mlir::Attribute ScheduledPipelineOp::removeStallabilityAttr() {
return (*this)->removeAttr(getStallabilityAttrName());
}

::mlir::LogicalResult ScheduledPipelineOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'inputNames'");
    if (namedAttrIt->getName() == getInputNamesAttrName()) {
      tblgen_inputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operandSegmentSizes;
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operandSegmentSizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operandSegmentSizes = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_outputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'outputNames'");
    if (namedAttrIt->getName() == getOutputNamesAttrName()) {
      tblgen_outputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_stallability;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getStallabilityAttrName()) {
      tblgen_stallability = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operandSegmentSizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 5)
      return emitOpError("'operandSegmentSizes' attribute for specifying operand segments must have 5 "
                "elements, but got ") << numElements;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline1(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline2(*this, tblgen_inputNames, "inputNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline2(*this, tblgen_outputNames, "outputNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline3(*this, tblgen_stallability, "stallability")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    if (valueGroup1.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup1.size();
    }

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_Pipeline1(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult ScheduledPipelineOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void ScheduledPipelineOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace pipeline
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::pipeline::ScheduledPipelineOp)

namespace circt {
namespace pipeline {

//===----------------------------------------------------------------------===//
// ::circt::pipeline::StageOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
StageOpGenericAdaptorBase::StageOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("pipeline.stage", odsAttrs.getContext());
}

StageOpGenericAdaptorBase::StageOpGenericAdaptorBase(StageOp op) : StageOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> StageOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, StageOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, StageOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr StageOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::ArrayAttr StageOpGenericAdaptorBase::getClockGatesPerRegisterAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, StageOp::getClockGatesPerRegisterAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr StageOpGenericAdaptorBase::getClockGatesPerRegister() {
  auto attr = getClockGatesPerRegisterAttr();
  return attr;
}

::mlir::ArrayAttr StageOpGenericAdaptorBase::getRegisterNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, StageOp::getRegisterNamesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > StageOpGenericAdaptorBase::getRegisterNames() {
  auto attr = getRegisterNamesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr StageOpGenericAdaptorBase::getPassthroughNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, StageOp::getPassthroughNamesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > StageOpGenericAdaptorBase::getPassthroughNames() {
  auto attr = getPassthroughNamesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

} // namespace detail
StageOpAdaptor::StageOpAdaptor(StageOp op) : StageOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult StageOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clockGatesPerRegister;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.stage' op ""requires attribute 'clockGatesPerRegister'");
    if (namedAttrIt->getName() == StageOp::getClockGatesPerRegisterAttrName(*odsOpName)) {
      tblgen_clockGatesPerRegister = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operandSegmentSizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.stage' op ""requires attribute 'operandSegmentSizes'");
    if (namedAttrIt->getName() == StageOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operandSegmentSizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_passthroughNames;
  ::mlir::Attribute tblgen_registerNames;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == StageOp::getPassthroughNamesAttrName(*odsOpName)) {
      tblgen_passthroughNames = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == StageOp::getRegisterNamesAttrName(*odsOpName)) {
      tblgen_registerNames = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operandSegmentSizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 3)
      return emitError(loc, "'pipeline.stage' op ""'operandSegmentSizes' attribute for specifying operand segments must have 3 "
                "elements, but got ") << numElements;
  }

  if (tblgen_clockGatesPerRegister && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_clockGatesPerRegister))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_clockGatesPerRegister), [&](::mlir::Attribute attr) { return attr && (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))); }))))
    return emitError(loc, "'pipeline.stage' op ""attribute 'clockGatesPerRegister' failed to satisfy constraint: 64-bit integer array attribute");

  if (tblgen_registerNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_registerNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_registerNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'pipeline.stage' op ""attribute 'registerNames' failed to satisfy constraint: string array attribute");

  if (tblgen_passthroughNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_passthroughNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_passthroughNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'pipeline.stage' op ""attribute 'passthroughNames' failed to satisfy constraint: string array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> StageOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range StageOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range StageOp::getRegisters() {
  return getODSOperands(0);
}

::mlir::Operation::operand_range StageOp::getPassthroughs() {
  return getODSOperands(1);
}

::mlir::Operation::operand_range StageOp::getClockGates() {
  return getODSOperands(2);
}

::mlir::MutableOperandRange StageOp::getRegistersMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange StageOp::getPassthroughsMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange StageOp::getClockGatesMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(2u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

std::pair<unsigned, unsigned> StageOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range StageOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Block *StageOp::getNextStage() {
  return (*this)->getSuccessor(0);
}

::mlir::ArrayAttr StageOp::getClockGatesPerRegisterAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getClockGatesPerRegisterAttrName()));
}

::mlir::ArrayAttr StageOp::getClockGatesPerRegister() {
  auto attr = getClockGatesPerRegisterAttr();
  return attr;
}

::mlir::ArrayAttr StageOp::getRegisterNamesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getRegisterNamesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > StageOp::getRegisterNames() {
  auto attr = getRegisterNamesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr StageOp::getPassthroughNamesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getPassthroughNamesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > StageOp::getPassthroughNames() {
  auto attr = getPassthroughNamesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

void StageOp::setClockGatesPerRegisterAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getClockGatesPerRegisterAttrName(), attr);
}

void StageOp::setRegisterNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getRegisterNamesAttrName(), attr);
}

void StageOp::setPassthroughNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getPassthroughNamesAttrName(), attr);
}

::mlir::Attribute StageOp::removeRegisterNamesAttr() {
return (*this)->removeAttr(getRegisterNamesAttrName());
}

::mlir::Attribute StageOp::removePassthroughNamesAttr() {
return (*this)->removeAttr(getPassthroughNamesAttrName());
}

::mlir::LogicalResult StageOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_clockGatesPerRegister;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'clockGatesPerRegister'");
    if (namedAttrIt->getName() == getClockGatesPerRegisterAttrName()) {
      tblgen_clockGatesPerRegister = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operandSegmentSizes;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operandSegmentSizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operandSegmentSizes = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_passthroughNames;
  ::mlir::Attribute tblgen_registerNames;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getPassthroughNamesAttrName()) {
      tblgen_passthroughNames = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getRegisterNamesAttrName()) {
      tblgen_registerNames = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operandSegmentSizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 3)
      return emitOpError("'operandSegmentSizes' attribute for specifying operand segments must have 3 "
                "elements, but got ") << numElements;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline4(*this, tblgen_clockGatesPerRegister, "clockGatesPerRegister")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline2(*this, tblgen_registerNames, "registerNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline2(*this, tblgen_passthroughNames, "passthroughNames")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
  }
  return ::mlir::success();
}

::mlir::LogicalResult StageOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult StageOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::Block *nextStageSuccessor = nullptr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> registersOperands;
  ::llvm::SMLoc registersOperandsLoc;
  (void)registersOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> registersTypes;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> clockGatesOperands;
  ::llvm::SMLoc clockGatesOperandsLoc;
  (void)clockGatesOperandsLoc;
  ::mlir::ArrayAttr clockGatesPerRegisterAttr;
  ::mlir::ArrayAttr registerNamesAttr;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> passthroughsOperands;
  ::llvm::SMLoc passthroughsOperandsLoc;
  (void)passthroughsOperandsLoc;
  ::llvm::SmallVector<::mlir::Type, 1> passthroughsTypes;
  ::mlir::ArrayAttr passthroughNamesAttr;

  if (parser.parseSuccessor(nextStageSuccessor))
    return ::mlir::failure();
  {
    registersOperandsLoc = parser.getCurrentLocation();
    clockGatesOperandsLoc = parser.getCurrentLocation();
    auto odsResult = parseStageRegisters(parser, registersOperands, registersTypes, clockGatesOperands, clockGatesPerRegisterAttr, registerNamesAttr);
    if (odsResult) return ::mlir::failure();
    result.addAttribute("clockGatesPerRegister", clockGatesPerRegisterAttr);
    if (registerNamesAttr)
      result.addAttribute("registerNames", registerNamesAttr);
  }
  {
    passthroughsOperandsLoc = parser.getCurrentLocation();
    auto odsResult = parsePassthroughs(parser, passthroughsOperands, passthroughsTypes, passthroughNamesAttr);
    if (odsResult) return ::mlir::failure();
    if (passthroughNamesAttr)
      result.addAttribute("passthroughNames", passthroughNamesAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addSuccessors(nextStageSuccessor);
  result.addAttribute("operandSegmentSizes", parser.getBuilder().getDenseI32ArrayAttr({static_cast<int32_t>(registersOperands.size()), static_cast<int32_t>(passthroughsOperands.size()), static_cast<int32_t>(clockGatesOperands.size())}));
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  if (parser.resolveOperands(registersOperands, registersTypes, registersOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(passthroughsOperands, passthroughsTypes, passthroughsOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clockGatesOperands, odsBuildableType0, clockGatesOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void StageOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getNextStage();
  _odsPrinter << ' ';
  printStageRegisters(_odsPrinter, *this, getRegisters(), getRegisters().getTypes(), getClockGates(), getClockGatesPerRegisterAttr(), getRegisterNamesAttr());
  _odsPrinter << ' ';
  printPassthroughs(_odsPrinter, *this, getPassthroughs(), getPassthroughs().getTypes(), getPassthroughNamesAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operandSegmentSizes");
  elidedAttrs.push_back("clockGatesPerRegister");
  elidedAttrs.push_back("registerNames");
  elidedAttrs.push_back("passthroughNames");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void StageOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace pipeline
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::pipeline::StageOp)

namespace circt {
namespace pipeline {

//===----------------------------------------------------------------------===//
// ::circt::pipeline::UnscheduledPipelineOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
UnscheduledPipelineOpGenericAdaptorBase::UnscheduledPipelineOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("pipeline.unscheduled", odsAttrs.getContext());
}

UnscheduledPipelineOpGenericAdaptorBase::UnscheduledPipelineOpGenericAdaptorBase(UnscheduledPipelineOp op) : UnscheduledPipelineOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> UnscheduledPipelineOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  assert(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, UnscheduledPipelineOp::getOperandSegmentSizesAttrName(*odsOpName)) && "missing segment size attribute for op");
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 1, UnscheduledPipelineOp::getOperandSegmentSizesAttrName(*odsOpName)));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr UnscheduledPipelineOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr UnscheduledPipelineOpGenericAdaptorBase::getNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 2, UnscheduledPipelineOp::getNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > UnscheduledPipelineOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr UnscheduledPipelineOpGenericAdaptorBase::getInputNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 2, UnscheduledPipelineOp::getInputNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr UnscheduledPipelineOpGenericAdaptorBase::getInputNames() {
  auto attr = getInputNamesAttr();
  return attr;
}

::mlir::ArrayAttr UnscheduledPipelineOpGenericAdaptorBase::getOutputNamesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 2, odsAttrs.end() - 0, UnscheduledPipelineOp::getOutputNamesAttrName(*odsOpName)));
  return attr;
}

::mlir::ArrayAttr UnscheduledPipelineOpGenericAdaptorBase::getOutputNames() {
  auto attr = getOutputNamesAttr();
  return attr;
}

::mlir::Region &UnscheduledPipelineOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange UnscheduledPipelineOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
UnscheduledPipelineOpAdaptor::UnscheduledPipelineOpAdaptor(UnscheduledPipelineOp op) : UnscheduledPipelineOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult UnscheduledPipelineOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.unscheduled' op ""requires attribute 'inputNames'");
    if (namedAttrIt->getName() == UnscheduledPipelineOp::getInputNamesAttrName(*odsOpName)) {
      tblgen_inputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operandSegmentSizes;
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.unscheduled' op ""requires attribute 'operandSegmentSizes'");
    if (namedAttrIt->getName() == UnscheduledPipelineOp::getOperandSegmentSizesAttrName(*odsOpName)) {
      tblgen_operandSegmentSizes = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == UnscheduledPipelineOp::getNameAttrName(*odsOpName)) {
      tblgen_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_outputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'pipeline.unscheduled' op ""requires attribute 'outputNames'");
    if (namedAttrIt->getName() == UnscheduledPipelineOp::getOutputNamesAttrName(*odsOpName)) {
      tblgen_outputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operandSegmentSizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 5)
      return emitError(loc, "'pipeline.unscheduled' op ""'operandSegmentSizes' attribute for specifying operand segments must have 5 "
                "elements, but got ") << numElements;
  }

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'pipeline.unscheduled' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inputNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_inputNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_inputNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'pipeline.unscheduled' op ""attribute 'inputNames' failed to satisfy constraint: string array attribute");

  if (tblgen_outputNames && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_outputNames))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_outputNames), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::mlir::StringAttr>(attr))); }))))
    return emitError(loc, "'pipeline.unscheduled' op ""attribute 'outputNames' failed to satisfy constraint: string array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> UnscheduledPipelineOp::getODSOperandIndexAndLength(unsigned index) {
  auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getOperandSegmentSizesAttrName()));

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range UnscheduledPipelineOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range UnscheduledPipelineOp::getInputs() {
  return getODSOperands(0);
}

::mlir::TypedValue<::mlir::IntegerType> UnscheduledPipelineOp::getStall() {
  auto operands = getODSOperands(1);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::TypedValue<::circt::seq::ClockType> UnscheduledPipelineOp::getClock() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> UnscheduledPipelineOp::getReset() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(3).begin());
}

::mlir::TypedValue<::mlir::IntegerType> UnscheduledPipelineOp::getGo() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::MutableOperandRange UnscheduledPipelineOp::getInputsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(0u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::MutableOperandRange UnscheduledPipelineOp::getStallMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, *::mlir::impl::getNamedAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 1, getOperandSegmentSizesAttrName())));
  return mutableRange;
}

::mlir::OpOperand &UnscheduledPipelineOp::getClockMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &UnscheduledPipelineOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(3);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &UnscheduledPipelineOp::getGoMutable() {
  auto range = getODSOperandIndexAndLength(4);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> UnscheduledPipelineOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true, false};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 1) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range UnscheduledPipelineOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range UnscheduledPipelineOp::getDataOutputs() {
  return getODSResults(0);
}

::mlir::TypedValue<::mlir::IntegerType> UnscheduledPipelineOp::getDone() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

::mlir::Region &UnscheduledPipelineOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::StringAttr UnscheduledPipelineOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 2, getNameAttrName()));
}

::std::optional< ::llvm::StringRef > UnscheduledPipelineOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr UnscheduledPipelineOp::getInputNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 2, getInputNamesAttrName()));
}

::mlir::ArrayAttr UnscheduledPipelineOp::getInputNames() {
  auto attr = getInputNamesAttr();
  return attr;
}

::mlir::ArrayAttr UnscheduledPipelineOp::getOutputNamesAttr() {
  return ::llvm::cast<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 2, (*this)->getAttrs().end() - 0, getOutputNamesAttrName()));
}

::mlir::ArrayAttr UnscheduledPipelineOp::getOutputNames() {
  auto attr = getOutputNamesAttr();
  return attr;
}

void UnscheduledPipelineOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void UnscheduledPipelineOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void UnscheduledPipelineOp::setInputNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getInputNamesAttrName(), attr);
}

void UnscheduledPipelineOp::setOutputNamesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getOutputNamesAttrName(), attr);
}

::mlir::Attribute UnscheduledPipelineOp::removeNameAttr() {
return (*this)->removeAttr(getNameAttrName());
}

::mlir::LogicalResult UnscheduledPipelineOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_inputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'inputNames'");
    if (namedAttrIt->getName() == getInputNamesAttrName()) {
      tblgen_inputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_operandSegmentSizes;
  ::mlir::Attribute tblgen_name;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'operandSegmentSizes'");
    if (namedAttrIt->getName() == getOperandSegmentSizesAttrName()) {
      tblgen_operandSegmentSizes = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getNameAttrName()) {
      tblgen_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_outputNames;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'outputNames'");
    if (namedAttrIt->getName() == getOutputNamesAttrName()) {
      tblgen_outputNames = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }

  {
    auto sizeAttr = ::llvm::cast<::mlir::DenseI32ArrayAttr>(tblgen_operandSegmentSizes);
    auto numElements = sizeAttr.asArrayRef().size();
    if (numElements != 5)
      return emitOpError("'operandSegmentSizes' attribute for specifying operand segments must have 5 "
                "elements, but got ") << numElements;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline1(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline2(*this, tblgen_inputNames, "inputNames")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Pipeline2(*this, tblgen_outputNames, "outputNames")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    if (valueGroup1.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup1.size();
    }

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Pipeline1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_Pipeline0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult UnscheduledPipelineOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void UnscheduledPipelineOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace pipeline
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::pipeline::UnscheduledPipelineOp)


#endif  // GET_OP_CLASSES

