/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: SSP.td                                                               *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::ssp::DependenceGraphOp,
::circt::ssp::InstanceOp,
::circt::ssp::OperationOp,
::circt::ssp::OperatorLibraryOp,
::circt::ssp::OperatorTypeOp
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace ssp {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_SSP0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::mlir::NoneType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be variadic of none type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_SSP0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::mlir::StringAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: string attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_SSP0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_SSP0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_SSP1(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::mlir::ArrayAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_SSP1(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_SSP1(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_SSP2(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::ArrayAttr>(attr))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(attr), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::circt::ssp::DependenceAttr>(attr))); }))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: dependence array attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_SSP2(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_SSP2(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_region_constraint_SSP0(
    ::mlir::Operation *op, ::mlir::Region &region, ::llvm::StringRef regionName,
    unsigned regionIndex) {
  if (!((::llvm::hasNItems(region, 1)))) {
    return op->emitOpError("region #") << regionIndex
        << (regionName.empty() ? " " : " ('" + regionName + "') ")
        << "failed to verify constraint: region with 1 blocks";
  }
  return ::mlir::success();
}
} // namespace ssp
} // namespace circt
namespace circt {
namespace ssp {

//===----------------------------------------------------------------------===//
// ::circt::ssp::DependenceGraphOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
DependenceGraphOpGenericAdaptorBase::DependenceGraphOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("ssp.graph", odsAttrs.getContext());
}

DependenceGraphOpGenericAdaptorBase::DependenceGraphOpGenericAdaptorBase(DependenceGraphOp op) : DependenceGraphOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> DependenceGraphOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr DependenceGraphOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::Region &DependenceGraphOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange DependenceGraphOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
DependenceGraphOpAdaptor::DependenceGraphOpAdaptor(DependenceGraphOp op) : DependenceGraphOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult DependenceGraphOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> DependenceGraphOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range DependenceGraphOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> DependenceGraphOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range DependenceGraphOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &DependenceGraphOp::getBody() {
  return (*this)->getRegion(0);
}

void DependenceGraphOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState) {
      ::mlir::Region* region = odsState.addRegion();
      region->push_back(new ::mlir::Block());
    
}

::mlir::LogicalResult DependenceGraphOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_SSP0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult DependenceGraphOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult DependenceGraphOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();

  if (bodyRegion->empty()) bodyRegion->emplaceBlock();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(bodyRegion));
  return ::mlir::success();
}

void DependenceGraphOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getBody());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace ssp
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::ssp::DependenceGraphOp)

namespace circt {
namespace ssp {

//===----------------------------------------------------------------------===//
// ::circt::ssp::InstanceOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
InstanceOpGenericAdaptorBase::InstanceOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("ssp.instance", odsAttrs.getContext());
}

InstanceOpGenericAdaptorBase::InstanceOpGenericAdaptorBase(InstanceOp op) : InstanceOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> InstanceOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr InstanceOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr InstanceOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, InstanceOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > InstanceOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr InstanceOpGenericAdaptorBase::getProblemNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, InstanceOp::getProblemNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef InstanceOpGenericAdaptorBase::getProblemName() {
  auto attr = getProblemNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr InstanceOpGenericAdaptorBase::getSspPropertiesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 1, odsAttrs.end() - 0, InstanceOp::getSspPropertiesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > InstanceOpGenericAdaptorBase::getSspProperties() {
  auto attr = getSspPropertiesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::Region &InstanceOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange InstanceOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
InstanceOpAdaptor::InstanceOpAdaptor(InstanceOp op) : InstanceOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult InstanceOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_problemName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'ssp.instance' op ""requires attribute 'problemName'");
    if (namedAttrIt->getName() == InstanceOp::getProblemNameAttrName(*odsOpName)) {
      tblgen_problemName = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sspProperties;
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == InstanceOp::getSspPropertiesAttrName(*odsOpName)) {
      tblgen_sspProperties = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == InstanceOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'ssp.instance' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_problemName && !((::llvm::isa<::mlir::StringAttr>(tblgen_problemName))))
    return emitError(loc, "'ssp.instance' op ""attribute 'problemName' failed to satisfy constraint: string attribute");

  if (tblgen_sspProperties && !((::llvm::isa<::mlir::ArrayAttr>(tblgen_sspProperties))))
    return emitError(loc, "'ssp.instance' op ""attribute 'sspProperties' failed to satisfy constraint: array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> InstanceOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range InstanceOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> InstanceOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range InstanceOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &InstanceOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::StringAttr InstanceOp::getSymNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::std::optional< ::llvm::StringRef > InstanceOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::StringAttr InstanceOp::getProblemNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getProblemNameAttrName()));
}

::llvm::StringRef InstanceOp::getProblemName() {
  auto attr = getProblemNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr InstanceOp::getSspPropertiesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 1, (*this)->getAttrs().end() - 0, getSspPropertiesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > InstanceOp::getSspProperties() {
  auto attr = getSspPropertiesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

void InstanceOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void InstanceOp::setSymName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSymNameAttrName());
}

void InstanceOp::setProblemNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getProblemNameAttrName(), attr);
}

void InstanceOp::setProblemName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getProblemNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void InstanceOp::setSspPropertiesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getSspPropertiesAttrName(), attr);
}

::mlir::Attribute InstanceOp::removeSymNameAttr() {
return (*this)->removeAttr(getSymNameAttrName());
}

::mlir::Attribute InstanceOp::removeSspPropertiesAttr() {
return (*this)->removeAttr(getSspPropertiesAttrName());
}

void InstanceOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr problemName, ::mlir::ArrayAttr sspProperties) {
      odsState.addAttribute(odsBuilder.getStringAttr("problemName"), problemName);
      if (sspProperties)
        odsState.addAttribute(odsBuilder.getStringAttr("sspProperties"), sspProperties);
      ::mlir::Region* region = odsState.addRegion();
      region->push_back(new ::mlir::Block());
    
}

::mlir::LogicalResult InstanceOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_problemName;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'problemName'");
    if (namedAttrIt->getName() == getProblemNameAttrName()) {
      tblgen_problemName = namedAttrIt->getValue();
      break;
    }
    ++namedAttrIt;
  }
  ::mlir::Attribute tblgen_sspProperties;
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getSspPropertiesAttrName()) {
      tblgen_sspProperties = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP0(*this, tblgen_problemName, "problemName")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP1(*this, tblgen_sspProperties, "sspProperties")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_SSP0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult InstanceOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult InstanceOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::StringAttr problemNameAttr;
  ::mlir::ArrayAttr sspPropertiesAttr;
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();

  // Parsing an optional symbol name doesn't fail, so no need to check the
  // result.
  (void)parser.parseOptionalSymbolName(sym_nameAttr);
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  if (sym_nameAttr) {
  }
  if (parser.parseKeyword("of"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(problemNameAttr, parser.getBuilder().getType<::mlir::NoneType>())) {
    return ::mlir::failure();
  }
  if (problemNameAttr) result.attributes.append("problemName", problemNameAttr);
  {
    auto odsResult = parseSSPProperties(parser, sspPropertiesAttr);
    if (odsResult) return ::mlir::failure();
    if (sspPropertiesAttr)
      result.addAttribute("sspProperties", sspPropertiesAttr);
  }

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();

  if (bodyRegion->empty()) bodyRegion->emplaceBlock();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(bodyRegion));
  return ::mlir::success();
}

void InstanceOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getSymNameAttr()) {
    _odsPrinter << ' ';
    _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  }
  _odsPrinter << ' ' << "of";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getProblemNameAttr());
  _odsPrinter << ' ';
  printSSPProperties(_odsPrinter, *this, getSspPropertiesAttr());
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getBody());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("problemName");
  elidedAttrs.push_back("sspProperties");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace ssp
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::ssp::InstanceOp)

namespace circt {
namespace ssp {

//===----------------------------------------------------------------------===//
// ::circt::ssp::OperationOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
OperationOpGenericAdaptorBase::OperationOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("ssp.operation", odsAttrs.getContext());
}

OperationOpGenericAdaptorBase::OperationOpGenericAdaptorBase(OperationOp op) : OperationOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> OperationOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr OperationOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr OperationOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, OperationOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > OperationOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr OperationOpGenericAdaptorBase::getDependencesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, OperationOp::getDependencesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > OperationOpGenericAdaptorBase::getDependences() {
  auto attr = getDependencesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr OperationOpGenericAdaptorBase::getSspPropertiesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, OperationOp::getSspPropertiesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > OperationOpGenericAdaptorBase::getSspProperties() {
  auto attr = getSspPropertiesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

} // namespace detail
OperationOpAdaptor::OperationOpAdaptor(OperationOp op) : OperationOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult OperationOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_dependences;
  ::mlir::Attribute tblgen_sspProperties;
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == OperationOp::getDependencesAttrName(*odsOpName)) {
      tblgen_dependences = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == OperationOp::getSspPropertiesAttrName(*odsOpName)) {
      tblgen_sspProperties = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == OperationOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'ssp.operation' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_dependences && !(((::llvm::isa<::mlir::ArrayAttr>(tblgen_dependences))) && (::llvm::all_of(::llvm::cast<::mlir::ArrayAttr>(tblgen_dependences), [&](::mlir::Attribute attr) { return attr && ((::llvm::isa<::circt::ssp::DependenceAttr>(attr))); }))))
    return emitError(loc, "'ssp.operation' op ""attribute 'dependences' failed to satisfy constraint: dependence array attribute");

  if (tblgen_sspProperties && !((::llvm::isa<::mlir::ArrayAttr>(tblgen_sspProperties))))
    return emitError(loc, "'ssp.operation' op ""attribute 'sspProperties' failed to satisfy constraint: array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> OperationOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range OperationOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::operand_range OperationOp::getOperands() {
  return getODSOperands(0);
}

::mlir::MutableOperandRange OperationOp::getOperandsMutable() {
  auto range = getODSOperandIndexAndLength(0);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> OperationOp::getODSResultIndexAndLength(unsigned index) {
  bool isVariadic[] = {true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumResults() - 0) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::result_range OperationOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Operation::result_range OperationOp::getResults() {
  return getODSResults(0);
}

::mlir::StringAttr OperationOp::getSymNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::std::optional< ::llvm::StringRef > OperationOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::ArrayAttr OperationOp::getDependencesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getDependencesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > OperationOp::getDependences() {
  auto attr = getDependencesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

::mlir::ArrayAttr OperationOp::getSspPropertiesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSspPropertiesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > OperationOp::getSspProperties() {
  auto attr = getSspPropertiesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

void OperationOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void OperationOp::setSymName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSymNameAttrName());
}

void OperationOp::setDependencesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getDependencesAttrName(), attr);
}

void OperationOp::setSspPropertiesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getSspPropertiesAttrName(), attr);
}

::mlir::Attribute OperationOp::removeSymNameAttr() {
return (*this)->removeAttr(getSymNameAttrName());
}

::mlir::Attribute OperationOp::removeDependencesAttr() {
return (*this)->removeAttr(getDependencesAttrName());
}

::mlir::Attribute OperationOp::removeSspPropertiesAttr() {
return (*this)->removeAttr(getSspPropertiesAttrName());
}

void OperationOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, unsigned numResults, ::mlir::ValueRange operands, ::mlir::StringAttr sym_name, ::mlir::ArrayAttr dependences, ::mlir::ArrayAttr sspProperties) {
      odsState.addTypes(::llvm::SmallVector<::mlir::Type>(numResults, odsBuilder.getNoneType()));
      odsState.addOperands(operands);
      if (sym_name)
        odsState.addAttribute(::mlir::SymbolTable::getSymbolAttrName(), sym_name);
      if (dependences)
        odsState.addAttribute(odsBuilder.getStringAttr("dependences"), dependences);
      if (sspProperties)
        odsState.addAttribute(odsBuilder.getStringAttr("sspProperties"), sspProperties);
    
}

::mlir::LogicalResult OperationOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_dependences;
  ::mlir::Attribute tblgen_sspProperties;
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getDependencesAttrName()) {
      tblgen_dependences = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getSspPropertiesAttrName()) {
      tblgen_sspProperties = namedAttrIt->getValue();
    }
    else if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP2(*this, tblgen_dependences, "dependences")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP1(*this, tblgen_sspProperties, "sspProperties")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_SSP0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_SSP0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult OperationOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

} // namespace ssp
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::ssp::OperationOp)

namespace circt {
namespace ssp {

//===----------------------------------------------------------------------===//
// ::circt::ssp::OperatorLibraryOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
OperatorLibraryOpGenericAdaptorBase::OperatorLibraryOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("ssp.library", odsAttrs.getContext());
}

OperatorLibraryOpGenericAdaptorBase::OperatorLibraryOpGenericAdaptorBase(OperatorLibraryOp op) : OperatorLibraryOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> OperatorLibraryOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr OperatorLibraryOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr OperatorLibraryOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, OperatorLibraryOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::llvm::StringRef > OperatorLibraryOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Region &OperatorLibraryOpGenericAdaptorBase::getBody() {
  return *odsRegions[0];
}

::mlir::RegionRange OperatorLibraryOpGenericAdaptorBase::getRegions() {
  return odsRegions;
}

} // namespace detail
OperatorLibraryOpAdaptor::OperatorLibraryOpAdaptor(OperatorLibraryOp op) : OperatorLibraryOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult OperatorLibraryOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == OperatorLibraryOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'ssp.library' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> OperatorLibraryOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range OperatorLibraryOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> OperatorLibraryOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range OperatorLibraryOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Region &OperatorLibraryOp::getBody() {
  return (*this)->getRegion(0);
}

::mlir::StringAttr OperatorLibraryOp::getSymNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::std::optional< ::llvm::StringRef > OperatorLibraryOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

void OperatorLibraryOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void OperatorLibraryOp::setSymName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getSymNameAttrName());
}

::mlir::Attribute OperatorLibraryOp::removeSymNameAttr() {
return (*this)->removeAttr(getSymNameAttrName());
}

void OperatorLibraryOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState) {
      ::mlir::Region* region = odsState.addRegion();
      region->push_back(new ::mlir::Block());
    
}

::mlir::LogicalResult OperatorLibraryOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;
  while (true) {
    if (namedAttrIt == namedAttrRange.end()) {
      break;
    }
    else if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;

    for (auto &region : ::llvm::MutableArrayRef((*this)->getRegion(0)))
      if (::mlir::failed(__mlir_ods_local_region_constraint_SSP0(*this, region, "body", index++)))
        return ::mlir::failure();
  }
  return ::mlir::success();
}

::mlir::LogicalResult OperatorLibraryOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult OperatorLibraryOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  std::unique_ptr<::mlir::Region> bodyRegion = std::make_unique<::mlir::Region>();

  // Parsing an optional symbol name doesn't fail, so no need to check the
  // result.
  (void)parser.parseOptionalSymbolName(sym_nameAttr);
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  if (sym_nameAttr) {
  }

  if (parser.parseRegion(*bodyRegion))
    return ::mlir::failure();

  if (bodyRegion->empty()) bodyRegion->emplaceBlock();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  result.addRegion(std::move(bodyRegion));
  return ::mlir::success();
}

void OperatorLibraryOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getSymNameAttr()) {
    _odsPrinter << ' ';
    _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  }
  _odsPrinter << ' ';
  _odsPrinter.printRegion(getBody());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace ssp
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::ssp::OperatorLibraryOp)

namespace circt {
namespace ssp {

//===----------------------------------------------------------------------===//
// ::circt::ssp::OperatorTypeOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
OperatorTypeOpGenericAdaptorBase::OperatorTypeOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("ssp.operator_type", odsAttrs.getContext());
}

OperatorTypeOpGenericAdaptorBase::OperatorTypeOpGenericAdaptorBase(OperatorTypeOp op) : OperatorTypeOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> OperatorTypeOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr OperatorTypeOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr OperatorTypeOpGenericAdaptorBase::getSymNameAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 0, OperatorTypeOp::getSymNameAttrName(*odsOpName)));
  return attr;
}

::llvm::StringRef OperatorTypeOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr OperatorTypeOpGenericAdaptorBase::getSspPropertiesAttr() {
  assert(odsAttrs && "no attributes when constructing adapter");
  auto attr = ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange(odsAttrs.begin() + 0, odsAttrs.end() - 1, OperatorTypeOp::getSspPropertiesAttrName(*odsOpName)));
  return attr;
}

::std::optional< ::mlir::ArrayAttr > OperatorTypeOpGenericAdaptorBase::getSspProperties() {
  auto attr = getSspPropertiesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

} // namespace detail
OperatorTypeOpAdaptor::OperatorTypeOpAdaptor(OperatorTypeOp op) : OperatorTypeOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult OperatorTypeOpAdaptor::verify(::mlir::Location loc) {
  auto namedAttrRange = odsAttrs;
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;
  ::mlir::Attribute tblgen_sspProperties;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitError(loc, "'ssp.operator_type' op ""requires attribute 'sym_name'");
    if (namedAttrIt->getName() == OperatorTypeOp::getSymNameAttrName(*odsOpName)) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == OperatorTypeOp::getSspPropertiesAttrName(*odsOpName)) {
      tblgen_sspProperties = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'ssp.operator_type' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");

  if (tblgen_sspProperties && !((::llvm::isa<::mlir::ArrayAttr>(tblgen_sspProperties))))
    return emitError(loc, "'ssp.operator_type' op ""attribute 'sspProperties' failed to satisfy constraint: array attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> OperatorTypeOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range OperatorTypeOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> OperatorTypeOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range OperatorTypeOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::StringAttr OperatorTypeOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 0, getSymNameAttrName()));
}

::llvm::StringRef OperatorTypeOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

::mlir::ArrayAttr OperatorTypeOp::getSspPropertiesAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::ArrayAttr>(::mlir::impl::getAttrFromSortedRange((*this)->getAttrs().begin() + 0, (*this)->getAttrs().end() - 1, getSspPropertiesAttrName()));
}

::std::optional< ::mlir::ArrayAttr > OperatorTypeOp::getSspProperties() {
  auto attr = getSspPropertiesAttr();
  return attr ? ::std::optional< ::mlir::ArrayAttr >(attr) : (::std::nullopt);
}

void OperatorTypeOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void OperatorTypeOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void OperatorTypeOp::setSspPropertiesAttr(::mlir::ArrayAttr attr) {
  (*this)->setAttr(getSspPropertiesAttrName(), attr);
}

::mlir::Attribute OperatorTypeOp::removeSspPropertiesAttr() {
return (*this)->removeAttr(getSspPropertiesAttrName());
}

void OperatorTypeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::StringAttr sym_name, /*optional*/::mlir::ArrayAttr sspProperties) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  if (sspProperties) {
    odsState.addAttribute(getSspPropertiesAttrName(odsState.name), sspProperties);
  }
}

void OperatorTypeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::StringAttr sym_name, /*optional*/::mlir::ArrayAttr sspProperties) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), sym_name);
  if (sspProperties) {
    odsState.addAttribute(getSspPropertiesAttrName(odsState.name), sspProperties);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void OperatorTypeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::llvm::StringRef sym_name, /*optional*/::mlir::ArrayAttr sspProperties) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  if (sspProperties) {
    odsState.addAttribute(getSspPropertiesAttrName(odsState.name), sspProperties);
  }
}

void OperatorTypeOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::llvm::StringRef sym_name, /*optional*/::mlir::ArrayAttr sspProperties) {
  odsState.addAttribute(getSymNameAttrName(odsState.name), odsBuilder.getStringAttr(sym_name));
  if (sspProperties) {
    odsState.addAttribute(getSspPropertiesAttrName(odsState.name), sspProperties);
  }
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void OperatorTypeOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult OperatorTypeOp::verifyInvariantsImpl() {
  auto namedAttrRange = (*this)->getAttrs();
  auto namedAttrIt = namedAttrRange.begin();
  ::mlir::Attribute tblgen_sym_name;
  ::mlir::Attribute tblgen_sspProperties;

  while (true) {
    if (namedAttrIt == namedAttrRange.end())
      return emitOpError("requires attribute 'sym_name'");
    if (namedAttrIt->getName() == getSymNameAttrName()) {
      tblgen_sym_name = namedAttrIt->getValue();
      break;
    }
    else if (namedAttrIt->getName() == getSspPropertiesAttrName()) {
      tblgen_sspProperties = namedAttrIt->getValue();
    }
    ++namedAttrIt;
  }

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP0(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_SSP1(*this, tblgen_sspProperties, "sspProperties")))
    return ::mlir::failure();
  return ::mlir::success();
}

::mlir::LogicalResult OperatorTypeOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult OperatorTypeOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::ArrayAttr sspPropertiesAttr;

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.attributes.append("sym_name", sym_nameAttr);
  {
    auto odsResult = parseSSPProperties(parser, sspPropertiesAttr);
    if (odsResult) return ::mlir::failure();
    if (sspPropertiesAttr)
      result.addAttribute("sspProperties", sspPropertiesAttr);
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void OperatorTypeOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  printSSPProperties(_odsPrinter, *this, getSspPropertiesAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  elidedAttrs.push_back("sspProperties");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

} // namespace ssp
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::ssp::OperatorTypeOp)


#endif  // GET_OP_CLASSES

