/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_PRINT
#define GEN_PASS_DECL_ROUNDTRIP
#define GEN_PASS_DECL_SCHEDULE
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// Print
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRINT
#undef GEN_PASS_DECL_PRINT
#endif // GEN_PASS_DECL_PRINT
#ifdef GEN_PASS_DEF_PRINT
namespace impl {

template <typename DerivedT>
class PrintBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintBase;

  PrintBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintBase(const PrintBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("ssp-print");
  }
  ::llvm::StringRef getArgument() const override { return "ssp-print"; }

  ::llvm::StringRef getDescription() const override { return "Prints all SSP instances as DOT graphs."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Print");
  }
  ::llvm::StringRef getName() const override { return "Print"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRINT
#endif // GEN_PASS_DEF_PRINT

//===----------------------------------------------------------------------===//
// Roundtrip
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROUNDTRIP
struct RoundtripOptions {
  bool checkInputConstraints = false;
  bool verifySolutionConstraints = false;
};
#undef GEN_PASS_DECL_ROUNDTRIP
#endif // GEN_PASS_DECL_ROUNDTRIP
#ifdef GEN_PASS_DEF_ROUNDTRIP
namespace impl {

template <typename DerivedT>
class RoundtripBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = RoundtripBase;

  RoundtripBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  RoundtripBase(const RoundtripBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("ssp-roundtrip");
  }
  ::llvm::StringRef getArgument() const override { return "ssp-roundtrip"; }

  ::llvm::StringRef getDescription() const override { return "Roundtrips all SSP instances via the scheduling infrastructure"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Roundtrip");
  }
  ::llvm::StringRef getName() const override { return "Roundtrip"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RoundtripBase<DerivedT>)

  RoundtripBase(const RoundtripOptions &options) : RoundtripBase() {
    checkInputConstraints = options.checkInputConstraints;
    verifySolutionConstraints = options.verifySolutionConstraints;
  }
protected:
  ::mlir::Pass::Option<bool> checkInputConstraints{*this, "check", ::llvm::cl::desc("Check the problem's input constraints."), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> verifySolutionConstraints{*this, "verify", ::llvm::cl::desc("Verify the problem's solution constraints."), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_ROUNDTRIP
#endif // GEN_PASS_DEF_ROUNDTRIP

//===----------------------------------------------------------------------===//
// Schedule
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_SCHEDULE
struct ScheduleOptions {
  std::string scheduler;
  std::string schedulerOptions;
};
#undef GEN_PASS_DECL_SCHEDULE
#endif // GEN_PASS_DECL_SCHEDULE
#ifdef GEN_PASS_DEF_SCHEDULE
namespace impl {

template <typename DerivedT>
class ScheduleBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ScheduleBase;

  ScheduleBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ScheduleBase(const ScheduleBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("ssp-schedule");
  }
  ::llvm::StringRef getArgument() const override { return "ssp-schedule"; }

  ::llvm::StringRef getDescription() const override { return "Schedules all SSP instances."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Schedule");
  }
  ::llvm::StringRef getName() const override { return "Schedule"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ScheduleBase<DerivedT>)

  ScheduleBase(const ScheduleOptions &options) : ScheduleBase() {
    scheduler = options.scheduler;
    schedulerOptions = options.schedulerOptions;
  }
protected:
  ::mlir::Pass::Option<std::string> scheduler{*this, "scheduler", ::llvm::cl::desc("Scheduling algorithm to use.")};
  ::mlir::Pass::Option<std::string> schedulerOptions{*this, "options", ::llvm::cl::desc("Scheduler-specific options.")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_SCHEDULE
#endif // GEN_PASS_DEF_SCHEDULE
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// Print Registration
//===----------------------------------------------------------------------===//

inline void registerPrint() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::ssp::createPrintPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrintPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::ssp::createPrintPass();
  });
}

//===----------------------------------------------------------------------===//
// Roundtrip Registration
//===----------------------------------------------------------------------===//

inline void registerRoundtrip() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::ssp::createRoundtripPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRoundtripPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::ssp::createRoundtripPass();
  });
}

//===----------------------------------------------------------------------===//
// Schedule Registration
//===----------------------------------------------------------------------===//

inline void registerSchedule() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::ssp::createSchedulePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerSchedulePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::ssp::createSchedulePass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerPrint();
  registerRoundtrip();
  registerSchedule();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class PrintBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintBase;

  PrintBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintBase(const PrintBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("ssp-print");
  }
  ::llvm::StringRef getArgument() const override { return "ssp-print"; }

  ::llvm::StringRef getDescription() const override { return "Prints all SSP instances as DOT graphs."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Print");
  }
  ::llvm::StringRef getName() const override { return "Print"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RoundtripBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = RoundtripBase;

  RoundtripBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  RoundtripBase(const RoundtripBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("ssp-roundtrip");
  }
  ::llvm::StringRef getArgument() const override { return "ssp-roundtrip"; }

  ::llvm::StringRef getDescription() const override { return "Roundtrips all SSP instances via the scheduling infrastructure"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Roundtrip");
  }
  ::llvm::StringRef getName() const override { return "Roundtrip"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RoundtripBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> checkInputConstraints{*this, "check", ::llvm::cl::desc("Check the problem's input constraints."), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> verifySolutionConstraints{*this, "verify", ::llvm::cl::desc("Verify the problem's solution constraints."), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class ScheduleBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ScheduleBase;

  ScheduleBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ScheduleBase(const ScheduleBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("ssp-schedule");
  }
  ::llvm::StringRef getArgument() const override { return "ssp-schedule"; }

  ::llvm::StringRef getDescription() const override { return "Schedules all SSP instances."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Schedule");
  }
  ::llvm::StringRef getName() const override { return "Schedule"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ScheduleBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> scheduler{*this, "scheduler", ::llvm::cl::desc("Scheduling algorithm to use.")};
  ::mlir::Pass::Option<std::string> schedulerOptions{*this, "options", ::llvm::cl::desc("Scheduler-specific options.")};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
