/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_HWCLEANUP
#define GEN_PASS_DECL_HWELIMINATEINOUTPORTS
#define GEN_PASS_DECL_HWEXPORTMODULEHIERARCHY
#define GEN_PASS_DECL_HWGENERATORCALLOUTPASS
#define GEN_PASS_DECL_HWLEGALIZEMODULES
#define GEN_PASS_DECL_HWSTUBEXTERNALMODULES
#define GEN_PASS_DECL_PRETTIFYVERILOG
#define GEN_PASS_DECL_SVEXTRACTTESTCODE
#define GEN_PASS_DECL_SVTRACEIVERILOG
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// HWCleanup
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWCLEANUP
struct HWCleanupOptions {
  bool mergeAlwaysBlocks = true;
};
#undef GEN_PASS_DECL_HWCLEANUP
#endif // GEN_PASS_DECL_HWCLEANUP
#ifdef GEN_PASS_DEF_HWCLEANUP
namespace impl {

template <typename DerivedT>
class HWCleanupBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = HWCleanupBase;

  HWCleanupBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWCleanupBase(const HWCleanupBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-cleanup");
  }
  ::llvm::StringRef getArgument() const override { return "hw-cleanup"; }

  ::llvm::StringRef getDescription() const override { return "Cleanup transformations for operations in hw.module bodies"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWCleanup");
  }
  ::llvm::StringRef getName() const override { return "HWCleanup"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWCleanupBase<DerivedT>)

  HWCleanupBase(const HWCleanupOptions &options) : HWCleanupBase() {
    mergeAlwaysBlocks = options.mergeAlwaysBlocks;
  }
protected:
  ::mlir::Pass::Option<bool> mergeAlwaysBlocks{*this, "merge-always-blocks", ::llvm::cl::desc("Allow always and always_ff blocks to be merged"), ::llvm::cl::init(true)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWCLEANUP
#endif // GEN_PASS_DEF_HWCLEANUP

//===----------------------------------------------------------------------===//
// HWEliminateInOutPorts
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWELIMINATEINOUTPORTS
struct HWEliminateInOutPortsOptions {
  std::string readSuffix = "_rd";
  std::string writeSuffix = "_wr";
};
#undef GEN_PASS_DECL_HWELIMINATEINOUTPORTS
#endif // GEN_PASS_DECL_HWELIMINATEINOUTPORTS
#ifdef GEN_PASS_DEF_HWELIMINATEINOUTPORTS
namespace impl {

template <typename DerivedT>
class HWEliminateInOutPortsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWEliminateInOutPortsBase;

  HWEliminateInOutPortsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWEliminateInOutPortsBase(const HWEliminateInOutPortsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-eliminate-inout-ports");
  }
  ::llvm::StringRef getArgument() const override { return "hw-eliminate-inout-ports"; }

  ::llvm::StringRef getDescription() const override { return "Raises usages of inout ports into explicit input and output ports"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWEliminateInOutPorts");
  }
  ::llvm::StringRef getName() const override { return "HWEliminateInOutPorts"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWEliminateInOutPortsBase<DerivedT>)

  HWEliminateInOutPortsBase(const HWEliminateInOutPortsOptions &options) : HWEliminateInOutPortsBase() {
    readSuffix = options.readSuffix;
    writeSuffix = options.writeSuffix;
  }
protected:
  ::mlir::Pass::Option<std::string> readSuffix{*this, "read-suffix", ::llvm::cl::desc("Suffix to be used for the port when the inout port has readers"), ::llvm::cl::init("_rd")};
  ::mlir::Pass::Option<std::string> writeSuffix{*this, "write-suffix", ::llvm::cl::desc("Suffix to be used for the port when the inout port has writers"), ::llvm::cl::init("_wr")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWELIMINATEINOUTPORTS
#endif // GEN_PASS_DEF_HWELIMINATEINOUTPORTS

//===----------------------------------------------------------------------===//
// HWExportModuleHierarchy
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWEXPORTMODULEHIERARCHY
#undef GEN_PASS_DECL_HWEXPORTMODULEHIERARCHY
#endif // GEN_PASS_DECL_HWEXPORTMODULEHIERARCHY
#ifdef GEN_PASS_DEF_HWEXPORTMODULEHIERARCHY
namespace impl {

template <typename DerivedT>
class HWExportModuleHierarchyBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWExportModuleHierarchyBase;

  HWExportModuleHierarchyBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWExportModuleHierarchyBase(const HWExportModuleHierarchyBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-export-module-hierarchy");
  }
  ::llvm::StringRef getArgument() const override { return "hw-export-module-hierarchy"; }

  ::llvm::StringRef getDescription() const override { return "Export module and instance hierarchy information"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWExportModuleHierarchy");
  }
  ::llvm::StringRef getName() const override { return "HWExportModuleHierarchy"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWExportModuleHierarchyBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWEXPORTMODULEHIERARCHY
#endif // GEN_PASS_DEF_HWEXPORTMODULEHIERARCHY

//===----------------------------------------------------------------------===//
// HWGeneratorCalloutPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWGENERATORCALLOUTPASS
struct HWGeneratorCalloutPassOptions {
  std::string schemaName;
  std::string genExecutable;
  std::string genExecArgs;
};
#undef GEN_PASS_DECL_HWGENERATORCALLOUTPASS
#endif // GEN_PASS_DECL_HWGENERATORCALLOUTPASS
#ifdef GEN_PASS_DEF_HWGENERATORCALLOUTPASS
namespace impl {

template <typename DerivedT>
class HWGeneratorCalloutPassBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = HWGeneratorCalloutPassBase;

  HWGeneratorCalloutPassBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWGeneratorCalloutPassBase(const HWGeneratorCalloutPassBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-generator-callout");
  }
  ::llvm::StringRef getArgument() const override { return "hw-generator-callout"; }

  ::llvm::StringRef getDescription() const override { return "Lower Generator Schema to external module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWGeneratorCalloutPass");
  }
  ::llvm::StringRef getName() const override { return "HWGeneratorCalloutPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWGeneratorCalloutPassBase<DerivedT>)

  HWGeneratorCalloutPassBase(const HWGeneratorCalloutPassOptions &options) : HWGeneratorCalloutPassBase() {
    schemaName = options.schemaName;
    genExecutable = options.genExecutable;
    genExecArgs = options.genExecArgs;
  }
protected:
  ::mlir::Pass::Option<std::string> schemaName{*this, "schema-name", ::llvm::cl::desc("Name of the schema to process")};
  ::mlir::Pass::Option<std::string> genExecutable{*this, "generator-executable", ::llvm::cl::desc("Generator program executable with optional full path")};
  ::mlir::Pass::Option<std::string> genExecArgs{*this, "generator-executable-arguments", ::llvm::cl::desc("Generator program arguments separated by ;")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWGENERATORCALLOUTPASS
#endif // GEN_PASS_DEF_HWGENERATORCALLOUTPASS

//===----------------------------------------------------------------------===//
// HWLegalizeModules
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWLEGALIZEMODULES
#undef GEN_PASS_DECL_HWLEGALIZEMODULES
#endif // GEN_PASS_DECL_HWLEGALIZEMODULES
#ifdef GEN_PASS_DEF_HWLEGALIZEMODULES
namespace impl {

template <typename DerivedT>
class HWLegalizeModulesBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = HWLegalizeModulesBase;

  HWLegalizeModulesBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWLegalizeModulesBase(const HWLegalizeModulesBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-legalize-modules");
  }
  ::llvm::StringRef getArgument() const override { return "hw-legalize-modules"; }

  ::llvm::StringRef getDescription() const override { return "Eliminate features marked unsupported in LoweringOptions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWLegalizeModules");
  }
  ::llvm::StringRef getName() const override { return "HWLegalizeModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWLegalizeModulesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWLEGALIZEMODULES
#endif // GEN_PASS_DEF_HWLEGALIZEMODULES

//===----------------------------------------------------------------------===//
// HWStubExternalModules
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWSTUBEXTERNALMODULES
#undef GEN_PASS_DECL_HWSTUBEXTERNALMODULES
#endif // GEN_PASS_DECL_HWSTUBEXTERNALMODULES
#ifdef GEN_PASS_DEF_HWSTUBEXTERNALMODULES
namespace impl {

template <typename DerivedT>
class HWStubExternalModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWStubExternalModulesBase;

  HWStubExternalModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWStubExternalModulesBase(const HWStubExternalModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-stub-external-modules");
  }
  ::llvm::StringRef getArgument() const override { return "hw-stub-external-modules"; }

  ::llvm::StringRef getDescription() const override { return "transform external hw modules to empty hw modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWStubExternalModules");
  }
  ::llvm::StringRef getName() const override { return "HWStubExternalModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWStubExternalModulesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWSTUBEXTERNALMODULES
#endif // GEN_PASS_DEF_HWSTUBEXTERNALMODULES

//===----------------------------------------------------------------------===//
// PrettifyVerilog
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRETTIFYVERILOG
#undef GEN_PASS_DECL_PRETTIFYVERILOG
#endif // GEN_PASS_DECL_PRETTIFYVERILOG
#ifdef GEN_PASS_DEF_PRETTIFYVERILOG
namespace impl {

template <typename DerivedT>
class PrettifyVerilogBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = PrettifyVerilogBase;

  PrettifyVerilogBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrettifyVerilogBase(const PrettifyVerilogBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("prettify-verilog");
  }
  ::llvm::StringRef getArgument() const override { return "prettify-verilog"; }

  ::llvm::StringRef getDescription() const override { return "Transformations to improve quality of ExportVerilog output"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrettifyVerilog");
  }
  ::llvm::StringRef getName() const override { return "PrettifyVerilog"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrettifyVerilogBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRETTIFYVERILOG
#endif // GEN_PASS_DEF_PRETTIFYVERILOG

//===----------------------------------------------------------------------===//
// SVExtractTestCode
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_SVEXTRACTTESTCODE
struct SVExtractTestCodeOptions {
  bool disableInstanceExtraction = false;
  bool disableRegisterExtraction = false;
  bool disableModuleInlining = false;
};
#undef GEN_PASS_DECL_SVEXTRACTTESTCODE
#endif // GEN_PASS_DECL_SVEXTRACTTESTCODE
#ifdef GEN_PASS_DEF_SVEXTRACTTESTCODE
namespace impl {

template <typename DerivedT>
class SVExtractTestCodeBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = SVExtractTestCodeBase;

  SVExtractTestCodeBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SVExtractTestCodeBase(const SVExtractTestCodeBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sv-extract-test-code");
  }
  ::llvm::StringRef getArgument() const override { return "sv-extract-test-code"; }

  ::llvm::StringRef getDescription() const override { return "Extract simulation only constructs to modules and bind"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SVExtractTestCode");
  }
  ::llvm::StringRef getName() const override { return "SVExtractTestCode"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SVExtractTestCodeBase<DerivedT>)

  SVExtractTestCodeBase(const SVExtractTestCodeOptions &options) : SVExtractTestCodeBase() {
    disableInstanceExtraction = options.disableInstanceExtraction;
    disableRegisterExtraction = options.disableRegisterExtraction;
    disableModuleInlining = options.disableModuleInlining;
  }
protected:
  ::mlir::Pass::Option<bool> disableInstanceExtraction{*this, "disable-instance-extraction", ::llvm::cl::desc("Disable extracting instances only that feed test code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> disableRegisterExtraction{*this, "disable-register-extraction", ::llvm::cl::desc("Disable extracting registers only that feed test code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> disableModuleInlining{*this, "disable-module-inlining", ::llvm::cl::desc("Disable inlining modules that only feed test code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Statistic numOpsExtracted{this, "num-ops-extracted", "Number of ops extracted"};
  ::mlir::Pass::Statistic numOpsErased{this, "num-ops-erased", "Number of ops erased"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_SVEXTRACTTESTCODE
#endif // GEN_PASS_DEF_SVEXTRACTTESTCODE

//===----------------------------------------------------------------------===//
// SVTraceIVerilog
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_SVTRACEIVERILOG
struct SVTraceIVerilogOptions {
  bool topOnly = true;
  std::string targetModuleName;
  std::string directoryName = "./";
};
#undef GEN_PASS_DECL_SVTRACEIVERILOG
#endif // GEN_PASS_DECL_SVTRACEIVERILOG
#ifdef GEN_PASS_DEF_SVTRACEIVERILOG
namespace impl {

template <typename DerivedT>
class SVTraceIVerilogBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = SVTraceIVerilogBase;

  SVTraceIVerilogBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SVTraceIVerilogBase(const SVTraceIVerilogBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sv-trace-iverilog");
  }
  ::llvm::StringRef getArgument() const override { return "sv-trace-iverilog"; }

  ::llvm::StringRef getDescription() const override { return "Add tracing to an iverilog simulated module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SVTraceIVerilog");
  }
  ::llvm::StringRef getName() const override { return "SVTraceIVerilog"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SVTraceIVerilogBase<DerivedT>)

  SVTraceIVerilogBase(const SVTraceIVerilogOptions &options) : SVTraceIVerilogBase() {
    topOnly = options.topOnly;
    targetModuleName = options.targetModuleName;
    directoryName = options.directoryName;
  }
protected:
  ::mlir::Pass::Option<bool> topOnly{*this, "top-only", ::llvm::cl::desc("If true, will only add tracing to the top-level module."), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<std::string> targetModuleName{*this, "module", ::llvm::cl::desc("Module to trace. If not provided, will trace all modules")};
  ::mlir::Pass::Option<std::string> directoryName{*this, "dir-name", ::llvm::cl::desc("Directory to emit into"), ::llvm::cl::init("./")};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_SVTRACEIVERILOG
#endif // GEN_PASS_DEF_SVTRACEIVERILOG
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// HWCleanup Registration
//===----------------------------------------------------------------------===//

inline void registerHWCleanup() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWCleanupPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWCleanupPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWCleanupPass();
  });
}

//===----------------------------------------------------------------------===//
// HWEliminateInOutPorts Registration
//===----------------------------------------------------------------------===//

inline void registerHWEliminateInOutPorts() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWEliminateInOutPortsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWEliminateInOutPortsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWEliminateInOutPortsPass();
  });
}

//===----------------------------------------------------------------------===//
// HWExportModuleHierarchy Registration
//===----------------------------------------------------------------------===//

inline void registerHWExportModuleHierarchy() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWExportModuleHierarchyPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWExportModuleHierarchyPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWExportModuleHierarchyPass();
  });
}

//===----------------------------------------------------------------------===//
// HWGeneratorCalloutPass Registration
//===----------------------------------------------------------------------===//

inline void registerHWGeneratorCalloutPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWGeneratorCalloutPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWGeneratorCalloutPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWGeneratorCalloutPass();
  });
}

//===----------------------------------------------------------------------===//
// HWLegalizeModules Registration
//===----------------------------------------------------------------------===//

inline void registerHWLegalizeModules() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWLegalizeModulesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWLegalizeModulesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWLegalizeModulesPass();
  });
}

//===----------------------------------------------------------------------===//
// HWStubExternalModules Registration
//===----------------------------------------------------------------------===//

inline void registerHWStubExternalModules() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWStubExternalModulesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWStubExternalModulesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createHWStubExternalModulesPass();
  });
}

//===----------------------------------------------------------------------===//
// PrettifyVerilog Registration
//===----------------------------------------------------------------------===//

inline void registerPrettifyVerilog() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createPrettifyVerilogPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrettifyVerilogPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createPrettifyVerilogPass();
  });
}

//===----------------------------------------------------------------------===//
// SVExtractTestCode Registration
//===----------------------------------------------------------------------===//

inline void registerSVExtractTestCode() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createSVExtractTestCodePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerSVExtractTestCodePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createSVExtractTestCodePass();
  });
}

//===----------------------------------------------------------------------===//
// SVTraceIVerilog Registration
//===----------------------------------------------------------------------===//

inline void registerSVTraceIVerilog() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createSVTraceIVerilogPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerSVTraceIVerilogPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::sv::createSVTraceIVerilogPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerHWCleanup();
  registerHWEliminateInOutPorts();
  registerHWExportModuleHierarchy();
  registerHWGeneratorCalloutPass();
  registerHWLegalizeModules();
  registerHWStubExternalModules();
  registerPrettifyVerilog();
  registerSVExtractTestCode();
  registerSVTraceIVerilog();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class HWCleanupBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = HWCleanupBase;

  HWCleanupBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWCleanupBase(const HWCleanupBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-cleanup");
  }
  ::llvm::StringRef getArgument() const override { return "hw-cleanup"; }

  ::llvm::StringRef getDescription() const override { return "Cleanup transformations for operations in hw.module bodies"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWCleanup");
  }
  ::llvm::StringRef getName() const override { return "HWCleanup"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWCleanupBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> mergeAlwaysBlocks{*this, "merge-always-blocks", ::llvm::cl::desc("Allow always and always_ff blocks to be merged"), ::llvm::cl::init(true)};
};

template <typename DerivedT>
class HWEliminateInOutPortsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWEliminateInOutPortsBase;

  HWEliminateInOutPortsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWEliminateInOutPortsBase(const HWEliminateInOutPortsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-eliminate-inout-ports");
  }
  ::llvm::StringRef getArgument() const override { return "hw-eliminate-inout-ports"; }

  ::llvm::StringRef getDescription() const override { return "Raises usages of inout ports into explicit input and output ports"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWEliminateInOutPorts");
  }
  ::llvm::StringRef getName() const override { return "HWEliminateInOutPorts"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWEliminateInOutPortsBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> readSuffix{*this, "read-suffix", ::llvm::cl::desc("Suffix to be used for the port when the inout port has readers"), ::llvm::cl::init("_rd")};
  ::mlir::Pass::Option<std::string> writeSuffix{*this, "write-suffix", ::llvm::cl::desc("Suffix to be used for the port when the inout port has writers"), ::llvm::cl::init("_wr")};
};

template <typename DerivedT>
class HWExportModuleHierarchyBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWExportModuleHierarchyBase;

  HWExportModuleHierarchyBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWExportModuleHierarchyBase(const HWExportModuleHierarchyBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-export-module-hierarchy");
  }
  ::llvm::StringRef getArgument() const override { return "hw-export-module-hierarchy"; }

  ::llvm::StringRef getDescription() const override { return "Export module and instance hierarchy information"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWExportModuleHierarchy");
  }
  ::llvm::StringRef getName() const override { return "HWExportModuleHierarchy"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWExportModuleHierarchyBase<DerivedT>)

protected:
};

template <typename DerivedT>
class HWGeneratorCalloutPassBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = HWGeneratorCalloutPassBase;

  HWGeneratorCalloutPassBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWGeneratorCalloutPassBase(const HWGeneratorCalloutPassBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-generator-callout");
  }
  ::llvm::StringRef getArgument() const override { return "hw-generator-callout"; }

  ::llvm::StringRef getDescription() const override { return "Lower Generator Schema to external module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWGeneratorCalloutPass");
  }
  ::llvm::StringRef getName() const override { return "HWGeneratorCalloutPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWGeneratorCalloutPassBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> schemaName{*this, "schema-name", ::llvm::cl::desc("Name of the schema to process")};
  ::mlir::Pass::Option<std::string> genExecutable{*this, "generator-executable", ::llvm::cl::desc("Generator program executable with optional full path")};
  ::mlir::Pass::Option<std::string> genExecArgs{*this, "generator-executable-arguments", ::llvm::cl::desc("Generator program arguments separated by ;")};
};

template <typename DerivedT>
class HWLegalizeModulesBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = HWLegalizeModulesBase;

  HWLegalizeModulesBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWLegalizeModulesBase(const HWLegalizeModulesBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-legalize-modules");
  }
  ::llvm::StringRef getArgument() const override { return "hw-legalize-modules"; }

  ::llvm::StringRef getDescription() const override { return "Eliminate features marked unsupported in LoweringOptions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWLegalizeModules");
  }
  ::llvm::StringRef getName() const override { return "HWLegalizeModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWLegalizeModulesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class HWStubExternalModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWStubExternalModulesBase;

  HWStubExternalModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWStubExternalModulesBase(const HWStubExternalModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-stub-external-modules");
  }
  ::llvm::StringRef getArgument() const override { return "hw-stub-external-modules"; }

  ::llvm::StringRef getDescription() const override { return "transform external hw modules to empty hw modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWStubExternalModules");
  }
  ::llvm::StringRef getName() const override { return "HWStubExternalModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWStubExternalModulesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class PrettifyVerilogBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = PrettifyVerilogBase;

  PrettifyVerilogBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrettifyVerilogBase(const PrettifyVerilogBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("prettify-verilog");
  }
  ::llvm::StringRef getArgument() const override { return "prettify-verilog"; }

  ::llvm::StringRef getDescription() const override { return "Transformations to improve quality of ExportVerilog output"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrettifyVerilog");
  }
  ::llvm::StringRef getName() const override { return "PrettifyVerilog"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrettifyVerilogBase<DerivedT>)

protected:
};

template <typename DerivedT>
class SVExtractTestCodeBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = SVExtractTestCodeBase;

  SVExtractTestCodeBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SVExtractTestCodeBase(const SVExtractTestCodeBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sv-extract-test-code");
  }
  ::llvm::StringRef getArgument() const override { return "sv-extract-test-code"; }

  ::llvm::StringRef getDescription() const override { return "Extract simulation only constructs to modules and bind"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SVExtractTestCode");
  }
  ::llvm::StringRef getName() const override { return "SVExtractTestCode"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SVExtractTestCodeBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> disableInstanceExtraction{*this, "disable-instance-extraction", ::llvm::cl::desc("Disable extracting instances only that feed test code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> disableRegisterExtraction{*this, "disable-register-extraction", ::llvm::cl::desc("Disable extracting registers only that feed test code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> disableModuleInlining{*this, "disable-module-inlining", ::llvm::cl::desc("Disable inlining modules that only feed test code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Statistic numOpsExtracted{this, "num-ops-extracted", "Number of ops extracted"};
  ::mlir::Pass::Statistic numOpsErased{this, "num-ops-erased", "Number of ops erased"};
};

template <typename DerivedT>
class SVTraceIVerilogBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = SVTraceIVerilogBase;

  SVTraceIVerilogBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  SVTraceIVerilogBase(const SVTraceIVerilogBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sv-trace-iverilog");
  }
  ::llvm::StringRef getArgument() const override { return "sv-trace-iverilog"; }

  ::llvm::StringRef getDescription() const override { return "Add tracing to an iverilog simulated module"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("SVTraceIVerilog");
  }
  ::llvm::StringRef getName() const override { return "SVTraceIVerilog"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(SVTraceIVerilogBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> topOnly{*this, "top-only", ::llvm::cl::desc("If true, will only add tracing to the top-level module."), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<std::string> targetModuleName{*this, "module", ::llvm::cl::desc("Module to trace. If not provided, will trace all modules")};
  ::mlir::Pass::Option<std::string> directoryName{*this, "dir-name", ::llvm::cl::desc("Directory to emit into"), ::llvm::cl::init("./")};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
