/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_EXTERNALIZECLOCKGATE
#define GEN_PASS_DECL_HWMEMSIMIMPL
#define GEN_PASS_DECL_LOWERSEQFIFO
#define GEN_PASS_DECL_LOWERSEQHLMEM
#define GEN_PASS_DECL_LOWERSEQSHIFTREG
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ExternalizeClockGate
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EXTERNALIZECLOCKGATE
struct ExternalizeClockGateOptions {
  std::string moduleName = "CKG";
  std::string inputName = "I";
  std::string outputName = "O";
  std::string enableName = "E";
  std::string testEnableName = "TE";
  std::string instName = "ckg";
};
#undef GEN_PASS_DECL_EXTERNALIZECLOCKGATE
#endif // GEN_PASS_DECL_EXTERNALIZECLOCKGATE
#ifdef GEN_PASS_DEF_EXTERNALIZECLOCKGATE
namespace impl {

template <typename DerivedT>
class ExternalizeClockGateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ExternalizeClockGateBase;

  ExternalizeClockGateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExternalizeClockGateBase(const ExternalizeClockGateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("externalize-clock-gate");
  }
  ::llvm::StringRef getArgument() const override { return "externalize-clock-gate"; }

  ::llvm::StringRef getDescription() const override { return "Convert seq.clock_gate ops into hw.module.extern instances"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExternalizeClockGate");
  }
  ::llvm::StringRef getName() const override { return "ExternalizeClockGate"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::comb::CombDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExternalizeClockGateBase<DerivedT>)

  ExternalizeClockGateBase(const ExternalizeClockGateOptions &options) : ExternalizeClockGateBase() {
    moduleName = options.moduleName;
    inputName = options.inputName;
    outputName = options.outputName;
    enableName = options.enableName;
    testEnableName = options.testEnableName;
    instName = options.instName;
  }
protected:
  ::mlir::Pass::Option<std::string> moduleName{*this, "name", ::llvm::cl::desc("Name of the external clock gate module"), ::llvm::cl::init("CKG")};
  ::mlir::Pass::Option<std::string> inputName{*this, "input", ::llvm::cl::desc("Name of the clock input"), ::llvm::cl::init("I")};
  ::mlir::Pass::Option<std::string> outputName{*this, "output", ::llvm::cl::desc("Name of the gated clock output"), ::llvm::cl::init("O")};
  ::mlir::Pass::Option<std::string> enableName{*this, "enable", ::llvm::cl::desc("Name of the enable input"), ::llvm::cl::init("E")};
  ::mlir::Pass::Option<std::string> testEnableName{*this, "test-enable", ::llvm::cl::desc("Name of the optional test enable input"), ::llvm::cl::init("TE")};
  ::mlir::Pass::Option<std::string> instName{*this, "instance-name", ::llvm::cl::desc("Name of the generated instances"), ::llvm::cl::init("ckg")};
  ::mlir::Pass::Statistic numClockGatesConverted{this, "num-clock-gates-converted", "Number of clock gates converted to external module instances"};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_EXTERNALIZECLOCKGATE
#endif // GEN_PASS_DEF_EXTERNALIZECLOCKGATE

//===----------------------------------------------------------------------===//
// HWMemSimImpl
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWMEMSIMIMPL
struct HWMemSimImplOptions {
  bool disableMemRandomization = false;
  bool disableRegRandomization = false;
  bool replSeqMem = false;
  ::circt::seq::ReadEnableMode readEnableMode = ::circt::seq::ReadEnableMode::Undefined;
  bool addMuxPragmas = false;
  bool addVivadoRAMAddressConflictSynthesisBugWorkaround = false;
};
#undef GEN_PASS_DECL_HWMEMSIMIMPL
#endif // GEN_PASS_DECL_HWMEMSIMIMPL
#ifdef GEN_PASS_DEF_HWMEMSIMIMPL
namespace impl {

template <typename DerivedT>
class HWMemSimImplBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = HWMemSimImplBase;

  HWMemSimImplBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWMemSimImplBase(const HWMemSimImplBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-memory-sim");
  }
  ::llvm::StringRef getArgument() const override { return "hw-memory-sim"; }

  ::llvm::StringRef getDescription() const override { return "Implement FIRRTMMem memories nodes with simulation model"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWMemSimImpl");
  }
  ::llvm::StringRef getName() const override { return "HWMemSimImpl"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWMemSimImplBase<DerivedT>)

  HWMemSimImplBase(const HWMemSimImplOptions &options) : HWMemSimImplBase() {
    disableMemRandomization = options.disableMemRandomization;
    disableRegRandomization = options.disableRegRandomization;
    replSeqMem = options.replSeqMem;
    readEnableMode = options.readEnableMode;
    addMuxPragmas = options.addMuxPragmas;
    addVivadoRAMAddressConflictSynthesisBugWorkaround = options.addVivadoRAMAddressConflictSynthesisBugWorkaround;
  }
protected:
  ::mlir::Pass::Option<bool> disableMemRandomization{*this, "disable-mem-randomization", ::llvm::cl::desc("Disable emission of memory randomization code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> disableRegRandomization{*this, "disable-reg-randomization", ::llvm::cl::desc("Disable emission of register randomization code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> replSeqMem{*this, "repl-seq-mem", ::llvm::cl::desc("Prepare seq mems for macro replacement"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<::circt::seq::ReadEnableMode> readEnableMode{*this, "read-enable-mode", ::llvm::cl::desc("specify the behaviour of the read enable signal"), ::llvm::cl::init(::circt::seq::ReadEnableMode::Undefined), 
              ::llvm::cl::values(
              clEnumValN(ReadEnableMode::Ignore, "ignore",
                         "Ignore the read enable signal"),
              clEnumValN(ReadEnableMode::Zero, "zero",
                         "Output zeros when reads are disabled"),
              clEnumValN(ReadEnableMode::Undefined, "undefined",
                         "Output X when reads are disbled"))
           };
  ::mlir::Pass::Option<bool> addMuxPragmas{*this, "add-mux-pragmas", ::llvm::cl::desc("Add mux pragmas to memory reads"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> addVivadoRAMAddressConflictSynthesisBugWorkaround{*this, "add-vivado-ram-address-conflict-synthesis-bug-workaround", ::llvm::cl::desc("Add a vivado attribute to specify a ram style of an array register"), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWMEMSIMIMPL
#endif // GEN_PASS_DEF_HWMEMSIMIMPL

//===----------------------------------------------------------------------===//
// LowerSeqFIFO
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQFIFO
#undef GEN_PASS_DECL_LOWERSEQFIFO
#endif // GEN_PASS_DECL_LOWERSEQFIFO
#ifdef GEN_PASS_DEF_LOWERSEQFIFO
namespace impl {

template <typename DerivedT>
class LowerSeqFIFOBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqFIFOBase;

  LowerSeqFIFOBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIFOBase(const LowerSeqFIFOBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-fifo");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-fifo"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.fifo ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIFO");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIFO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::comb::CombDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIFOBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQFIFO
#endif // GEN_PASS_DEF_LOWERSEQFIFO

//===----------------------------------------------------------------------===//
// LowerSeqHLMem
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQHLMEM
#undef GEN_PASS_DECL_LOWERSEQHLMEM
#endif // GEN_PASS_DECL_LOWERSEQHLMEM
#ifdef GEN_PASS_DEF_LOWERSEQHLMEM
namespace impl {

template <typename DerivedT>
class LowerSeqHLMemBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqHLMemBase;

  LowerSeqHLMemBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqHLMemBase(const LowerSeqHLMemBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-hlmem");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-hlmem"; }

  ::llvm::StringRef getDescription() const override { return "Lowers seq.hlmem operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqHLMem");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqHLMem"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqHLMemBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQHLMEM
#endif // GEN_PASS_DEF_LOWERSEQHLMEM

//===----------------------------------------------------------------------===//
// LowerSeqShiftReg
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERSEQSHIFTREG
#undef GEN_PASS_DECL_LOWERSEQSHIFTREG
#endif // GEN_PASS_DECL_LOWERSEQSHIFTREG
#ifdef GEN_PASS_DEF_LOWERSEQSHIFTREG
namespace impl {

template <typename DerivedT>
class LowerSeqShiftRegBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqShiftRegBase;

  LowerSeqShiftRegBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqShiftRegBase(const LowerSeqShiftRegBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-shiftreg");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-shiftreg"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.shiftreg ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqShiftReg");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqShiftReg"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqShiftRegBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LOWERSEQSHIFTREG
#endif // GEN_PASS_DEF_LOWERSEQSHIFTREG
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ExternalizeClockGate Registration
//===----------------------------------------------------------------------===//

inline void registerExternalizeClockGate() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createExternalizeClockGatePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerExternalizeClockGatePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createExternalizeClockGatePass();
  });
}

//===----------------------------------------------------------------------===//
// HWMemSimImpl Registration
//===----------------------------------------------------------------------===//

inline void registerHWMemSimImpl() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createHWMemSimImplPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWMemSimImplPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createHWMemSimImplPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqFIFO Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqFIFO() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqFIFOPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqFIFOPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqFIFOPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqHLMem Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqHLMem() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqHLMemPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqHLMemPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqHLMemPass();
  });
}

//===----------------------------------------------------------------------===//
// LowerSeqShiftReg Registration
//===----------------------------------------------------------------------===//

inline void registerLowerSeqShiftReg() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqShiftRegPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerSeqShiftRegPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::seq::createLowerSeqShiftRegPass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerExternalizeClockGate();
  registerHWMemSimImpl();
  registerLowerSeqFIFO();
  registerLowerSeqHLMem();
  registerLowerSeqShiftReg();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ExternalizeClockGateBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = ExternalizeClockGateBase;

  ExternalizeClockGateBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExternalizeClockGateBase(const ExternalizeClockGateBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("externalize-clock-gate");
  }
  ::llvm::StringRef getArgument() const override { return "externalize-clock-gate"; }

  ::llvm::StringRef getDescription() const override { return "Convert seq.clock_gate ops into hw.module.extern instances"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExternalizeClockGate");
  }
  ::llvm::StringRef getName() const override { return "ExternalizeClockGate"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::comb::CombDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExternalizeClockGateBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> moduleName{*this, "name", ::llvm::cl::desc("Name of the external clock gate module"), ::llvm::cl::init("CKG")};
  ::mlir::Pass::Option<std::string> inputName{*this, "input", ::llvm::cl::desc("Name of the clock input"), ::llvm::cl::init("I")};
  ::mlir::Pass::Option<std::string> outputName{*this, "output", ::llvm::cl::desc("Name of the gated clock output"), ::llvm::cl::init("O")};
  ::mlir::Pass::Option<std::string> enableName{*this, "enable", ::llvm::cl::desc("Name of the enable input"), ::llvm::cl::init("E")};
  ::mlir::Pass::Option<std::string> testEnableName{*this, "test-enable", ::llvm::cl::desc("Name of the optional test enable input"), ::llvm::cl::init("TE")};
  ::mlir::Pass::Option<std::string> instName{*this, "instance-name", ::llvm::cl::desc("Name of the generated instances"), ::llvm::cl::init("ckg")};
  ::mlir::Pass::Statistic numClockGatesConverted{this, "num-clock-gates-converted", "Number of clock gates converted to external module instances"};
};

template <typename DerivedT>
class HWMemSimImplBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = HWMemSimImplBase;

  HWMemSimImplBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWMemSimImplBase(const HWMemSimImplBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-memory-sim");
  }
  ::llvm::StringRef getArgument() const override { return "hw-memory-sim"; }

  ::llvm::StringRef getDescription() const override { return "Implement FIRRTMMem memories nodes with simulation model"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWMemSimImpl");
  }
  ::llvm::StringRef getName() const override { return "HWMemSimImpl"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWMemSimImplBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> disableMemRandomization{*this, "disable-mem-randomization", ::llvm::cl::desc("Disable emission of memory randomization code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> disableRegRandomization{*this, "disable-reg-randomization", ::llvm::cl::desc("Disable emission of register randomization code"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> replSeqMem{*this, "repl-seq-mem", ::llvm::cl::desc("Prepare seq mems for macro replacement"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<::circt::seq::ReadEnableMode> readEnableMode{*this, "read-enable-mode", ::llvm::cl::desc("specify the behaviour of the read enable signal"), ::llvm::cl::init(::circt::seq::ReadEnableMode::Undefined), 
              ::llvm::cl::values(
              clEnumValN(ReadEnableMode::Ignore, "ignore",
                         "Ignore the read enable signal"),
              clEnumValN(ReadEnableMode::Zero, "zero",
                         "Output zeros when reads are disabled"),
              clEnumValN(ReadEnableMode::Undefined, "undefined",
                         "Output X when reads are disbled"))
           };
  ::mlir::Pass::Option<bool> addMuxPragmas{*this, "add-mux-pragmas", ::llvm::cl::desc("Add mux pragmas to memory reads"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> addVivadoRAMAddressConflictSynthesisBugWorkaround{*this, "add-vivado-ram-address-conflict-synthesis-bug-workaround", ::llvm::cl::desc("Add a vivado attribute to specify a ram style of an array register"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class LowerSeqFIFOBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqFIFOBase;

  LowerSeqFIFOBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqFIFOBase(const LowerSeqFIFOBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-fifo");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-fifo"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.fifo ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqFIFO");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqFIFO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
    registry.insert<circt::comb::CombDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqFIFOBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerSeqHLMemBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqHLMemBase;

  LowerSeqHLMemBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqHLMemBase(const LowerSeqHLMemBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-hlmem");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-hlmem"; }

  ::llvm::StringRef getDescription() const override { return "Lowers seq.hlmem operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqHLMem");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqHLMem"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::sv::SVDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqHLMemBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerSeqShiftRegBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = LowerSeqShiftRegBase;

  LowerSeqShiftRegBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerSeqShiftRegBase(const LowerSeqShiftRegBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-seq-shiftreg");
  }
  ::llvm::StringRef getArgument() const override { return "lower-seq-shiftreg"; }

  ::llvm::StringRef getDescription() const override { return "Lower seq.shiftreg ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerSeqShiftReg");
  }
  ::llvm::StringRef getName() const override { return "LowerSeqShiftReg"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerSeqShiftRegBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
