# This file allows users to call find_package(CIRCT) and pick up our targets.


# Compute the installation prefix from this CIRCTConfig.cmake file location.
get_filename_component(CIRCT_INSTALL_PREFIX "${CMAKE_CURRENT_LIST_FILE}" PATH)
get_filename_component(CIRCT_INSTALL_PREFIX "${CIRCT_INSTALL_PREFIX}" PATH)
get_filename_component(CIRCT_INSTALL_PREFIX "${CIRCT_INSTALL_PREFIX}" PATH)
get_filename_component(CIRCT_INSTALL_PREFIX "${CIRCT_INSTALL_PREFIX}" PATH)

find_package(MLIR REQUIRED CONFIG
             HINTS "${CIRCT_INSTALL_PREFIX}/lib64/cmake/mlir")

set(CIRCT_EXPORTED_TARGETS "CIRCTDebugAnalysis;CIRCTDependenceAnalysis;CIRCTSchedulingAnalysis;CIRCTAnalysisTestPasses;CIRCTAffineToLoopSchedule;CIRCTArcToLLVM;CIRCTCalyxToFSM;CIRCTCalyxToHW;CIRCTCombToArith;CIRCTCombToLLVM;CIRCTConvertToArcs;CIRCTDCToHW;CIRCTExportChiselInterface;CIRCTExportVerilog;CIRCTFIRRTLToHW;CIRCTFSMToSV;CIRCTHandshakeToDC;CIRCTHandshakeToHW;CIRCTHWArithToHW;CIRCTHWToBTOR2;CIRCTHWToLLHD;CIRCTHWToLLVM;CIRCTHWToSV;CIRCTHWToSystemC;CIRCTLLHDToLLVM;CIRCTLoopScheduleToCalyx;CIRCTMooreToCore;CIRCTPipelineToHW;CIRCTSCFToCalyx;CIRCTSeqToSV;CIRCTSimToSV;CIRCTCFToHandshake;CIRCTVerifToSV;CIRCTCalyxNative;CIRCTArc;CIRCTArcReductions;CIRCTArcExternalInterfaces;CIRCTArcTransforms;CIRCTCalyx;CIRCTExportCalyx;CIRCTCalyxTransforms;CIRCTComb;CIRCTCombTransforms;CIRCTDC;CIRCTDCTransforms;CIRCTDebug;CIRCTESI;CIRCTFIRRTL;CIRCTFIRRTLReductions;CIRCTExportFIRRTL;CIRCTImportFIRFile;CIRCTFIRRTLTransforms;CIRCTFSM;CIRCTFSMTransforms;CIRCTHandshake;CIRCTHandshakeTransforms;CIRCTHW;CIRCTHWReductions;CIRCTHWTransforms;CIRCTHWArith;CIRCTIbis;CIRCTIbisTransforms;CIRCTInteropDialect;CIRCTLLHD;CIRCTLLHDSimState;CIRCTLLHDSimTrace;circt-llhd-signals-runtime-wrappers;CIRCTLLHDSimEngine;CIRCTLLHDTransforms;CIRCTLoopSchedule;CIRCTLTL;CIRCTMoore;CIRCTMSFT;CIRCTMSFTTransforms;CIRCTOM;CIRCTOMEvaluator;CIRCTOMTransforms;CIRCTPipelineOps;CIRCTPipelineTransforms;CIRCTSeq;CIRCTSeqTransforms;CIRCTSim;CIRCTSSP;CIRCTSSPTransforms;CIRCTSV;CIRCTSVTransforms;CIRCTSystemC;CIRCTSystemCTransforms;CIRCTVerif;CIRCTLogicalEquivalence;CIRCTFirtool;CIRCTReduceLib;CIRCTScheduling;CIRCTSupport;CIRCTTargetDebugInfo;CIRCTExportSystemC;CIRCTTransforms;arcilator;circt-as;circt-dis;circt-lec;circt-lsp-server;circt-opt;circt-reduce;circt-translate;firtool;llhd-sim;om-linker;hlstool;ibistool")
set(CIRCT_CMAKE_DIR "${CIRCT_INSTALL_PREFIX}/lib64/cmake/circt")
set(CIRCT_BINARY_DIR "${CIRCT_INSTALL_PREFIX}")
set(CIRCT_INCLUDE_DIRS "${CIRCT_INSTALL_PREFIX}/include")
set(CIRCT_LIBRARY_DIRS "${CIRCT_INSTALL_PREFIX}/lib")
set(CIRCT_TOOLS_DIR "${CIRCT_INSTALL_PREFIX}/bin")

set_property(GLOBAL PROPERTY CIRCT_ALL_LIBS "CIRCTDebugAnalysis;CIRCTDependenceAnalysis;CIRCTSchedulingAnalysis;CIRCTAnalysisTestPasses;CIRCTAffineToLoopSchedule;CIRCTArcToLLVM;CIRCTCalyxToFSM;CIRCTCalyxToHW;CIRCTCombToArith;CIRCTCombToLLVM;CIRCTConvertToArcs;CIRCTDCToHW;CIRCTExportChiselInterface;CIRCTExportVerilog;CIRCTFIRRTLToHW;CIRCTFSMToSV;CIRCTHandshakeToDC;CIRCTHandshakeToHW;CIRCTHWArithToHW;CIRCTHWToBTOR2;CIRCTHWToLLHD;CIRCTHWToLLVM;CIRCTHWToSV;CIRCTHWToSystemC;CIRCTLLHDToLLVM;CIRCTLoopScheduleToCalyx;CIRCTMooreToCore;CIRCTPipelineToHW;CIRCTSCFToCalyx;CIRCTSeqToSV;CIRCTSimToSV;CIRCTCFToHandshake;CIRCTVerifToSV;CIRCTCalyxNative;CIRCTArc;CIRCTArcReductions;CIRCTArcExternalInterfaces;CIRCTArcTransforms;CIRCTCalyx;CIRCTExportCalyx;CIRCTCalyxTransforms;CIRCTComb;CIRCTCombTransforms;CIRCTDC;CIRCTDCTransforms;CIRCTDebug;CIRCTESI;CIRCTFIRRTL;CIRCTFIRRTLReductions;CIRCTExportFIRRTL;CIRCTImportFIRFile;CIRCTFIRRTLTransforms;CIRCTFSM;CIRCTFSMTransforms;CIRCTHandshake;CIRCTHandshakeTransforms;CIRCTHW;CIRCTHWReductions;CIRCTHWTransforms;CIRCTHWArith;CIRCTIbis;CIRCTIbisTransforms;CIRCTInteropDialect;CIRCTLLHD;CIRCTLLHDSimState;CIRCTLLHDSimTrace;circt-llhd-signals-runtime-wrappers;CIRCTLLHDSimEngine;CIRCTLLHDTransforms;CIRCTLoopSchedule;CIRCTLTL;CIRCTMoore;CIRCTMSFT;CIRCTMSFTTransforms;CIRCTOM;CIRCTOMEvaluator;CIRCTOMTransforms;CIRCTPipelineOps;CIRCTPipelineTransforms;CIRCTSeq;CIRCTSeqTransforms;CIRCTSim;CIRCTSSP;CIRCTSSPTransforms;CIRCTSV;CIRCTSVTransforms;CIRCTSystemC;CIRCTSystemCTransforms;CIRCTVerif;CIRCTLogicalEquivalence;CIRCTFirtool;CIRCTReduceLib;CIRCTScheduling;CIRCTSupport;CIRCTTargetDebugInfo;CIRCTExportSystemC;CIRCTTransforms")
set_property(GLOBAL PROPERTY CIRCT_DIALECT_LIBS "CIRCTArc;CIRCTArcExternalInterfaces;CIRCTArcTransforms;CIRCTCalyx;CIRCTExportCalyx;CIRCTCalyxTransforms;CIRCTComb;CIRCTCombTransforms;CIRCTDC;CIRCTDCTransforms;CIRCTDebug;CIRCTESI;CIRCTFIRRTL;CIRCTFIRRTLTransforms;CIRCTFSM;CIRCTFSMTransforms;CIRCTHandshake;CIRCTHandshakeTransforms;CIRCTHW;CIRCTHWTransforms;CIRCTHWArith;CIRCTIbis;CIRCTIbisTransforms;CIRCTInteropDialect;CIRCTLLHD;CIRCTLLHDTransforms;CIRCTLoopSchedule;CIRCTLTL;CIRCTMoore;CIRCTMSFT;CIRCTMSFTTransforms;CIRCTOM;CIRCTOMTransforms;CIRCTPipelineOps;CIRCTPipelineTransforms;CIRCTSeq;CIRCTSeqTransforms;CIRCTSim;CIRCTSSP;CIRCTSSPTransforms;CIRCTSV;CIRCTSVTransforms;CIRCTSystemC;CIRCTSystemCTransforms;CIRCTVerif")
set_property(GLOBAL PROPERTY CIRCT_CONVERSION_LIBS "CIRCTArcToLLVM;CIRCTCombToArith;CIRCTCombToLLVM;CIRCTConvertToArcs;CIRCTFIRRTLToHW;CIRCTFSMToSV;CIRCTHWArithToHW;CIRCTHWToBTOR2;CIRCTHWToLLHD;CIRCTHWToLLVM;CIRCTHWToSV;CIRCTHWToSystemC;CIRCTLLHDToLLVM;CIRCTLoopScheduleToCalyx;CIRCTMooreToCore;CIRCTSCFToCalyx;CIRCTSeqToSV;CIRCTSimToSV;CIRCTVerifToSV")
set_property(GLOBAL PROPERTY CIRCT_TRANSLATION_LIBS "CIRCTExportChiselInterface;CIRCTExportVerilog;CIRCTExportFIRRTL;CIRCTImportFIRFile;CIRCTTargetDebugInfo;CIRCTExportSystemC")

# Provide all our library targets to users.
if(NOT TARGET CIRCTSupport)
  include("${CIRCT_CMAKE_DIR}/CIRCTTargets.cmake")
endif()

# By creating these targets here, subprojects that depend on CIRCT's
# tablegen-generated headers can always depend on these targets whether building
# in-tree with CIRCT or not.
if(NOT TARGET circt-tablegen-targets)
  add_custom_target(circt-tablegen-targets)
endif()
if(NOT TARGET circt-headers)
  add_custom_target(circt-headers)
endif()
if(NOT TARGET circt-generic-headers)
  add_custom_target(circt-generic-headers)
endif()
if(NOT TARGET circt-doc)
  add_custom_target(circt-doc)
endif()
