/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Op Definitions                                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: Seq.td                                                               *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_OP_LIST
#undef GET_OP_LIST

::circt::seq::ClockDividerOp,
::circt::seq::ClockGateOp,
::circt::seq::ClockInverterOp,
::circt::seq::ClockMuxOp,
::circt::seq::CompRegClockEnabledOp,
::circt::seq::CompRegOp,
::circt::seq::ConstClockOp,
::circt::seq::FIFOOp,
::circt::seq::FirMemOp,
::circt::seq::FirMemReadOp,
::circt::seq::FirMemReadWriteOp,
::circt::seq::FirMemWriteOp,
::circt::seq::FirRegOp,
::circt::seq::FromClockOp,
::circt::seq::HLMemOp,
::circt::seq::ReadPortOp,
::circt::seq::ShiftRegOp,
::circt::seq::ToClockOp,
::circt::seq::WritePortOp
#endif  // GET_OP_LIST

#ifdef GET_OP_CLASSES
#undef GET_OP_CLASSES


//===----------------------------------------------------------------------===//
// Local Utility Method Definitions
//===----------------------------------------------------------------------===//

namespace circt {
namespace seq {

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq0(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::seq::ClockType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be A type for clock-carrying wires, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq1(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger(1)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be 1-bit signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq2(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((true))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be any type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq3(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::circt::hw::isHWIntegerType(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be a signless integer bitvector, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq4(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be A FIRRTL-flavored memory, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq5(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((type.isSignlessInteger()))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be signless integer, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq6(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::llvm::isa<::circt::seq::HLMemType>(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be Multi-dimensional memory type, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_type_constraint_Seq7(
    ::mlir::Operation *op, ::mlir::Type type, ::llvm::StringRef valueKind,
    unsigned valueIndex) {
  if (!((::circt::hw::isHWIntegerType(type)))) {
    return op->emitOpError(valueKind) << " #" << valueIndex
        << " must be variadic of a signless integer bitvector, but got " << type;
  }
  return ::mlir::success();
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq0(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(8)))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 8-bit signless integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq0(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq0(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq1(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::circt::hw::InnerSymAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: Inner symbol definition";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq1(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq1(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq2(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::mlir::StringAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: string attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq2(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq2(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq3(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::circt::seq::ClockConstAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: clock constant";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq3(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq3(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq4(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() >= 1))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq4(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq4(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq5(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() >= 0))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 0";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq5(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq5(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq6(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 32-bit signless integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq6(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq6(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq7(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<circt::seq::RUWAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: Read-Under-Write Behavior";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq7(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq7(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq8(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<circt::seq::WUWAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: Write-Under-Write Behavior";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq8(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq8(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq9(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::circt::seq::FirMemInitAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: Memory initialization information";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq9(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq9(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq10(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((true)))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: any attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq10(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq10(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq11(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::mlir::IntegerAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: arbitrary integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq11(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq11(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq12(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !((::llvm::isa<::mlir::UnitAttr>(attr))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: unit attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq12(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq12(attr, attrName, [op]() {
    return op->emitOpError();
  });
}

static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq13(
    ::mlir::Attribute attr, ::llvm::StringRef attrName, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  if (attr && !(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64)))))
    return emitError() << "attribute '" << attrName
        << "' failed to satisfy constraint: 64-bit signless integer attribute";
  return ::mlir::success();
}
static ::mlir::LogicalResult __mlir_ods_local_attr_constraint_Seq13(
    ::mlir::Operation *op, ::mlir::Attribute attr, ::llvm::StringRef attrName) {
  return __mlir_ods_local_attr_constraint_Seq13(attr, attrName, [op]() {
    return op->emitOpError();
  });
}
} // namespace seq
} // namespace circt
namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ClockDividerOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ClockDividerOpGenericAdaptorBase::ClockDividerOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.clock_div", odsAttrs.getContext());
}

ClockDividerOpGenericAdaptorBase::ClockDividerOpGenericAdaptorBase(ClockDividerOp op) : ClockDividerOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ClockDividerOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ClockDividerOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr ClockDividerOpGenericAdaptorBase::getPow2Attr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().pow2);
  return attr;
}

uint8_t ClockDividerOpGenericAdaptorBase::getPow2() {
  auto attr = getPow2Attr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
ClockDividerOpAdaptor::ClockDividerOpAdaptor(ClockDividerOp op) : ClockDividerOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ClockDividerOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_pow2 = getProperties().pow2; (void)tblgen_pow2;
  if (!tblgen_pow2) return emitError(loc, "'seq.clock_div' op ""requires attribute 'pow2'");

  if (tblgen_pow2 && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_pow2))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_pow2).getType().isSignlessInteger(8)))))
    return emitError(loc, "'seq.clock_div' op ""attribute 'pow2' failed to satisfy constraint: 8-bit signless integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ClockDividerOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ClockDividerOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockDividerOp::getClockIn() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(0).begin());
}

::mlir::OpOperand &ClockDividerOp::getClockInMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> ClockDividerOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ClockDividerOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockDividerOp::getClockOut() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSResults(0).begin());
}

::mlir::LogicalResult ClockDividerOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.pow2;
       auto attr = dict.get("pow2");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for pow2 in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `pow2` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute ClockDividerOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.pow2;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("pow2",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code ClockDividerOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.pow2.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> ClockDividerOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "pow2")
      return prop.pow2;
  return std::nullopt;
}

void ClockDividerOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "pow2") {
       prop.pow2 = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.pow2)>>(value);
       return;
    }
}

void ClockDividerOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.pow2) attrs.append("pow2", prop.pow2);
}

::mlir::LogicalResult ClockDividerOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getPow2AttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(attr, "pow2", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult ClockDividerOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readAttribute(prop.pow2)))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockDividerOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;
  writer.writeAttribute(prop.pow2);
}

::mlir::IntegerAttr ClockDividerOp::getPow2Attr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().pow2);
}

uint8_t ClockDividerOp::getPow2() {
  auto attr = getPow2Attr();
  return attr.getValue().getZExtValue();
}

void ClockDividerOp::setPow2Attr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getPow2AttrName(), attr);
}

void ClockDividerOp::setPow2(uint8_t attrValue) {
  (*this)->setAttr(getPow2AttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(8), attrValue));
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type clockOut, ::mlir::Value clockIn, ::mlir::IntegerAttr pow2) {
  odsState.addOperands(clockIn);
  odsState.getOrAddProperties<Properties>().pow2 = pow2;
  odsState.addTypes(clockOut);
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value clockIn, ::mlir::IntegerAttr pow2) {
  odsState.addOperands(clockIn);
  odsState.getOrAddProperties<Properties>().pow2 = pow2;

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ClockDividerOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clockIn, ::mlir::IntegerAttr pow2) {
  odsState.addOperands(clockIn);
  odsState.getOrAddProperties<Properties>().pow2 = pow2;
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type clockOut, ::mlir::Value clockIn, uint8_t pow2) {
  odsState.addOperands(clockIn);
  odsState.getOrAddProperties<Properties>().pow2 = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(8), pow2);
  odsState.addTypes(clockOut);
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value clockIn, uint8_t pow2) {
  odsState.addOperands(clockIn);
  odsState.getOrAddProperties<Properties>().pow2 = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(8), pow2);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ClockDividerOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clockIn, uint8_t pow2) {
  odsState.addOperands(clockIn);
  odsState.getOrAddProperties<Properties>().pow2 = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(8), pow2);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ClockDividerOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ClockDividerOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ClockDividerOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ClockDividerOp::verifyInvariantsImpl() {
  auto tblgen_pow2 = getProperties().pow2; (void)tblgen_pow2;
  if (!tblgen_pow2) return emitOpError("requires attribute 'pow2'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq0(*this, tblgen_pow2, "pow2")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ClockDividerOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::LogicalResult ClockDividerOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getType<::circt::seq::ClockType>();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ClockDividerOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand clockInRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockInOperands(clockInRawOperands);  ::llvm::SMLoc clockInOperandsLoc;
  (void)clockInOperandsLoc;
  ::mlir::IntegerAttr pow2Attr;

  clockInOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockInRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("by"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(pow2Attr, parser.getBuilder().getIntegerType(8))) {
    return ::mlir::failure();
  }
  if (pow2Attr) result.getOrAddProperties<ClockDividerOp::Properties>().pow2 = pow2Attr;
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(clockInOperands, odsBuildableType0, clockInOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockDividerOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getClockIn();
  _odsPrinter << ' ' << "by";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getPow2Attr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("pow2");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ClockDividerOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ClockDividerOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ClockGateOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ClockGateOpGenericAdaptorBase::ClockGateOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.clock_gate", odsAttrs.getContext());
}

ClockGateOpGenericAdaptorBase::ClockGateOpGenericAdaptorBase(ClockGateOp op) : ClockGateOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ClockGateOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 2) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr ClockGateOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::hw::InnerSymAttr ClockGateOpGenericAdaptorBase::getInnerSymAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
  return attr;
}

::std::optional<::circt::hw::InnerSymAttr> ClockGateOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

} // namespace detail
ClockGateOpAdaptor::ClockGateOpAdaptor(ClockGateOp op) : ClockGateOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ClockGateOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;

  if (tblgen_inner_sym && !((::llvm::isa<::circt::hw::InnerSymAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.clock_gate' op ""attribute 'inner_sym' failed to satisfy constraint: Inner symbol definition");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ClockGateOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 2) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range ClockGateOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockGateOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ClockGateOp::getEnable() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ClockGateOp::getTestEnable() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::OpOperand &ClockGateOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ClockGateOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange ClockGateOp::getTestEnableMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> ClockGateOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ClockGateOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockGateOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSResults(0).begin());
}

::mlir::LogicalResult ClockGateOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.inner_sym;
       auto attr = dict.get("inner_sym");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for inner_sym in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `inner_sym` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute ClockGateOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.inner_sym;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("inner_sym",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code ClockGateOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.inner_sym.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> ClockGateOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "inner_sym")
      return prop.inner_sym;
  return std::nullopt;
}

void ClockGateOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "inner_sym") {
       prop.inner_sym = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.inner_sym)>>(value);
       return;
    }
}

void ClockGateOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.inner_sym) attrs.append("inner_sym", prop.inner_sym);
}

::mlir::LogicalResult ClockGateOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getInnerSymAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(attr, "inner_sym", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult ClockGateOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.inner_sym)))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockGateOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.inner_sym);
}

::circt::hw::InnerSymAttr ClockGateOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
}

::std::optional<::circt::hw::InnerSymAttr> ClockGateOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

void ClockGateOp::setInnerSymAttr(::circt::hw::InnerSymAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

::mlir::Attribute ClockGateOp::removeInnerSymAttr() {
    auto &attr = getProperties().inner_sym;
    attr = {};
    return attr;
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input, ::mlir::Value enable, /*optional*/::mlir::Value test_enable, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(enable);
  if (test_enable)
    odsState.addOperands(test_enable);
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  odsState.addTypes(output);
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value enable, /*optional*/::mlir::Value test_enable, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(enable);
  if (test_enable)
    odsState.addOperands(test_enable);
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ClockGateOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value enable, /*optional*/::mlir::Value test_enable, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(enable);
  if (test_enable)
    odsState.addOperands(test_enable);
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ClockGateOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ClockGateOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ClockGateOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ClockGateOp::verifyInvariantsImpl() {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, output} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult ClockGateOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void ClockGateOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult ClockGateOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getType<::circt::seq::ClockType>();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ClockGateOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand enableRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> enableOperands(enableRawOperands);  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> test_enableOperands;
  ::llvm::SMLoc test_enableOperandsLoc;
  (void)test_enableOperandsLoc;
  ::circt::hw::InnerSymAttr inner_symAttr;

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  enableOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(enableRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalComma())) {

  {
    test_enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      test_enableOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("sym"))) {

  if (parser.parseCustomAttributeWithFallback(inner_symAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (inner_symAttr) result.getOrAddProperties<ClockGateOp::Properties>().inner_sym = inner_symAttr;
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(inputOperands, odsBuildableType0, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType1, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(test_enableOperands, odsBuildableType1, test_enableOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockGateOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getEnable();
  if (getTestEnable()) {
    _odsPrinter << ",";
    _odsPrinter << ' ';
    if (::mlir::Value value = getTestEnable())
      _odsPrinter << value;
  }
  if (getInnerSymAttr()) {
    _odsPrinter << ' ' << "sym";
    _odsPrinter << ' ';
  _odsPrinter.printStrippedAttrOrType(getInnerSymAttr());
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("inner_sym");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ClockGateOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ClockGateOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ClockInverterOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ClockInverterOpGenericAdaptorBase::ClockInverterOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.clock_inv", odsAttrs.getContext());
}

ClockInverterOpGenericAdaptorBase::ClockInverterOpGenericAdaptorBase(ClockInverterOp op) : ClockInverterOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ClockInverterOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ClockInverterOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
ClockInverterOpAdaptor::ClockInverterOpAdaptor(ClockInverterOp op) : ClockInverterOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ClockInverterOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ClockInverterOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ClockInverterOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockInverterOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(0).begin());
}

::mlir::OpOperand &ClockInverterOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> ClockInverterOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ClockInverterOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockInverterOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSResults(0).begin());
}

void ClockInverterOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input) {
  odsState.addOperands(input);
  odsState.addTypes(output);
}

void ClockInverterOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input) {
  odsState.addOperands(input);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ClockInverterOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ClockInverterOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input) {
  odsState.addOperands(input);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ClockInverterOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ClockInverterOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ClockInverterOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ClockInverterOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ClockInverterOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::LogicalResult ClockInverterOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getType<::circt::seq::ClockType>();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ClockInverterOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(inputOperands, odsBuildableType0, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockInverterOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ClockInverterOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ClockInverterOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ClockMuxOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ClockMuxOpGenericAdaptorBase::ClockMuxOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.clock_mux", odsAttrs.getContext());
}

ClockMuxOpGenericAdaptorBase::ClockMuxOpGenericAdaptorBase(ClockMuxOp op) : ClockMuxOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ClockMuxOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ClockMuxOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
ClockMuxOpAdaptor::ClockMuxOpAdaptor(ClockMuxOp op) : ClockMuxOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ClockMuxOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ClockMuxOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ClockMuxOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> ClockMuxOp::getCond() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> ClockMuxOp::getTrueClock() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> ClockMuxOp::getFalseClock() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(2).begin());
}

::mlir::OpOperand &ClockMuxOp::getCondMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ClockMuxOp::getTrueClockMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ClockMuxOp::getFalseClockMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> ClockMuxOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ClockMuxOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ClockMuxOp::getResult() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSResults(0).begin());
}

void ClockMuxOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, ::mlir::Value cond, ::mlir::Value trueClock, ::mlir::Value falseClock) {
  odsState.addOperands(cond);
  odsState.addOperands(trueClock);
  odsState.addOperands(falseClock);
  odsState.addTypes(result);
}

void ClockMuxOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value cond, ::mlir::Value trueClock, ::mlir::Value falseClock) {
  odsState.addOperands(cond);
  odsState.addOperands(trueClock);
  odsState.addOperands(falseClock);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ClockMuxOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ClockMuxOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value cond, ::mlir::Value trueClock, ::mlir::Value falseClock) {
  odsState.addOperands(cond);
  odsState.addOperands(trueClock);
  odsState.addOperands(falseClock);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ClockMuxOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ClockMuxOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ClockMuxOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ClockMuxOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ClockMuxOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::LogicalResult ClockMuxOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getType<::circt::seq::ClockType>();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ClockMuxOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand condRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> condOperands(condRawOperands);  ::llvm::SMLoc condOperandsLoc;
  (void)condOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand trueClockRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> trueClockOperands(trueClockRawOperands);  ::llvm::SMLoc trueClockOperandsLoc;
  (void)trueClockOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand falseClockRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> falseClockOperands(falseClockRawOperands);  ::llvm::SMLoc falseClockOperandsLoc;
  (void)falseClockOperandsLoc;

  condOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(condRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  trueClockOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(trueClockRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  falseClockOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(falseClockRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(condOperands, odsBuildableType1, condOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(trueClockOperands, odsBuildableType0, trueClockOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(falseClockOperands, odsBuildableType0, falseClockOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ClockMuxOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getCond();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getTrueClock();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getFalseClock();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ClockMuxOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ClockMuxOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::CompRegClockEnabledOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CompRegClockEnabledOpGenericAdaptorBase::CompRegClockEnabledOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.compreg.ce", odsAttrs.getContext());
}

CompRegClockEnabledOpGenericAdaptorBase::CompRegClockEnabledOpGenericAdaptorBase(CompRegClockEnabledOp op) : CompRegClockEnabledOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> CompRegClockEnabledOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr CompRegClockEnabledOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr CompRegClockEnabledOpGenericAdaptorBase::getNameAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
  return attr;
}

::std::optional< ::llvm::StringRef > CompRegClockEnabledOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr CompRegClockEnabledOpGenericAdaptorBase::getInnerSymAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
  return attr;
}

::std::optional<::circt::hw::InnerSymAttr> CompRegClockEnabledOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

} // namespace detail
CompRegClockEnabledOpAdaptor::CompRegClockEnabledOpAdaptor(CompRegClockEnabledOp op) : CompRegClockEnabledOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult CompRegClockEnabledOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.compreg.ce' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::circt::hw::InnerSymAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.compreg.ce' op ""attribute 'inner_sym' failed to satisfy constraint: Inner symbol definition");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CompRegClockEnabledOp::getODSOperandIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range CompRegClockEnabledOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegClockEnabledOp::getInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> CompRegClockEnabledOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegClockEnabledOp::getClockEnable() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegClockEnabledOp::getReset() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value CompRegClockEnabledOp::getResetValue() {
  auto operands = getODSOperands(4);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::Value CompRegClockEnabledOp::getPowerOnValue() {
  auto operands = getODSOperands(5);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::OpOperand &CompRegClockEnabledOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &CompRegClockEnabledOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &CompRegClockEnabledOp::getClockEnableMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(4u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange CompRegClockEnabledOp::getPowerOnValueMutable() {
  auto range = getODSOperandIndexAndLength(5);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(5u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

std::pair<unsigned, unsigned> CompRegClockEnabledOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CompRegClockEnabledOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegClockEnabledOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::LogicalResult CompRegClockEnabledOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.inner_sym;
       auto attr = dict.get("inner_sym");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for inner_sym in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `inner_sym` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.name;
       auto attr = dict.get("name");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for name in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `name` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("operandSegmentSizes");   if (!attr) attr = dict.get("operand_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for operandSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.operandSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute CompRegClockEnabledOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.inner_sym;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("inner_sym",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.name;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("name",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.operandSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("operandSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code CompRegClockEnabledOp::computePropertiesHash(const Properties &prop) {
  auto hash_operandSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    llvm::hash_value(prop.inner_sym.getAsOpaquePointer()), 
    llvm::hash_value(prop.name.getAsOpaquePointer()), 
    hash_operandSegmentSizes(prop.operandSegmentSizes));
}

std::optional<mlir::Attribute> CompRegClockEnabledOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "inner_sym")
      return prop.inner_sym;

    if (name == "name")
      return prop.name;
    if (name == "operand_segment_sizes" || name == "operandSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes);
  return std::nullopt;
}

void CompRegClockEnabledOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "inner_sym") {
       prop.inner_sym = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.inner_sym)>>(value);
       return;
    }

    if (name == "name") {
       prop.name = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.name)>>(value);
       return;
    }
        if (name == "operand_segment_sizes" || name == "operandSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.operandSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.operandSegmentSizes.begin());
       return;
    }
}

void CompRegClockEnabledOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.inner_sym) attrs.append("inner_sym", prop.inner_sym);

    if (prop.name) attrs.append("name", prop.name);
  attrs.append("operandSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes));
}

::mlir::LogicalResult CompRegClockEnabledOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getInnerSymAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(attr, "inner_sym", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getNameAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "name", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult CompRegClockEnabledOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.inner_sym)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.name)))
    return ::mlir::failure();

  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.operandSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.operandSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void CompRegClockEnabledOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.inner_sym);

  writer.writeOptionalAttribute(prop.name);

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.operandSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.operandSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

::mlir::StringAttr CompRegClockEnabledOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
}

::std::optional< ::llvm::StringRef > CompRegClockEnabledOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr CompRegClockEnabledOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
}

::std::optional<::circt::hw::InnerSymAttr> CompRegClockEnabledOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

void CompRegClockEnabledOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void CompRegClockEnabledOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void CompRegClockEnabledOp::setInnerSymAttr(::circt::hw::InnerSymAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

::mlir::Attribute CompRegClockEnabledOp::removeNameAttr() {
    auto &attr = getProperties().name;
    attr = {};
    return attr;
}

::mlir::Attribute CompRegClockEnabledOp::removeInnerSymAttr() {
    auto &attr = getProperties().inner_sym;
    attr = {};
    return attr;
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, Value ce, StringRef name) {
      auto nameAttr = StringAttr::get(odsBuilder.getContext(), name);
      return build(odsBuilder, odsState, input.getType(), input, clk, ce,
                   nameAttr, /*reset*/ Value(), /*resetValue*/ Value(),
                   /*powerOnValue*/ Value(),
                   hw::InnerSymAttr::get(nameAttr));
    
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, Value ce, Value reset, Value rstValue, StringRef name, Value powerOnValue) {
      auto nameAttr = StringAttr::get(odsBuilder.getContext(), name);
      return build(odsBuilder, odsState, input.getType(), input, clk, ce,
                   nameAttr, reset, rstValue, powerOnValue,
                   hw::InnerSymAttr::get(nameAttr));
    
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  odsState.addTypes(data);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(CompRegClockEnabledOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void CompRegClockEnabledOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(CompRegClockEnabledOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult CompRegClockEnabledOp::verifyInvariantsImpl() {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    if (valueGroup4.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup4.size();
    }

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup5 = getODSOperands(5);

    if (valueGroup5.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup5.size();
    }

    for (auto v : valueGroup5) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult CompRegClockEnabledOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::LogicalResult CompRegClockEnabledOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult CompRegClockEnabledOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::circt::hw::InnerSymAttr inner_symAttr;
  ::mlir::StringAttr nameAttr;
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clockEnableRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockEnableOperands(clockEnableRawOperands);  ::llvm::SMLoc clockEnableOperandsLoc;
  (void)clockEnableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> resetOperands;
  ::llvm::SMLoc resetOperandsLoc;
  (void)resetOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> resetValueOperands;
  ::llvm::SMLoc resetValueOperandsLoc;
  (void)resetValueOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> powerOnValueOperands;
  ::llvm::SMLoc powerOnValueOperandsLoc;
  (void)powerOnValueOperandsLoc;
  ::mlir::Type dataRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> dataTypes(dataRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> resetValueTypes;
  ::llvm::SmallVector<::mlir::Type, 1> powerOnValueTypes;
  if (::mlir::succeeded(parser.parseOptionalKeyword("sym"))) {

  if (parser.parseCustomAttributeWithFallback(inner_symAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (inner_symAttr) result.getOrAddProperties<CompRegClockEnabledOp::Properties>().inner_sym = inner_symAttr;
  }
  {
    auto odsResult = parseImplicitSSAName(parser, nameAttr);
    if (odsResult) return ::mlir::failure();
    if (nameAttr)
      result.getOrAddProperties<CompRegClockEnabledOp::Properties>().name = nameAttr;
  }

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  clockEnableOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockEnableRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("reset"))) {

  {
    resetOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      resetOperands.push_back(operand);
    }
  }
  if (parser.parseComma())
    return ::mlir::failure();

  {
    resetValueOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      resetValueOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("powerOn"))) {

  {
    powerOnValueOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      powerOnValueOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    dataRawTypes[0] = type;
  }
  {
    ::std::optional<::mlir::OpAsmParser::UnresolvedOperand> resetValueOperand = resetValueOperands.empty() ? ::std::optional<::mlir::OpAsmParser::UnresolvedOperand>() : resetValueOperands[0];
    ::mlir::Type resetValueType;
    auto odsResult = parseOptionalTypeMatch(parser, dataRawTypes[0], resetValueOperand, resetValueType);
    if (odsResult) return ::mlir::failure();
    if (resetValueType)
      resetValueTypes.push_back(resetValueType);
  }
  {
    ::std::optional<::mlir::OpAsmParser::UnresolvedOperand> powerOnValueOperand = powerOnValueOperands.empty() ? ::std::optional<::mlir::OpAsmParser::UnresolvedOperand>() : powerOnValueOperands[0];
    ::mlir::Type powerOnValueType;
    auto odsResult = parseOptionalTypeMatch(parser, dataRawTypes[0], powerOnValueOperand, powerOnValueType);
    if (odsResult) return ::mlir::failure();
    if (powerOnValueType)
      powerOnValueTypes.push_back(powerOnValueType);
  }
::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, static_cast<int32_t>(resetOperands.size()), static_cast<int32_t>(resetValueOperands.size()), static_cast<int32_t>(powerOnValueOperands.size())}), result.getOrAddProperties<CompRegClockEnabledOp::Properties>().operandSegmentSizes.begin());
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(dataTypes);
  if (parser.resolveOperands(inputOperands, dataTypes[0], inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clockEnableOperands, odsBuildableType1, clockEnableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(resetOperands, odsBuildableType1, resetOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(resetValueOperands, resetValueTypes, resetValueOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(powerOnValueOperands, powerOnValueTypes, powerOnValueOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void CompRegClockEnabledOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getInnerSymAttr()) {
    _odsPrinter << ' ' << "sym";
    _odsPrinter << ' ';
  _odsPrinter.printStrippedAttrOrType(getInnerSymAttr());
  }
  _odsPrinter << ' ';
  printImplicitSSAName(_odsPrinter, *this, getNameAttr());
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getClockEnable();
  if (getReset()) {
    _odsPrinter << ' ' << "reset";
    _odsPrinter << ' ';
    if (::mlir::Value value = getReset())
      _odsPrinter << value;
    _odsPrinter << ",";
    _odsPrinter << ' ';
    if (::mlir::Value value = getResetValue())
      _odsPrinter << value;
  }
  if (getPowerOnValue()) {
    _odsPrinter << ' ' << "powerOn";
    _odsPrinter << ' ';
    if (::mlir::Value value = getPowerOnValue())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operandSegmentSizes");
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getData().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  _odsPrinter << ' ';
  printOptionalTypeMatch(_odsPrinter, *this, getData().getType(), getResetValue(), (getResetValue() ? getResetValue().getType() : ::mlir::Type()));
  _odsPrinter << ' ';
  printOptionalTypeMatch(_odsPrinter, *this, getData().getType(), getPowerOnValue(), (getPowerOnValue() ? getPowerOnValue().getType() : ::mlir::Type()));
}

void CompRegClockEnabledOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::CompRegClockEnabledOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::CompRegOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
CompRegOpGenericAdaptorBase::CompRegOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.compreg", odsAttrs.getContext());
}

CompRegOpGenericAdaptorBase::CompRegOpGenericAdaptorBase(CompRegOp op) : CompRegOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> CompRegOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr CompRegOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr CompRegOpGenericAdaptorBase::getNameAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
  return attr;
}

::std::optional< ::llvm::StringRef > CompRegOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr CompRegOpGenericAdaptorBase::getInnerSymAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
  return attr;
}

::std::optional<::circt::hw::InnerSymAttr> CompRegOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

} // namespace detail
CompRegOpAdaptor::CompRegOpAdaptor(CompRegOp op) : CompRegOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult CompRegOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.compreg' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::circt::hw::InnerSymAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.compreg' op ""attribute 'inner_sym' failed to satisfy constraint: Inner symbol definition");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> CompRegOp::getODSOperandIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range CompRegOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegOp::getInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> CompRegOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> CompRegOp::getReset() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value CompRegOp::getResetValue() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::Value CompRegOp::getPowerOnValue() {
  auto operands = getODSOperands(4);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::OpOperand &CompRegOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &CompRegOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange CompRegOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(2u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange CompRegOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange CompRegOp::getPowerOnValueMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(4u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

std::pair<unsigned, unsigned> CompRegOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range CompRegOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value CompRegOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::LogicalResult CompRegOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.inner_sym;
       auto attr = dict.get("inner_sym");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for inner_sym in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `inner_sym` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.name;
       auto attr = dict.get("name");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for name in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `name` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("operandSegmentSizes");   if (!attr) attr = dict.get("operand_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for operandSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.operandSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute CompRegOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.inner_sym;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("inner_sym",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.name;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("name",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.operandSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("operandSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code CompRegOp::computePropertiesHash(const Properties &prop) {
  auto hash_operandSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    llvm::hash_value(prop.inner_sym.getAsOpaquePointer()), 
    llvm::hash_value(prop.name.getAsOpaquePointer()), 
    hash_operandSegmentSizes(prop.operandSegmentSizes));
}

std::optional<mlir::Attribute> CompRegOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "inner_sym")
      return prop.inner_sym;

    if (name == "name")
      return prop.name;
    if (name == "operand_segment_sizes" || name == "operandSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes);
  return std::nullopt;
}

void CompRegOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "inner_sym") {
       prop.inner_sym = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.inner_sym)>>(value);
       return;
    }

    if (name == "name") {
       prop.name = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.name)>>(value);
       return;
    }
        if (name == "operand_segment_sizes" || name == "operandSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.operandSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.operandSegmentSizes.begin());
       return;
    }
}

void CompRegOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.inner_sym) attrs.append("inner_sym", prop.inner_sym);

    if (prop.name) attrs.append("name", prop.name);
  attrs.append("operandSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes));
}

::mlir::LogicalResult CompRegOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getInnerSymAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(attr, "inner_sym", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getNameAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "name", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult CompRegOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.inner_sym)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.name)))
    return ::mlir::failure();

  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.operandSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.operandSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void CompRegOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.inner_sym);

  writer.writeOptionalAttribute(prop.name);

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.operandSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.operandSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

::mlir::StringAttr CompRegOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
}

::std::optional< ::llvm::StringRef > CompRegOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr CompRegOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
}

::std::optional<::circt::hw::InnerSymAttr> CompRegOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

void CompRegOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void CompRegOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void CompRegOp::setInnerSymAttr(::circt::hw::InnerSymAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

::mlir::Attribute CompRegOp::removeNameAttr() {
    auto &attr = getProperties().name;
    attr = {};
    return attr;
}

::mlir::Attribute CompRegOp::removeInnerSymAttr() {
    auto &attr = getProperties().inner_sym;
    attr = {};
    return attr;
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk) {
      return build(odsBuilder, odsState, input.getType(), input, clk,
                   /*name*/ StringAttr(),
                   /*reset*/ Value(), /*resetValue*/ Value(),
                   /*powerOnValue*/ Value(), hw::InnerSymAttr());
    
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, StringAttrOrRef name) {
      auto nameAttr = name.get(odsBuilder.getContext());
      return build(odsBuilder, odsState, input.getType(), input, clk, nameAttr,
                   /*reset*/ Value(), /*resetValue*/ Value(),
                   /*powerOnValue*/ Value(), hw::InnerSymAttr::get(nameAttr));
    
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, Value input, Value clk, Value reset, Value rstValue, StringAttrOrRef name, Value powerOnValue) {
      auto nameAttr = name.get(odsBuilder.getContext());
      return build(odsBuilder, odsState, input.getType(), input, clk, nameAttr,
                   reset, rstValue, powerOnValue, hw::InnerSymAttr::get(nameAttr));
    
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value input, ::mlir::Value clk, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  odsState.addTypes(data);
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input, ::mlir::Value clk, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(CompRegOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value clk, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void CompRegOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void CompRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(CompRegOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult CompRegOp::verifyInvariantsImpl() {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    if (valueGroup4.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup4.size();
    }

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult CompRegOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::LogicalResult CompRegOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult CompRegOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::circt::hw::InnerSymAttr inner_symAttr;
  ::mlir::StringAttr nameAttr;
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> resetOperands;
  ::llvm::SMLoc resetOperandsLoc;
  (void)resetOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> resetValueOperands;
  ::llvm::SMLoc resetValueOperandsLoc;
  (void)resetValueOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> powerOnValueOperands;
  ::llvm::SMLoc powerOnValueOperandsLoc;
  (void)powerOnValueOperandsLoc;
  ::mlir::Type dataRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> dataTypes(dataRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> resetValueTypes;
  ::llvm::SmallVector<::mlir::Type, 1> powerOnValueTypes;
  if (::mlir::succeeded(parser.parseOptionalKeyword("sym"))) {

  if (parser.parseCustomAttributeWithFallback(inner_symAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (inner_symAttr) result.getOrAddProperties<CompRegOp::Properties>().inner_sym = inner_symAttr;
  }
  {
    auto odsResult = parseImplicitSSAName(parser, nameAttr);
    if (odsResult) return ::mlir::failure();
    if (nameAttr)
      result.getOrAddProperties<CompRegOp::Properties>().name = nameAttr;
  }

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("reset"))) {

  {
    resetOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      resetOperands.push_back(operand);
    }
  }
  if (parser.parseComma())
    return ::mlir::failure();

  {
    resetValueOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      resetValueOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("powerOn"))) {

  {
    powerOnValueOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      powerOnValueOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    dataRawTypes[0] = type;
  }
  {
    ::std::optional<::mlir::OpAsmParser::UnresolvedOperand> resetValueOperand = resetValueOperands.empty() ? ::std::optional<::mlir::OpAsmParser::UnresolvedOperand>() : resetValueOperands[0];
    ::mlir::Type resetValueType;
    auto odsResult = parseOptionalTypeMatch(parser, dataRawTypes[0], resetValueOperand, resetValueType);
    if (odsResult) return ::mlir::failure();
    if (resetValueType)
      resetValueTypes.push_back(resetValueType);
  }
  {
    ::std::optional<::mlir::OpAsmParser::UnresolvedOperand> powerOnValueOperand = powerOnValueOperands.empty() ? ::std::optional<::mlir::OpAsmParser::UnresolvedOperand>() : powerOnValueOperands[0];
    ::mlir::Type powerOnValueType;
    auto odsResult = parseOptionalTypeMatch(parser, dataRawTypes[0], powerOnValueOperand, powerOnValueType);
    if (odsResult) return ::mlir::failure();
    if (powerOnValueType)
      powerOnValueTypes.push_back(powerOnValueType);
  }
::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, static_cast<int32_t>(resetOperands.size()), static_cast<int32_t>(resetValueOperands.size()), static_cast<int32_t>(powerOnValueOperands.size())}), result.getOrAddProperties<CompRegOp::Properties>().operandSegmentSizes.begin());
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(dataTypes);
  if (parser.resolveOperands(inputOperands, dataTypes[0], inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(resetOperands, odsBuildableType1, resetOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(resetValueOperands, resetValueTypes, resetValueOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(powerOnValueOperands, powerOnValueTypes, powerOnValueOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void CompRegOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getInnerSymAttr()) {
    _odsPrinter << ' ' << "sym";
    _odsPrinter << ' ';
  _odsPrinter.printStrippedAttrOrType(getInnerSymAttr());
  }
  _odsPrinter << ' ';
  printImplicitSSAName(_odsPrinter, *this, getNameAttr());
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  if (getReset()) {
    _odsPrinter << ' ' << "reset";
    _odsPrinter << ' ';
    if (::mlir::Value value = getReset())
      _odsPrinter << value;
    _odsPrinter << ",";
    _odsPrinter << ' ';
    if (::mlir::Value value = getResetValue())
      _odsPrinter << value;
  }
  if (getPowerOnValue()) {
    _odsPrinter << ' ' << "powerOn";
    _odsPrinter << ' ';
    if (::mlir::Value value = getPowerOnValue())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operandSegmentSizes");
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getData().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  _odsPrinter << ' ';
  printOptionalTypeMatch(_odsPrinter, *this, getData().getType(), getResetValue(), (getResetValue() ? getResetValue().getType() : ::mlir::Type()));
  _odsPrinter << ' ';
  printOptionalTypeMatch(_odsPrinter, *this, getData().getType(), getPowerOnValue(), (getPowerOnValue() ? getPowerOnValue().getType() : ::mlir::Type()));
}

void CompRegOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::CompRegOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ConstClockOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ConstClockOpGenericAdaptorBase::ConstClockOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.const_clock", odsAttrs.getContext());
}

ConstClockOpGenericAdaptorBase::ConstClockOpGenericAdaptorBase(ConstClockOp op) : ConstClockOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ConstClockOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ConstClockOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::circt::seq::ClockConstAttr ConstClockOpGenericAdaptorBase::getValueAttr() {
  auto attr = ::llvm::cast<::circt::seq::ClockConstAttr>(getProperties().value);
  return attr;
}

circt::seq::ClockConst ConstClockOpGenericAdaptorBase::getValue() {
  auto attr = getValueAttr();
  return attr.getValue();
}

} // namespace detail
ConstClockOpAdaptor::ConstClockOpAdaptor(ConstClockOp op) : ConstClockOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ConstClockOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_value = getProperties().value; (void)tblgen_value;
  if (!tblgen_value) return emitError(loc, "'seq.const_clock' op ""requires attribute 'value'");

  if (tblgen_value && !((::llvm::isa<::circt::seq::ClockConstAttr>(tblgen_value))))
    return emitError(loc, "'seq.const_clock' op ""attribute 'value' failed to satisfy constraint: clock constant");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ConstClockOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ConstClockOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> ConstClockOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ConstClockOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ConstClockOp::getResult() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSResults(0).begin());
}

::mlir::LogicalResult ConstClockOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.value;
       auto attr = dict.get("value");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for value in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `value` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute ConstClockOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.value;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("value",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code ConstClockOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.value.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> ConstClockOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "value")
      return prop.value;
  return std::nullopt;
}

void ConstClockOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "value") {
       prop.value = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.value)>>(value);
       return;
    }
}

void ConstClockOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.value) attrs.append("value", prop.value);
}

::mlir::LogicalResult ConstClockOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getValueAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq3(attr, "value", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult ConstClockOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readAttribute(prop.value)))
    return ::mlir::failure();
  return ::mlir::success();
}

void ConstClockOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;
  writer.writeAttribute(prop.value);
}

::circt::seq::ClockConstAttr ConstClockOp::getValueAttr() {
  return ::llvm::cast<::circt::seq::ClockConstAttr>(getProperties().value);
}

circt::seq::ClockConst ConstClockOp::getValue() {
  auto attr = getValueAttr();
  return attr.getValue();
}

void ConstClockOp::setValueAttr(::circt::seq::ClockConstAttr attr) {
  (*this)->setAttr(getValueAttrName(), attr);
}

void ConstClockOp::setValue(circt::seq::ClockConst attrValue) {
  (*this)->setAttr(getValueAttrName(), circt::seq::ClockConstAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, ::circt::seq::ClockConstAttr value) {
  odsState.getOrAddProperties<Properties>().value = value;
  odsState.addTypes(result);
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::circt::seq::ClockConstAttr value) {
  odsState.getOrAddProperties<Properties>().value = value;

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ConstClockOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::circt::seq::ClockConstAttr value) {
  odsState.getOrAddProperties<Properties>().value = value;
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type result, circt::seq::ClockConst value) {
  odsState.getOrAddProperties<Properties>().value = circt::seq::ClockConstAttr::get(odsBuilder.getContext(), value);
  odsState.addTypes(result);
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, circt::seq::ClockConst value) {
  odsState.getOrAddProperties<Properties>().value = circt::seq::ClockConstAttr::get(odsBuilder.getContext(), value);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ConstClockOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, circt::seq::ClockConst value) {
  odsState.getOrAddProperties<Properties>().value = circt::seq::ClockConstAttr::get(odsBuilder.getContext(), value);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ConstClockOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ConstClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ConstClockOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ConstClockOp::verifyInvariantsImpl() {
  auto tblgen_value = getProperties().value; (void)tblgen_value;
  if (!tblgen_value) return emitOpError("requires attribute 'value'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq3(*this, tblgen_value, "value")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ConstClockOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::LogicalResult ConstClockOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getType<::circt::seq::ClockType>();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ConstClockOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::circt::seq::ClockConstAttr valueAttr;

  if (parser.parseCustomAttributeWithFallback(valueAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (valueAttr) result.getOrAddProperties<ConstClockOp::Properties>().value = valueAttr;
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  result.addTypes(odsBuildableType0);
  return ::mlir::success();
}

void ConstClockOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
_odsPrinter.printStrippedAttrOrType(getValueAttr());
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("value");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ConstClockOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ConstClockOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FIFOOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FIFOOpGenericAdaptorBase::FIFOOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.fifo", odsAttrs.getContext());
}

FIFOOpGenericAdaptorBase::FIFOOpGenericAdaptorBase(FIFOOp op) : FIFOOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FIFOOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr FIFOOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr FIFOOpGenericAdaptorBase::getDepthAttr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().depth);
  return attr;
}

uint64_t FIFOOpGenericAdaptorBase::getDepth() {
  auto attr = getDepthAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FIFOOpGenericAdaptorBase::getAlmostFullThresholdAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(getProperties().almostFullThreshold);
  return attr;
}

::std::optional<uint64_t> FIFOOpGenericAdaptorBase::getAlmostFullThreshold() {
  auto attr = getAlmostFullThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

::mlir::IntegerAttr FIFOOpGenericAdaptorBase::getAlmostEmptyThresholdAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(getProperties().almostEmptyThreshold);
  return attr;
}

::std::optional<uint64_t> FIFOOpGenericAdaptorBase::getAlmostEmptyThreshold() {
  auto attr = getAlmostEmptyThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

} // namespace detail
FIFOOpAdaptor::FIFOOpAdaptor(FIFOOp op) : FIFOOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FIFOOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_almostEmptyThreshold = getProperties().almostEmptyThreshold; (void)tblgen_almostEmptyThreshold;
  auto tblgen_almostFullThreshold = getProperties().almostFullThreshold; (void)tblgen_almostFullThreshold;
  auto tblgen_depth = getProperties().depth; (void)tblgen_depth;
  if (!tblgen_depth) return emitError(loc, "'seq.fifo' op ""requires attribute 'depth'");

  if (tblgen_depth && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_depth))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_depth).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_depth).getInt() >= 1))))
    return emitError(loc, "'seq.fifo' op ""attribute 'depth' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1");

  if (tblgen_almostFullThreshold && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_almostFullThreshold))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostFullThreshold).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostFullThreshold).getInt() >= 0))))
    return emitError(loc, "'seq.fifo' op ""attribute 'almostFullThreshold' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 0");

  if (tblgen_almostEmptyThreshold && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_almostEmptyThreshold))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostEmptyThreshold).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_almostEmptyThreshold).getInt() >= 0))))
    return emitError(loc, "'seq.fifo' op ""attribute 'almostEmptyThreshold' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 0");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FIFOOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range FIFOOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>> FIFOOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getRdEn() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getWrEn() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> FIFOOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(3).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::OpOperand &FIFOOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FIFOOp::getRdEnMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FIFOOp::getWrEnMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FIFOOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(3);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FIFOOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(4);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> FIFOOp::getODSResultIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().resultSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::result_range FIFOOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>> FIFOOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>>>(*getODSResults(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getFull() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getEmpty() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getAlmostFull() {
  auto results = getODSResults(3);
  return results.empty() ? ::mlir::TypedValue<::mlir::IntegerType>() : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*results.begin());
}

::mlir::TypedValue<::mlir::IntegerType> FIFOOp::getAlmostEmpty() {
  auto results = getODSResults(4);
  return results.empty() ? ::mlir::TypedValue<::mlir::IntegerType>() : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*results.begin());
}

::mlir::LogicalResult FIFOOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.almostEmptyThreshold;
       auto attr = dict.get("almostEmptyThreshold");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for almostEmptyThreshold in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `almostEmptyThreshold` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.almostFullThreshold;
       auto attr = dict.get("almostFullThreshold");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for almostFullThreshold in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `almostFullThreshold` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.depth;
       auto attr = dict.get("depth");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for depth in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `depth` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("resultSegmentSizes");   if (!attr) attr = dict.get("result_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for resultSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.resultSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute FIFOOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.almostEmptyThreshold;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("almostEmptyThreshold",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.almostFullThreshold;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("almostFullThreshold",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.depth;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("depth",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.resultSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("resultSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code FIFOOp::computePropertiesHash(const Properties &prop) {
  auto hash_resultSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    llvm::hash_value(prop.almostEmptyThreshold.getAsOpaquePointer()), 
    llvm::hash_value(prop.almostFullThreshold.getAsOpaquePointer()), 
    llvm::hash_value(prop.depth.getAsOpaquePointer()), 
    hash_resultSegmentSizes(prop.resultSegmentSizes));
}

std::optional<mlir::Attribute> FIFOOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "almostEmptyThreshold")
      return prop.almostEmptyThreshold;

    if (name == "almostFullThreshold")
      return prop.almostFullThreshold;

    if (name == "depth")
      return prop.depth;
    if (name == "result_segment_sizes" || name == "resultSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.resultSegmentSizes);
  return std::nullopt;
}

void FIFOOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "almostEmptyThreshold") {
       prop.almostEmptyThreshold = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.almostEmptyThreshold)>>(value);
       return;
    }

    if (name == "almostFullThreshold") {
       prop.almostFullThreshold = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.almostFullThreshold)>>(value);
       return;
    }

    if (name == "depth") {
       prop.depth = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.depth)>>(value);
       return;
    }
        if (name == "result_segment_sizes" || name == "resultSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.resultSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.resultSegmentSizes.begin());
       return;
    }
}

void FIFOOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.almostEmptyThreshold) attrs.append("almostEmptyThreshold", prop.almostEmptyThreshold);

    if (prop.almostFullThreshold) attrs.append("almostFullThreshold", prop.almostFullThreshold);

    if (prop.depth) attrs.append("depth", prop.depth);
  attrs.append("resultSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.resultSegmentSizes));
}

::mlir::LogicalResult FIFOOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getAlmostEmptyThresholdAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq5(attr, "almostEmptyThreshold", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getAlmostFullThresholdAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq5(attr, "almostFullThreshold", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getDepthAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq4(attr, "depth", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult FIFOOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.almostEmptyThreshold)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.almostFullThreshold)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.depth)))
    return ::mlir::failure();

  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.resultSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.resultSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void FIFOOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.almostEmptyThreshold);

  writer.writeOptionalAttribute(prop.almostFullThreshold);
  writer.writeAttribute(prop.depth);

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.resultSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.resultSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

::mlir::IntegerAttr FIFOOp::getDepthAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().depth);
}

uint64_t FIFOOp::getDepth() {
  auto attr = getDepthAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FIFOOp::getAlmostFullThresholdAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(getProperties().almostFullThreshold);
}

::std::optional<uint64_t> FIFOOp::getAlmostFullThreshold() {
  auto attr = getAlmostFullThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

::mlir::IntegerAttr FIFOOp::getAlmostEmptyThresholdAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(getProperties().almostEmptyThreshold);
}

::std::optional<uint64_t> FIFOOp::getAlmostEmptyThreshold() {
  auto attr = getAlmostEmptyThresholdAttr();
  return attr ? ::std::optional<uint64_t>(attr.getValue().getZExtValue()) : (::std::nullopt);
}

void FIFOOp::setDepthAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getDepthAttrName(), attr);
}

void FIFOOp::setDepth(uint64_t attrValue) {
  (*this)->setAttr(getDepthAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void FIFOOp::setAlmostFullThresholdAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getAlmostFullThresholdAttrName(), attr);
}

void FIFOOp::setAlmostFullThreshold(::std::optional<uint64_t> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getAlmostFullThresholdAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), *attrValue));
    (*this)->removeAttr(getAlmostFullThresholdAttrName());
}

void FIFOOp::setAlmostEmptyThresholdAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getAlmostEmptyThresholdAttrName(), attr);
}

void FIFOOp::setAlmostEmptyThreshold(::std::optional<uint64_t> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getAlmostEmptyThresholdAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), *attrValue));
    (*this)->removeAttr(getAlmostEmptyThresholdAttrName());
}

::mlir::Attribute FIFOOp::removeAlmostFullThresholdAttr() {
    auto &attr = getProperties().almostFullThreshold;
    attr = {};
    return attr;
}

::mlir::Attribute FIFOOp::removeAlmostEmptyThresholdAttr() {
    auto &attr = getProperties().almostEmptyThreshold;
    attr = {};
    return attr;
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Type full, ::mlir::Type empty, /*optional*/::mlir::Type almostFull, /*optional*/::mlir::Type almostEmpty, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, ::mlir::IntegerAttr depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().depth = depth;
  if (almostFullThreshold) {
    odsState.getOrAddProperties<Properties>().almostFullThreshold = almostFullThreshold;
  }
  if (almostEmptyThreshold) {
    odsState.getOrAddProperties<Properties>().almostEmptyThreshold = almostEmptyThreshold;
  }
  odsState.addTypes(output);
  odsState.addTypes(full);
  odsState.addTypes(empty);
  if (almostFull)
    odsState.addTypes(almostFull);
  if (almostEmpty)
    odsState.addTypes(almostEmpty);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (almostFull ? 1 : 0), (almostEmpty ? 1 : 0)}), odsState.getOrAddProperties<Properties>().resultSegmentSizes.begin());
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, ::mlir::IntegerAttr depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().depth = depth;
  if (almostFullThreshold) {
    odsState.getOrAddProperties<Properties>().almostFullThreshold = almostFullThreshold;
  }
  if (almostEmptyThreshold) {
    odsState.getOrAddProperties<Properties>().almostEmptyThreshold = almostEmptyThreshold;
  }
  assert(resultTypes.size() >= 3u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Type full, ::mlir::Type empty, /*optional*/::mlir::Type almostFull, /*optional*/::mlir::Type almostEmpty, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, uint64_t depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().depth = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), depth);
  if (almostFullThreshold) {
    odsState.getOrAddProperties<Properties>().almostFullThreshold = almostFullThreshold;
  }
  if (almostEmptyThreshold) {
    odsState.getOrAddProperties<Properties>().almostEmptyThreshold = almostEmptyThreshold;
  }
  odsState.addTypes(output);
  odsState.addTypes(full);
  odsState.addTypes(empty);
  if (almostFull)
    odsState.addTypes(almostFull);
  if (almostEmpty)
    odsState.addTypes(almostEmpty);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (almostFull ? 1 : 0), (almostEmpty ? 1 : 0)}), odsState.getOrAddProperties<Properties>().resultSegmentSizes.begin());
}

void FIFOOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input, ::mlir::Value rdEn, ::mlir::Value wrEn, ::mlir::Value clk, ::mlir::Value rst, uint64_t depth, /*optional*/::mlir::IntegerAttr almostFullThreshold, /*optional*/::mlir::IntegerAttr almostEmptyThreshold) {
  odsState.addOperands(input);
  odsState.addOperands(rdEn);
  odsState.addOperands(wrEn);
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().depth = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), depth);
  if (almostFullThreshold) {
    odsState.getOrAddProperties<Properties>().almostFullThreshold = almostFullThreshold;
  }
  if (almostEmptyThreshold) {
    odsState.getOrAddProperties<Properties>().almostEmptyThreshold = almostEmptyThreshold;
  }
  assert(resultTypes.size() >= 3u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FIFOOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 5u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() >= 3u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult FIFOOp::verifyInvariantsImpl() {
  auto tblgen_almostEmptyThreshold = getProperties().almostEmptyThreshold; (void)tblgen_almostEmptyThreshold;
  auto tblgen_almostFullThreshold = getProperties().almostFullThreshold; (void)tblgen_almostFullThreshold;
  auto tblgen_depth = getProperties().depth; (void)tblgen_depth;
  if (!tblgen_depth) return emitOpError("requires attribute 'depth'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq4(*this, tblgen_depth, "depth")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq5(*this, tblgen_almostFullThreshold, "almostFullThreshold")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq5(*this, tblgen_almostEmptyThreshold, "almostEmptyThreshold")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq3(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq3(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSResults(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSResults(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSResults(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("result group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSResults(4);

    if (valueGroup4.size() > 1) {
      return emitOpError("result group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup4.size();
    }

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()( (*this->getODSOperands(0).begin()).getType() , (*this->getODSResults(0).begin()).getType()))))
    return emitOpError("failed to verify that Input type should match output type");
  return ::mlir::success();
}

::mlir::LogicalResult FIFOOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::ParseResult FIFOOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::IntegerAttr depthAttr;
  ::mlir::IntegerAttr almostFullThresholdAttr;
  ::llvm::SmallVector<::mlir::Type, 1> almostFullTypes;
  ::mlir::IntegerAttr almostEmptyThresholdAttr;
  ::llvm::SmallVector<::mlir::Type, 1> almostEmptyTypes;
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rdEnRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rdEnOperands(rdEnRawOperands);  ::llvm::SMLoc rdEnOperandsLoc;
  (void)rdEnOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand wrEnRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> wrEnOperands(wrEnRawOperands);  ::llvm::SMLoc wrEnOperandsLoc;
  (void)wrEnOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rstRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rstOperands(rstRawOperands);  ::llvm::SMLoc rstOperandsLoc;
  (void)rstOperandsLoc;
  ::mlir::Type inputRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> inputTypes(inputRawTypes);
  if (parser.parseKeyword("depth"))
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(depthAttr, parser.getBuilder().getIntegerType(64))) {
    return ::mlir::failure();
  }
  if (depthAttr) result.getOrAddProperties<FIFOOp::Properties>().depth = depthAttr;
  {
    ::mlir::Type almostFullType;
    auto odsResult = parseFIFOAFThreshold(parser, almostFullThresholdAttr, almostFullType);
    if (odsResult) return ::mlir::failure();
    if (almostFullThresholdAttr)
      result.getOrAddProperties<FIFOOp::Properties>().almostFullThreshold = almostFullThresholdAttr;
    if (almostFullType)
      almostFullTypes.push_back(almostFullType);
  }
  {
    ::mlir::Type almostEmptyType;
    auto odsResult = parseFIFOAEThreshold(parser, almostEmptyThresholdAttr, almostEmptyType);
    if (odsResult) return ::mlir::failure();
    if (almostEmptyThresholdAttr)
      result.getOrAddProperties<FIFOOp::Properties>().almostEmptyThreshold = almostEmptyThresholdAttr;
    if (almostEmptyType)
      almostEmptyTypes.push_back(almostEmptyType);
  }
  if (parser.parseKeyword("in"))
    return ::mlir::failure();

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("rdEn"))
    return ::mlir::failure();

  rdEnOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rdEnRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("wrEn"))
    return ::mlir::failure();

  wrEnOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(wrEnRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("clk"))
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("rst"))
    return ::mlir::failure();

  rstOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rstRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType> type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    inputRawTypes[0] = type;
  }
::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, static_cast<int32_t>(almostFullTypes.size()), static_cast<int32_t>(almostEmptyTypes.size())}), result.getOrAddProperties<FIFOOp::Properties>().resultSegmentSizes.begin());
  for (::mlir::Type type : inputTypes) {
    (void)type;
    if (!((::circt::hw::isHWIntegerType(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'input' must be a signless integer bitvector, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getType<::circt::seq::ClockType>();
  result.addTypes( inputTypes[0] );
  result.addTypes(odsBuildableType0);
  result.addTypes(odsBuildableType0);
  result.addTypes(almostFullTypes);
  result.addTypes(almostEmptyTypes);
  if (parser.resolveOperands(inputOperands, inputTypes, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rdEnOperands, odsBuildableType0, rdEnOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(wrEnOperands, odsBuildableType0, wrEnOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType1, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rstOperands, odsBuildableType0, rstOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FIFOOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ' << "depth";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getDepthAttr());
  _odsPrinter << ' ';
  printFIFOAFThreshold(_odsPrinter, *this, getAlmostFullThresholdAttr(), (getAlmostFull() ? getAlmostFull().getType() : ::mlir::Type()));
  _odsPrinter << ' ';
  printFIFOAEThreshold(_odsPrinter, *this, getAlmostEmptyThresholdAttr(), (getAlmostEmpty() ? getAlmostEmpty().getType() : ::mlir::Type()));
  _odsPrinter << ' ' << "in";
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ' ' << "rdEn";
  _odsPrinter << ' ';
  _odsPrinter << getRdEn();
  _odsPrinter << ' ' << "wrEn";
  _odsPrinter << ' ';
  _odsPrinter << getWrEn();
  _odsPrinter << ' ' << "clk";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ' ' << "rst";
  _odsPrinter << ' ';
  _odsPrinter << getRst();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("resultSegmentSizes");
  elidedAttrs.push_back("depth");
  elidedAttrs.push_back("almostFullThreshold");
  elidedAttrs.push_back("almostEmptyThreshold");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getInput().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::hw::TypeVariant<::mlir::IntegerType, ::circt::hw::IntType>>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FIFOOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemOpGenericAdaptorBase::FirMemOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem", odsAttrs.getContext());
}

FirMemOpGenericAdaptorBase::FirMemOpGenericAdaptorBase(FirMemOp op) : FirMemOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FirMemOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr FirMemOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr FirMemOpGenericAdaptorBase::getReadLatencyAttr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().readLatency);
  return attr;
}

uint32_t FirMemOpGenericAdaptorBase::getReadLatency() {
  auto attr = getReadLatencyAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FirMemOpGenericAdaptorBase::getWriteLatencyAttr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().writeLatency);
  return attr;
}

uint32_t FirMemOpGenericAdaptorBase::getWriteLatency() {
  auto attr = getWriteLatencyAttr();
  return attr.getValue().getZExtValue();
}

circt::seq::RUWAttr FirMemOpGenericAdaptorBase::getRuwAttr() {
  auto attr = ::llvm::cast<circt::seq::RUWAttr>(getProperties().ruw);
  return attr;
}

circt::seq::RUW FirMemOpGenericAdaptorBase::getRuw() {
  auto attr = getRuwAttr();
  return attr.getValue();
}

circt::seq::WUWAttr FirMemOpGenericAdaptorBase::getWuwAttr() {
  auto attr = ::llvm::cast<circt::seq::WUWAttr>(getProperties().wuw);
  return attr;
}

circt::seq::WUW FirMemOpGenericAdaptorBase::getWuw() {
  auto attr = getWuwAttr();
  return attr.getValue();
}

::mlir::StringAttr FirMemOpGenericAdaptorBase::getNameAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
  return attr;
}

::std::optional< ::llvm::StringRef > FirMemOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr FirMemOpGenericAdaptorBase::getInnerSymAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
  return attr;
}

::std::optional<::circt::hw::InnerSymAttr> FirMemOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

::circt::seq::FirMemInitAttr FirMemOpGenericAdaptorBase::getInitAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::seq::FirMemInitAttr>(getProperties().init);
  return attr;
}

::std::optional<::circt::seq::FirMemInitAttr> FirMemOpGenericAdaptorBase::getInit() {
  auto attr = getInitAttr();
  return attr ? ::std::optional<::circt::seq::FirMemInitAttr>(::llvm::cast<::circt::seq::FirMemInitAttr>(attr)) : (::std::nullopt);
}

::mlir::StringAttr FirMemOpGenericAdaptorBase::getPrefixAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().prefix);
  return attr;
}

::std::optional< ::llvm::StringRef > FirMemOpGenericAdaptorBase::getPrefix() {
  auto attr = getPrefixAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Attribute FirMemOpGenericAdaptorBase::getOutputFileAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::Attribute>(getProperties().output_file);
  return attr;
}

::std::optional<::mlir::Attribute> FirMemOpGenericAdaptorBase::getOutputFile() {
  auto attr = getOutputFileAttr();
  return attr ? ::std::optional<::mlir::Attribute>(attr) : (::std::nullopt);
}

} // namespace detail
FirMemOpAdaptor::FirMemOpAdaptor(FirMemOp op) : FirMemOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FirMemOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_init = getProperties().init; (void)tblgen_init;
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;
  auto tblgen_output_file = getProperties().output_file; (void)tblgen_output_file;
  auto tblgen_prefix = getProperties().prefix; (void)tblgen_prefix;
  auto tblgen_readLatency = getProperties().readLatency; (void)tblgen_readLatency;
  if (!tblgen_readLatency) return emitError(loc, "'seq.firmem' op ""requires attribute 'readLatency'");
  auto tblgen_ruw = getProperties().ruw; (void)tblgen_ruw;
  if (!tblgen_ruw) return emitError(loc, "'seq.firmem' op ""requires attribute 'ruw'");
  auto tblgen_writeLatency = getProperties().writeLatency; (void)tblgen_writeLatency;
  if (!tblgen_writeLatency) return emitError(loc, "'seq.firmem' op ""requires attribute 'writeLatency'");
  auto tblgen_wuw = getProperties().wuw; (void)tblgen_wuw;
  if (!tblgen_wuw) return emitError(loc, "'seq.firmem' op ""requires attribute 'wuw'");

  if (tblgen_readLatency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_readLatency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_readLatency).getType().isSignlessInteger(32)))))
    return emitError(loc, "'seq.firmem' op ""attribute 'readLatency' failed to satisfy constraint: 32-bit signless integer attribute");

  if (tblgen_writeLatency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_writeLatency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_writeLatency).getType().isSignlessInteger(32)))))
    return emitError(loc, "'seq.firmem' op ""attribute 'writeLatency' failed to satisfy constraint: 32-bit signless integer attribute");

  if (tblgen_ruw && !((::llvm::isa<circt::seq::RUWAttr>(tblgen_ruw))))
    return emitError(loc, "'seq.firmem' op ""attribute 'ruw' failed to satisfy constraint: Read-Under-Write Behavior");

  if (tblgen_wuw && !((::llvm::isa<circt::seq::WUWAttr>(tblgen_wuw))))
    return emitError(loc, "'seq.firmem' op ""attribute 'wuw' failed to satisfy constraint: Write-Under-Write Behavior");

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.firmem' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::circt::hw::InnerSymAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.firmem' op ""attribute 'inner_sym' failed to satisfy constraint: Inner symbol definition");

  if (tblgen_init && !((::llvm::isa<::circt::seq::FirMemInitAttr>(tblgen_init))))
    return emitError(loc, "'seq.firmem' op ""attribute 'init' failed to satisfy constraint: Memory initialization information");

  if (tblgen_prefix && !((::llvm::isa<::mlir::StringAttr>(tblgen_prefix))))
    return emitError(loc, "'seq.firmem' op ""attribute 'prefix' failed to satisfy constraint: string attribute");

  if (tblgen_output_file && !((true)))
    return emitError(loc, "'seq.firmem' op ""attribute 'output_file' failed to satisfy constraint: any attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range FirMemOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

std::pair<unsigned, unsigned> FirMemOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSResults(0).begin());
}

::mlir::LogicalResult FirMemOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.init;
       auto attr = dict.get("init");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for init in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `init` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.inner_sym;
       auto attr = dict.get("inner_sym");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for inner_sym in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `inner_sym` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.name;
       auto attr = dict.get("name");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for name in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `name` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.output_file;
       auto attr = dict.get("output_file");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for output_file in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `output_file` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.prefix;
       auto attr = dict.get("prefix");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for prefix in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `prefix` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.readLatency;
       auto attr = dict.get("readLatency");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for readLatency in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `readLatency` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.ruw;
       auto attr = dict.get("ruw");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for ruw in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `ruw` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.writeLatency;
       auto attr = dict.get("writeLatency");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for writeLatency in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `writeLatency` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.wuw;
       auto attr = dict.get("wuw");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for wuw in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `wuw` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute FirMemOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.init;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("init",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.inner_sym;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("inner_sym",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.name;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("name",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.output_file;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("output_file",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.prefix;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("prefix",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.readLatency;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("readLatency",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.ruw;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("ruw",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.writeLatency;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("writeLatency",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.wuw;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("wuw",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code FirMemOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.init.getAsOpaquePointer()), 
    llvm::hash_value(prop.inner_sym.getAsOpaquePointer()), 
    llvm::hash_value(prop.name.getAsOpaquePointer()), 
    llvm::hash_value(prop.output_file.getAsOpaquePointer()), 
    llvm::hash_value(prop.prefix.getAsOpaquePointer()), 
    llvm::hash_value(prop.readLatency.getAsOpaquePointer()), 
    llvm::hash_value(prop.ruw.getAsOpaquePointer()), 
    llvm::hash_value(prop.writeLatency.getAsOpaquePointer()), 
    llvm::hash_value(prop.wuw.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> FirMemOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "init")
      return prop.init;

    if (name == "inner_sym")
      return prop.inner_sym;

    if (name == "name")
      return prop.name;

    if (name == "output_file")
      return prop.output_file;

    if (name == "prefix")
      return prop.prefix;

    if (name == "readLatency")
      return prop.readLatency;

    if (name == "ruw")
      return prop.ruw;

    if (name == "writeLatency")
      return prop.writeLatency;

    if (name == "wuw")
      return prop.wuw;
  return std::nullopt;
}

void FirMemOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "init") {
       prop.init = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.init)>>(value);
       return;
    }

    if (name == "inner_sym") {
       prop.inner_sym = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.inner_sym)>>(value);
       return;
    }

    if (name == "name") {
       prop.name = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.name)>>(value);
       return;
    }

    if (name == "output_file") {
       prop.output_file = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.output_file)>>(value);
       return;
    }

    if (name == "prefix") {
       prop.prefix = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.prefix)>>(value);
       return;
    }

    if (name == "readLatency") {
       prop.readLatency = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.readLatency)>>(value);
       return;
    }

    if (name == "ruw") {
       prop.ruw = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.ruw)>>(value);
       return;
    }

    if (name == "writeLatency") {
       prop.writeLatency = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.writeLatency)>>(value);
       return;
    }

    if (name == "wuw") {
       prop.wuw = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.wuw)>>(value);
       return;
    }
}

void FirMemOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.init) attrs.append("init", prop.init);

    if (prop.inner_sym) attrs.append("inner_sym", prop.inner_sym);

    if (prop.name) attrs.append("name", prop.name);

    if (prop.output_file) attrs.append("output_file", prop.output_file);

    if (prop.prefix) attrs.append("prefix", prop.prefix);

    if (prop.readLatency) attrs.append("readLatency", prop.readLatency);

    if (prop.ruw) attrs.append("ruw", prop.ruw);

    if (prop.writeLatency) attrs.append("writeLatency", prop.writeLatency);

    if (prop.wuw) attrs.append("wuw", prop.wuw);
}

::mlir::LogicalResult FirMemOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getInitAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq9(attr, "init", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getInnerSymAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(attr, "inner_sym", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getNameAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "name", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getOutputFileAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq10(attr, "output_file", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getPrefixAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "prefix", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getReadLatencyAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq6(attr, "readLatency", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getRuwAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq7(attr, "ruw", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getWriteLatencyAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq6(attr, "writeLatency", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getWuwAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq8(attr, "wuw", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult FirMemOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.init)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.inner_sym)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.name)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.output_file)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.prefix)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.readLatency)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.ruw)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.writeLatency)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.wuw)))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.init);

  writer.writeOptionalAttribute(prop.inner_sym);

  writer.writeOptionalAttribute(prop.name);

  writer.writeOptionalAttribute(prop.output_file);

  writer.writeOptionalAttribute(prop.prefix);
  writer.writeAttribute(prop.readLatency);
  writer.writeAttribute(prop.ruw);
  writer.writeAttribute(prop.writeLatency);
  writer.writeAttribute(prop.wuw);
}

::mlir::IntegerAttr FirMemOp::getReadLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().readLatency);
}

uint32_t FirMemOp::getReadLatency() {
  auto attr = getReadLatencyAttr();
  return attr.getValue().getZExtValue();
}

::mlir::IntegerAttr FirMemOp::getWriteLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().writeLatency);
}

uint32_t FirMemOp::getWriteLatency() {
  auto attr = getWriteLatencyAttr();
  return attr.getValue().getZExtValue();
}

circt::seq::RUWAttr FirMemOp::getRuwAttr() {
  return ::llvm::cast<circt::seq::RUWAttr>(getProperties().ruw);
}

circt::seq::RUW FirMemOp::getRuw() {
  auto attr = getRuwAttr();
  return attr.getValue();
}

circt::seq::WUWAttr FirMemOp::getWuwAttr() {
  return ::llvm::cast<circt::seq::WUWAttr>(getProperties().wuw);
}

circt::seq::WUW FirMemOp::getWuw() {
  auto attr = getWuwAttr();
  return attr.getValue();
}

::mlir::StringAttr FirMemOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
}

::std::optional< ::llvm::StringRef > FirMemOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr FirMemOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
}

::std::optional<::circt::hw::InnerSymAttr> FirMemOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

::circt::seq::FirMemInitAttr FirMemOp::getInitAttr() {
  return ::llvm::dyn_cast_or_null<::circt::seq::FirMemInitAttr>(getProperties().init);
}

::std::optional<::circt::seq::FirMemInitAttr> FirMemOp::getInit() {
  auto attr = getInitAttr();
  return attr ? ::std::optional<::circt::seq::FirMemInitAttr>(::llvm::cast<::circt::seq::FirMemInitAttr>(attr)) : (::std::nullopt);
}

::mlir::StringAttr FirMemOp::getPrefixAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().prefix);
}

::std::optional< ::llvm::StringRef > FirMemOp::getPrefix() {
  auto attr = getPrefixAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::mlir::Attribute FirMemOp::getOutputFileAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::Attribute>(getProperties().output_file);
}

::std::optional<::mlir::Attribute> FirMemOp::getOutputFile() {
  auto attr = getOutputFileAttr();
  return attr ? ::std::optional<::mlir::Attribute>(attr) : (::std::nullopt);
}

void FirMemOp::setReadLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getReadLatencyAttrName(), attr);
}

void FirMemOp::setReadLatency(uint32_t attrValue) {
  (*this)->setAttr(getReadLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(32), attrValue));
}

void FirMemOp::setWriteLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getWriteLatencyAttrName(), attr);
}

void FirMemOp::setWriteLatency(uint32_t attrValue) {
  (*this)->setAttr(getWriteLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(32), attrValue));
}

void FirMemOp::setRuwAttr(circt::seq::RUWAttr attr) {
  (*this)->setAttr(getRuwAttrName(), attr);
}

void FirMemOp::setRuw(circt::seq::RUW attrValue) {
  (*this)->setAttr(getRuwAttrName(), circt::seq::RUWAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void FirMemOp::setWuwAttr(circt::seq::WUWAttr attr) {
  (*this)->setAttr(getWuwAttrName(), attr);
}

void FirMemOp::setWuw(circt::seq::WUW attrValue) {
  (*this)->setAttr(getWuwAttrName(), circt::seq::WUWAttr::get(::mlir::Builder((*this)->getContext()).getContext(), attrValue));
}

void FirMemOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void FirMemOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void FirMemOp::setInnerSymAttr(::circt::hw::InnerSymAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void FirMemOp::setInitAttr(::circt::seq::FirMemInitAttr attr) {
  (*this)->setAttr(getInitAttrName(), attr);
}

void FirMemOp::setPrefixAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getPrefixAttrName(), attr);
}

void FirMemOp::setPrefix(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getPrefixAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getPrefixAttrName());
}

void FirMemOp::setOutputFileAttr(::mlir::Attribute attr) {
  (*this)->setAttr(getOutputFileAttrName(), attr);
}

::mlir::Attribute FirMemOp::removeNameAttr() {
    auto &attr = getProperties().name;
    attr = {};
    return attr;
}

::mlir::Attribute FirMemOp::removeInnerSymAttr() {
    auto &attr = getProperties().inner_sym;
    attr = {};
    return attr;
}

::mlir::Attribute FirMemOp::removeInitAttr() {
    auto &attr = getProperties().init;
    attr = {};
    return attr;
}

::mlir::Attribute FirMemOp::removePrefixAttr() {
    auto &attr = getProperties().prefix;
    attr = {};
    return attr;
}

::mlir::Attribute FirMemOp::removeOutputFileAttr() {
    auto &attr = getProperties().output_file;
    attr = {};
    return attr;
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type memory, ::mlir::IntegerAttr readLatency, ::mlir::IntegerAttr writeLatency, circt::seq::RUWAttr ruw, circt::seq::WUWAttr wuw, /*optional*/::mlir::StringAttr name, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.getOrAddProperties<Properties>().readLatency = readLatency;
  odsState.getOrAddProperties<Properties>().writeLatency = writeLatency;
  odsState.getOrAddProperties<Properties>().ruw = ruw;
  odsState.getOrAddProperties<Properties>().wuw = wuw;
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  if (init) {
    odsState.getOrAddProperties<Properties>().init = init;
  }
  if (prefix) {
    odsState.getOrAddProperties<Properties>().prefix = prefix;
  }
  if (output_file) {
    odsState.getOrAddProperties<Properties>().output_file = output_file;
  }
  odsState.addTypes(memory);
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::IntegerAttr readLatency, ::mlir::IntegerAttr writeLatency, circt::seq::RUWAttr ruw, circt::seq::WUWAttr wuw, /*optional*/::mlir::StringAttr name, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.getOrAddProperties<Properties>().readLatency = readLatency;
  odsState.getOrAddProperties<Properties>().writeLatency = writeLatency;
  odsState.getOrAddProperties<Properties>().ruw = ruw;
  odsState.getOrAddProperties<Properties>().wuw = wuw;
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  if (init) {
    odsState.getOrAddProperties<Properties>().init = init;
  }
  if (prefix) {
    odsState.getOrAddProperties<Properties>().prefix = prefix;
  }
  if (output_file) {
    odsState.getOrAddProperties<Properties>().output_file = output_file;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type memory, uint32_t readLatency, uint32_t writeLatency, circt::seq::RUW ruw, circt::seq::WUW wuw, /*optional*/::mlir::StringAttr name, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.getOrAddProperties<Properties>().readLatency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), readLatency);
  odsState.getOrAddProperties<Properties>().writeLatency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), writeLatency);
  odsState.getOrAddProperties<Properties>().ruw = circt::seq::RUWAttr::get(odsBuilder.getContext(), ruw);
  odsState.getOrAddProperties<Properties>().wuw = circt::seq::WUWAttr::get(odsBuilder.getContext(), wuw);
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  if (init) {
    odsState.getOrAddProperties<Properties>().init = init;
  }
  if (prefix) {
    odsState.getOrAddProperties<Properties>().prefix = prefix;
  }
  if (output_file) {
    odsState.getOrAddProperties<Properties>().output_file = output_file;
  }
  odsState.addTypes(memory);
}

void FirMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, uint32_t readLatency, uint32_t writeLatency, circt::seq::RUW ruw, circt::seq::WUW wuw, /*optional*/::mlir::StringAttr name, /*optional*/::circt::hw::InnerSymAttr inner_sym, /*optional*/::circt::seq::FirMemInitAttr init, /*optional*/::mlir::StringAttr prefix, /*optional*/::mlir::Attribute output_file) {
  odsState.getOrAddProperties<Properties>().readLatency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), readLatency);
  odsState.getOrAddProperties<Properties>().writeLatency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(32), writeLatency);
  odsState.getOrAddProperties<Properties>().ruw = circt::seq::RUWAttr::get(odsBuilder.getContext(), ruw);
  odsState.getOrAddProperties<Properties>().wuw = circt::seq::WUWAttr::get(odsBuilder.getContext(), wuw);
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  if (init) {
    odsState.getOrAddProperties<Properties>().init = init;
  }
  if (prefix) {
    odsState.getOrAddProperties<Properties>().prefix = prefix;
  }
  if (output_file) {
    odsState.getOrAddProperties<Properties>().output_file = output_file;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 0u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult FirMemOp::verifyInvariantsImpl() {
  auto tblgen_init = getProperties().init; (void)tblgen_init;
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;
  auto tblgen_output_file = getProperties().output_file; (void)tblgen_output_file;
  auto tblgen_prefix = getProperties().prefix; (void)tblgen_prefix;
  auto tblgen_readLatency = getProperties().readLatency; (void)tblgen_readLatency;
  if (!tblgen_readLatency) return emitOpError("requires attribute 'readLatency'");
  auto tblgen_ruw = getProperties().ruw; (void)tblgen_ruw;
  if (!tblgen_ruw) return emitOpError("requires attribute 'ruw'");
  auto tblgen_writeLatency = getProperties().writeLatency; (void)tblgen_writeLatency;
  if (!tblgen_writeLatency) return emitOpError("requires attribute 'writeLatency'");
  auto tblgen_wuw = getProperties().wuw; (void)tblgen_wuw;
  if (!tblgen_wuw) return emitOpError("requires attribute 'wuw'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq6(*this, tblgen_readLatency, "readLatency")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq6(*this, tblgen_writeLatency, "writeLatency")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq7(*this, tblgen_ruw, "ruw")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq8(*this, tblgen_wuw, "wuw")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq9(*this, tblgen_init, "init")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_prefix, "prefix")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq10(*this, tblgen_output_file, "output_file")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult FirMemOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult FirMemOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::circt::hw::InnerSymAttr inner_symAttr;
  ::mlir::StringAttr nameAttr;
  ::mlir::IntegerAttr readLatencyAttr;
  ::mlir::IntegerAttr writeLatencyAttr;
  circt::seq::RUWAttr ruwAttr;
  circt::seq::WUWAttr wuwAttr;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);
  if (::mlir::succeeded(parser.parseOptionalKeyword("sym"))) {

  if (parser.parseCustomAttributeWithFallback(inner_symAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (inner_symAttr) result.getOrAddProperties<FirMemOp::Properties>().inner_sym = inner_symAttr;
  }
  {
    auto odsResult = parseImplicitSSAName(parser, nameAttr);
    if (odsResult) return ::mlir::failure();
    if (nameAttr)
      result.getOrAddProperties<FirMemOp::Properties>().name = nameAttr;
  }

  if (parser.parseCustomAttributeWithFallback(readLatencyAttr, parser.getBuilder().getIntegerType(32))) {
    return ::mlir::failure();
  }
  if (readLatencyAttr) result.getOrAddProperties<FirMemOp::Properties>().readLatency = readLatencyAttr;
  if (parser.parseComma())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(writeLatencyAttr, parser.getBuilder().getIntegerType(32))) {
    return ::mlir::failure();
  }
  if (writeLatencyAttr) result.getOrAddProperties<FirMemOp::Properties>().writeLatency = writeLatencyAttr;
  if (parser.parseComma())
    return ::mlir::failure();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"undefined","old","new"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "ruw", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'ruw' [undefined, old, new]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = circt::seq::symbolizeRUW(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "ruw attribute specification: \"" << attrStr << '"';;

      ruwAttr = circt::seq::RUWAttr::get(parser.getBuilder().getContext(), *attrOptional);
        result.getOrAddProperties<FirMemOp::Properties>().ruw = ruwAttr;
    }
  }
  if (parser.parseComma())
    return ::mlir::failure();

  {
    ::llvm::StringRef attrStr;
    ::mlir::NamedAttrList attrStorage;
    auto loc = parser.getCurrentLocation();
    if (parser.parseOptionalKeyword(&attrStr, {"undefined","port_order"})) {
      ::mlir::StringAttr attrVal;
      ::mlir::OptionalParseResult parseResult =
        parser.parseOptionalAttribute(attrVal,
                                      parser.getBuilder().getNoneType(),
                                      "wuw", attrStorage);
      if (parseResult.has_value()) {
        if (failed(*parseResult))
          return ::mlir::failure();
        attrStr = attrVal.getValue();
      } else {
        return parser.emitError(loc, "expected string or keyword containing one of the following enum values for attribute 'wuw' [undefined, port_order]");
      }
    }
    if (!attrStr.empty()) {
      auto attrOptional = circt::seq::symbolizeWUW(attrStr);
      if (!attrOptional)
        return parser.emitError(loc, "invalid ")
               << "wuw attribute specification: \"" << attrStr << '"';;

      wuwAttr = circt::seq::WUWAttr::get(parser.getBuilder().getContext(), *attrOptional);
        result.getOrAddProperties<FirMemOp::Properties>().wuw = wuwAttr;
    }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  result.addTypes(memoryTypes);
  return ::mlir::success();
}

void FirMemOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  if (getInnerSymAttr()) {
    _odsPrinter << ' ' << "sym";
    _odsPrinter << ' ';
  _odsPrinter.printStrippedAttrOrType(getInnerSymAttr());
  }
  printImplicitSSAName(_odsPrinter, *this, getNameAttr());
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getReadLatencyAttr());
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter.printAttributeWithoutType(getWriteLatencyAttr());
  _odsPrinter << ",";
  _odsPrinter << ' ';

  {
    auto caseValue = getRuw();
    auto caseValueStr = stringifyRUW(caseValue);
    _odsPrinter << caseValueStr;
  }
  _odsPrinter << ",";
  _odsPrinter << ' ';

  {
    auto caseValue = getWuw();
    auto caseValueStr = stringifyWUW(caseValue);
    _odsPrinter << caseValueStr;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("name");
  elidedAttrs.push_back("readLatency");
  elidedAttrs.push_back("writeLatency");
  elidedAttrs.push_back("ruw");
  elidedAttrs.push_back("wuw");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

void FirMemOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Allocate::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemReadOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemReadOpGenericAdaptorBase::FirMemReadOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem.read_port", odsAttrs.getContext());
}

FirMemReadOpGenericAdaptorBase::FirMemReadOpGenericAdaptorBase(FirMemReadOp op) : FirMemReadOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FirMemReadOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr FirMemReadOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FirMemReadOpAdaptor::FirMemReadOpAdaptor(FirMemReadOp op) : FirMemReadOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FirMemReadOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemReadOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, false, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range FirMemReadOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemReadOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getAddress() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> FirMemReadOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getEnable() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::OpOperand &FirMemReadOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemReadOp::getAddressMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemReadOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange FirMemReadOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> FirMemReadOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemReadOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadOp::getData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(0).begin());
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  odsState.addTypes(data);
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(FirMemReadOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemReadOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void FirMemReadOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(FirMemReadOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult FirMemReadOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getDepth())))
    , (*this->getODSOperands(1).begin()).getType()))))
    return emitOpError("failed to verify that address type should match clog2 of memory depth");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSResults(0).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  return ::mlir::success();
}

::mlir::LogicalResult FirMemReadOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void FirMemReadOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FirMemReadOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = 
      IntegerType::get(
        operands[0].getType().getContext(),
        std::max(1U, cast<FirMemType>(operands[0].getType()).getWidth()))
    ;
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult FirMemReadOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand memoryRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> memoryOperands(memoryRawOperands);  ::llvm::SMLoc memoryOperandsLoc;
  (void)memoryOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand addressRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> addressOperands(addressRawOperands);  ::llvm::SMLoc addressOperandsLoc;
  (void)addressOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> enableOperands;
  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);

  memoryOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(memoryRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseLSquare())
    return ::mlir::failure();

  addressOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(addressRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("enable"))) {

  {
    enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      enableOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  for (::mlir::Type type : memoryTypes) {
    (void)type;
    if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'memory' must be A FIRRTL-flavored memory, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    );
  if (parser.resolveOperands(memoryOperands, memoryTypes, memoryOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(addressOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>(memoryTypes[0]).getDepth())))
    , addressOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType1, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemReadOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getMemory();
  _odsPrinter << "[";
  _odsPrinter << getAddress();
  _odsPrinter << "]";
  _odsPrinter << ",";
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  if (getEnable()) {
    _odsPrinter << ' ' << "enable";
    _odsPrinter << ' ';
    if (::mlir::Value value = getEnable())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

void FirMemReadOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Read::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemReadOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemReadWriteOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemReadWriteOpGenericAdaptorBase::FirMemReadWriteOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem.read_write_port", odsAttrs.getContext());
}

FirMemReadWriteOpGenericAdaptorBase::FirMemReadWriteOpGenericAdaptorBase(FirMemReadWriteOp op) : FirMemReadWriteOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FirMemReadWriteOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr FirMemReadWriteOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FirMemReadWriteOpAdaptor::FirMemReadWriteOpAdaptor(FirMemReadWriteOp op) : FirMemReadWriteOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FirMemReadWriteOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemReadWriteOp::getODSOperandIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range FirMemReadWriteOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemReadWriteOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getAddress() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> FirMemReadWriteOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getEnable() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getWriteData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getMode() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(5).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getMask() {
  auto operands = getODSOperands(6);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::OpOperand &FirMemReadWriteOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemReadWriteOp::getAddressMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemReadWriteOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange FirMemReadWriteOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::OpOperand &FirMemReadWriteOp::getWriteDataMutable() {
  auto range = getODSOperandIndexAndLength(4);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemReadWriteOp::getModeMutable() {
  auto range = getODSOperandIndexAndLength(5);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange FirMemReadWriteOp::getMaskMutable() {
  auto range = getODSOperandIndexAndLength(6);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(6u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

std::pair<unsigned, unsigned> FirMemReadWriteOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemReadWriteOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> FirMemReadWriteOp::getReadData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(0).begin());
}

::mlir::LogicalResult FirMemReadWriteOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }
    ;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("operandSegmentSizes");   if (!attr) attr = dict.get("operand_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for operandSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.operandSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute FirMemReadWriteOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.operandSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("operandSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code FirMemReadWriteOp::computePropertiesHash(const Properties &prop) {
  auto hash_operandSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    hash_operandSegmentSizes(prop.operandSegmentSizes));
}

std::optional<mlir::Attribute> FirMemReadWriteOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "operand_segment_sizes" || name == "operandSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes);
  return std::nullopt;
}

void FirMemReadWriteOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
        if (name == "operand_segment_sizes" || name == "operandSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.operandSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.operandSegmentSizes.begin());
       return;
    }
}

void FirMemReadWriteOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
  attrs.append("operandSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes));
}

::mlir::LogicalResult FirMemReadWriteOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    return ::mlir::success();
}

::mlir::LogicalResult FirMemReadWriteOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.operandSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.operandSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void FirMemReadWriteOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.operandSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.operandSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type readData, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable, ::mlir::Value writeData, ::mlir::Value mode, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(writeData);
  odsState.addOperands(mode);
  if (mask)
    odsState.addOperands(mask);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (enable ? 1 : 0), 1, 1, (mask ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.addTypes(readData);
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable, ::mlir::Value writeData, ::mlir::Value mode, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(writeData);
  odsState.addOperands(mode);
  if (mask)
    odsState.addOperands(mask);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (enable ? 1 : 0), 1, 1, (mask ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(FirMemReadWriteOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable, ::mlir::Value writeData, ::mlir::Value mode, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(writeData);
  odsState.addOperands(mode);
  if (mask)
    odsState.addOperands(mask);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (enable ? 1 : 0), 1, 1, (mask ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 5u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void FirMemReadWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 5u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(FirMemReadWriteOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult FirMemReadWriteOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup5 = getODSOperands(5);

    for (auto v : valueGroup5) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup6 = getODSOperands(6);

    if (valueGroup6.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup6.size();
    }

    for (auto v : valueGroup6) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getDepth())))
    , (*this->getODSOperands(1).begin()).getType()))))
    return emitOpError("failed to verify that address type should match clog2 of memory depth");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSOperands(4).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSResults(0).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  return ::mlir::success();
}

::mlir::LogicalResult FirMemReadWriteOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void FirMemReadWriteOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FirMemReadWriteOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = 
      IntegerType::get(
        operands[0].getType().getContext(),
        std::max(1U, cast<FirMemType>(operands[0].getType()).getWidth()))
    ;
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult FirMemReadWriteOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand memoryRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> memoryOperands(memoryRawOperands);  ::llvm::SMLoc memoryOperandsLoc;
  (void)memoryOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand addressRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> addressOperands(addressRawOperands);  ::llvm::SMLoc addressOperandsLoc;
  (void)addressOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand writeDataRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> writeDataOperands(writeDataRawOperands);  ::llvm::SMLoc writeDataOperandsLoc;
  (void)writeDataOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand modeRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> modeOperands(modeRawOperands);  ::llvm::SMLoc modeOperandsLoc;
  (void)modeOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> enableOperands;
  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> maskOperands;
  ::llvm::SMLoc maskOperandsLoc;
  (void)maskOperandsLoc;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> maskTypes;

  memoryOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(memoryRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseLSquare())
    return ::mlir::failure();

  addressOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(addressRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (parser.parseEqual())
    return ::mlir::failure();

  writeDataOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(writeDataRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseKeyword("if"))
    return ::mlir::failure();

  modeOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(modeRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("enable"))) {

  {
    enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      enableOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("mask"))) {

  {
    maskOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  if (::mlir::succeeded(parser.parseOptionalComma())) {

  {
    ::mlir::Type optionalType;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalType(optionalType);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskTypes.push_back(optionalType);
    }
  }
  }
::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, static_cast<int32_t>(enableOperands.size()), 1, 1, static_cast<int32_t>(maskOperands.size())}), result.getOrAddProperties<FirMemReadWriteOp::Properties>().operandSegmentSizes.begin());
  for (::mlir::Type type : memoryTypes) {
    (void)type;
    if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'memory' must be A FIRRTL-flavored memory, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    );
  if (parser.resolveOperands(memoryOperands, memoryTypes, memoryOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(addressOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>(memoryTypes[0]).getDepth())))
    , addressOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType1, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(writeDataOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    , writeDataOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(modeOperands, odsBuildableType1, modeOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(maskOperands, maskTypes, maskOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemReadWriteOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getMemory();
  _odsPrinter << "[";
  _odsPrinter << getAddress();
  _odsPrinter << "]";
  _odsPrinter << ' ' << "=";
  _odsPrinter << ' ';
  _odsPrinter << getWriteData();
  _odsPrinter << ' ' << "if";
  _odsPrinter << ' ';
  _odsPrinter << getMode();
  _odsPrinter << ",";
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  if (getEnable()) {
    _odsPrinter << ' ' << "enable";
    _odsPrinter << ' ';
    if (::mlir::Value value = getEnable())
      _odsPrinter << value;
  }
  if (getMask()) {
    _odsPrinter << ' ' << "mask";
    _odsPrinter << ' ';
    if (::mlir::Value value = getMask())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operandSegmentSizes");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  if (getMask()) {
    _odsPrinter << ",";
    _odsPrinter << ' ';
    _odsPrinter << (getMask() ? ::llvm::ArrayRef<::mlir::Type>(getMask().getType()) : ::llvm::ArrayRef<::mlir::Type>());
  }
}

void FirMemReadWriteOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Read::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
  effects.emplace_back(::mlir::MemoryEffects::Write::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemReadWriteOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirMemWriteOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirMemWriteOpGenericAdaptorBase::FirMemWriteOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firmem.write_port", odsAttrs.getContext());
}

FirMemWriteOpGenericAdaptorBase::FirMemWriteOpGenericAdaptorBase(FirMemWriteOp op) : FirMemWriteOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FirMemWriteOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr FirMemWriteOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FirMemWriteOpAdaptor::FirMemWriteOpAdaptor(FirMemWriteOp op) : FirMemWriteOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FirMemWriteOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirMemWriteOp::getODSOperandIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range FirMemWriteOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::FirMemType> FirMemWriteOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::FirMemType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getAddress() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> FirMemWriteOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getEnable() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getData() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(4).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirMemWriteOp::getMask() {
  auto operands = getODSOperands(5);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::OpOperand &FirMemWriteOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemWriteOp::getAddressMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirMemWriteOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange FirMemWriteOp::getEnableMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::OpOperand &FirMemWriteOp::getDataMutable() {
  auto range = getODSOperandIndexAndLength(4);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange FirMemWriteOp::getMaskMutable() {
  auto range = getODSOperandIndexAndLength(5);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(5u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

std::pair<unsigned, unsigned> FirMemWriteOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirMemWriteOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::LogicalResult FirMemWriteOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }
    ;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("operandSegmentSizes");   if (!attr) attr = dict.get("operand_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for operandSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.operandSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute FirMemWriteOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.operandSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("operandSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code FirMemWriteOp::computePropertiesHash(const Properties &prop) {
  auto hash_operandSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    hash_operandSegmentSizes(prop.operandSegmentSizes));
}

std::optional<mlir::Attribute> FirMemWriteOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "operand_segment_sizes" || name == "operandSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes);
  return std::nullopt;
}

void FirMemWriteOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
        if (name == "operand_segment_sizes" || name == "operandSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.operandSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.operandSegmentSizes.begin());
       return;
    }
}

void FirMemWriteOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
  attrs.append("operandSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes));
}

::mlir::LogicalResult FirMemWriteOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    return ::mlir::success();
}

::mlir::LogicalResult FirMemWriteOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.operandSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.operandSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void FirMemWriteOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.operandSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.operandSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

void FirMemWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable, ::mlir::Value data, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(data);
  if (mask)
    odsState.addOperands(mask);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (enable ? 1 : 0), 1, (mask ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
}

void FirMemWriteOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::Value address, ::mlir::Value clk, /*optional*/::mlir::Value enable, ::mlir::Value data, /*optional*/::mlir::Value mask) {
  odsState.addOperands(memory);
  odsState.addOperands(address);
  odsState.addOperands(clk);
  if (enable)
    odsState.addOperands(enable);
  odsState.addOperands(data);
  if (mask)
    odsState.addOperands(mask);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (enable ? 1 : 0), 1, (mask ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FirMemWriteOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 4u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult FirMemWriteOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq4(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup5 = getODSOperands(5);

    if (valueGroup5.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup5.size();
    }

    for (auto v : valueGroup5) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq5(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getDepth())))
    , (*this->getODSOperands(1).begin()).getType()))))
    return emitOpError("failed to verify that address type should match clog2 of memory depth");
  if (!((std::equal_to<>()(
      IntegerType::get(
        (*this->getODSOperands(0).begin()).getType().getContext(),
        std::max(1U, cast<FirMemType>((*this->getODSOperands(0).begin()).getType()).getWidth()))
    , (*this->getODSOperands(4).begin()).getType()))))
    return emitOpError("failed to verify that data type should match memory width");
  return ::mlir::success();
}

::mlir::LogicalResult FirMemWriteOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void FirMemWriteOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::ParseResult FirMemWriteOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand memoryRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> memoryOperands(memoryRawOperands);  ::llvm::SMLoc memoryOperandsLoc;
  (void)memoryOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand addressRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> addressOperands(addressRawOperands);  ::llvm::SMLoc addressOperandsLoc;
  (void)addressOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand dataRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> dataOperands(dataRawOperands);  ::llvm::SMLoc dataOperandsLoc;
  (void)dataOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> enableOperands;
  ::llvm::SMLoc enableOperandsLoc;
  (void)enableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> maskOperands;
  ::llvm::SMLoc maskOperandsLoc;
  (void)maskOperandsLoc;
  ::mlir::Type memoryRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> memoryTypes(memoryRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> maskTypes;

  memoryOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(memoryRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseLSquare())
    return ::mlir::failure();

  addressOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(addressRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (parser.parseEqual())
    return ::mlir::failure();

  dataOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(dataRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();
  if (parser.parseKeyword("clock"))
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("enable"))) {

  {
    enableOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      enableOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("mask"))) {

  {
    maskOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::FirMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    memoryRawTypes[0] = type;
  }
  if (::mlir::succeeded(parser.parseOptionalComma())) {

  {
    ::mlir::Type optionalType;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalType(optionalType);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      maskTypes.push_back(optionalType);
    }
  }
  }
::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, static_cast<int32_t>(enableOperands.size()), 1, static_cast<int32_t>(maskOperands.size())}), result.getOrAddProperties<FirMemWriteOp::Properties>().operandSegmentSizes.begin());
  for (::mlir::Type type : memoryTypes) {
    (void)type;
    if (!((::llvm::isa<::circt::seq::FirMemType>(type)))) {
      return parser.emitError(parser.getNameLoc()) << "'memory' must be A FIRRTL-flavored memory, but got " << type;
    }
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  if (parser.resolveOperands(memoryOperands, memoryTypes, memoryOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(addressOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, llvm::Log2_64_Ceil(cast<FirMemType>(memoryTypes[0]).getDepth())))
    , addressOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(enableOperands, odsBuildableType1, enableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(dataOperands, 
      IntegerType::get(
        memoryTypes[0].getContext(),
        std::max(1U, cast<FirMemType>(memoryTypes[0]).getWidth()))
    , dataOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(maskOperands, maskTypes, maskOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirMemWriteOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getMemory();
  _odsPrinter << "[";
  _odsPrinter << getAddress();
  _odsPrinter << "]";
  _odsPrinter << ' ' << "=";
  _odsPrinter << ' ';
  _odsPrinter << getData();
  _odsPrinter << ",";
  _odsPrinter << ' ' << "clock";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  if (getEnable()) {
    _odsPrinter << ' ' << "enable";
    _odsPrinter << ' ';
    if (::mlir::Value value = getEnable())
      _odsPrinter << value;
  }
  if (getMask()) {
    _odsPrinter << ' ' << "mask";
    _odsPrinter << ' ';
    if (::mlir::Value value = getMask())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operandSegmentSizes");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getMemory().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::FirMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  if (getMask()) {
    _odsPrinter << ",";
    _odsPrinter << ' ';
    _odsPrinter << (getMask() ? ::llvm::ArrayRef<::mlir::Type>(getMask().getType()) : ::llvm::ArrayRef<::mlir::Type>());
  }
}

void FirMemWriteOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Write::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirMemWriteOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FirRegOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FirRegOpGenericAdaptorBase::FirRegOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.firreg", odsAttrs.getContext());
}

FirRegOpGenericAdaptorBase::FirRegOpGenericAdaptorBase(FirRegOp op) : FirRegOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FirRegOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 2) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr FirRegOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr FirRegOpGenericAdaptorBase::getNameAttr() {
  auto attr = ::llvm::cast<::mlir::StringAttr>(getProperties().name);
  return attr;
}

::llvm::StringRef FirRegOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::circt::hw::InnerSymAttr FirRegOpGenericAdaptorBase::getInnerSymAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
  return attr;
}

::std::optional<::circt::hw::InnerSymAttr> FirRegOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

::mlir::IntegerAttr FirRegOpGenericAdaptorBase::getPresetAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(getProperties().preset);
  return attr;
}

::std::optional< ::mlir::APInt > FirRegOpGenericAdaptorBase::getPreset() {
  auto attr = getPresetAttr();
  return attr ? ::std::optional< ::mlir::APInt >(attr.getValue()) : (::std::nullopt);
}

::mlir::UnitAttr FirRegOpGenericAdaptorBase::getIsAsyncAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::UnitAttr>(getProperties().isAsync);
  if (!attr)
    attr = ((false) ? ::mlir::Builder(odsAttrs.getContext()).getUnitAttr() : nullptr);
  return attr;
}

bool FirRegOpGenericAdaptorBase::getIsAsync() {
  auto attr = getIsAsyncAttr();
    if (!attr)
      return ((false) ? ::mlir::Builder(odsAttrs.getContext()).getUnitAttr() : nullptr) != nullptr;
  return attr != nullptr;
}

} // namespace detail
FirRegOpAdaptor::FirRegOpAdaptor(FirRegOp op) : FirRegOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FirRegOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_isAsync = getProperties().isAsync; (void)tblgen_isAsync;
  auto tblgen_name = getProperties().name; (void)tblgen_name;
  if (!tblgen_name) return emitError(loc, "'seq.firreg' op ""requires attribute 'name'");
  auto tblgen_preset = getProperties().preset; (void)tblgen_preset;

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.firreg' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::circt::hw::InnerSymAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.firreg' op ""attribute 'inner_sym' failed to satisfy constraint: Inner symbol definition");

  if (tblgen_preset && !((::llvm::isa<::mlir::IntegerAttr>(tblgen_preset))))
    return emitError(loc, "'seq.firreg' op ""attribute 'preset' failed to satisfy constraint: arbitrary integer attribute");

  if (tblgen_isAsync && !((::llvm::isa<::mlir::UnitAttr>(tblgen_isAsync))))
    return emitError(loc, "'seq.firreg' op ""attribute 'isAsync' failed to satisfy constraint: unit attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FirRegOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, false, true, true};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 2) / 2;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range FirRegOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value FirRegOp::getNext() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> FirRegOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> FirRegOp::getReset() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value FirRegOp::getResetValue() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::OpOperand &FirRegOp::getNextMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &FirRegOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange FirRegOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::MutableOperandRange FirRegOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

std::pair<unsigned, unsigned> FirRegOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FirRegOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value FirRegOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::LogicalResult FirRegOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.inner_sym;
       auto attr = dict.get("inner_sym");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for inner_sym in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `inner_sym` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.isAsync;
       auto attr = dict.get("isAsync");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for isAsync in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `isAsync` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.name;
       auto attr = dict.get("name");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for name in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `name` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.preset;
       auto attr = dict.get("preset");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for preset in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `preset` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute FirRegOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.inner_sym;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("inner_sym",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.isAsync;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("isAsync",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.name;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("name",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.preset;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("preset",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code FirRegOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.inner_sym.getAsOpaquePointer()), 
    llvm::hash_value(prop.isAsync.getAsOpaquePointer()), 
    llvm::hash_value(prop.name.getAsOpaquePointer()), 
    llvm::hash_value(prop.preset.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> FirRegOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "inner_sym")
      return prop.inner_sym;

    if (name == "isAsync")
      return prop.isAsync;

    if (name == "name")
      return prop.name;

    if (name == "preset")
      return prop.preset;
  return std::nullopt;
}

void FirRegOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "inner_sym") {
       prop.inner_sym = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.inner_sym)>>(value);
       return;
    }

    if (name == "isAsync") {
       prop.isAsync = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.isAsync)>>(value);
       return;
    }

    if (name == "name") {
       prop.name = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.name)>>(value);
       return;
    }

    if (name == "preset") {
       prop.preset = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.preset)>>(value);
       return;
    }
}

void FirRegOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.inner_sym) attrs.append("inner_sym", prop.inner_sym);

    if (prop.isAsync) attrs.append("isAsync", prop.isAsync);

    if (prop.name) attrs.append("name", prop.name);

    if (prop.preset) attrs.append("preset", prop.preset);
}

::mlir::LogicalResult FirRegOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getInnerSymAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(attr, "inner_sym", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getIsAsyncAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq12(attr, "isAsync", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getNameAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "name", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getPresetAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq11(attr, "preset", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult FirRegOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.inner_sym)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.isAsync)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.name)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.preset)))
    return ::mlir::failure();
  return ::mlir::success();
}

void FirRegOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.inner_sym);

  writer.writeOptionalAttribute(prop.isAsync);
  writer.writeAttribute(prop.name);

  writer.writeOptionalAttribute(prop.preset);
}

::mlir::StringAttr FirRegOp::getNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(getProperties().name);
}

::llvm::StringRef FirRegOp::getName() {
  auto attr = getNameAttr();
  return attr.getValue();
}

::circt::hw::InnerSymAttr FirRegOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
}

::std::optional<::circt::hw::InnerSymAttr> FirRegOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

::mlir::IntegerAttr FirRegOp::getPresetAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::IntegerAttr>(getProperties().preset);
}

::std::optional< ::mlir::APInt > FirRegOp::getPreset() {
  auto attr = getPresetAttr();
  return attr ? ::std::optional< ::mlir::APInt >(attr.getValue()) : (::std::nullopt);
}

::mlir::UnitAttr FirRegOp::getIsAsyncAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::UnitAttr>(getProperties().isAsync);
}

bool FirRegOp::getIsAsync() {
  auto attr = getIsAsyncAttr();
    if (!attr)
      return ((false) ? ::mlir::Builder((*this)->getContext()).getUnitAttr() : nullptr) != nullptr;
  return attr != nullptr;
}

void FirRegOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void FirRegOp::setName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void FirRegOp::setInnerSymAttr(::circt::hw::InnerSymAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

void FirRegOp::setPresetAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getPresetAttrName(), attr);
}

void FirRegOp::setIsAsyncAttr(::mlir::UnitAttr attr) {
  (*this)->setAttr(getIsAsyncAttrName(), attr);
}

void FirRegOp::setIsAsync(bool attrValue) {
    if (attrValue)
      return (*this)->setAttr(getIsAsyncAttrName(), ((attrValue) ? ::mlir::Builder((*this)->getContext()).getUnitAttr() : nullptr));
    (*this)->removeAttr(getIsAsyncAttrName());
}

::mlir::Attribute FirRegOp::removeInnerSymAttr() {
    auto &attr = getProperties().inner_sym;
    attr = {};
    return attr;
}

::mlir::Attribute FirRegOp::removePresetAttr() {
    auto &attr = getProperties().preset;
    attr = {};
    return attr;
}

::mlir::Attribute FirRegOp::removeIsAsyncAttr() {
    auto &attr = getProperties().isAsync;
    attr = {};
    return attr;
}

::mlir::LogicalResult FirRegOp::verifyInvariantsImpl() {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_isAsync = getProperties().isAsync; (void)tblgen_isAsync;
  auto tblgen_name = getProperties().name; (void)tblgen_name;
  if (!tblgen_name) return emitOpError("requires attribute 'name'");
  auto tblgen_preset = getProperties().preset; (void)tblgen_preset;

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq11(*this, tblgen_preset, "preset")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq12(*this, tblgen_isAsync, "isAsync")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {next, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult FirRegOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

void FirRegOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FirRegOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

void FirRegOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
  effects.emplace_back(::mlir::MemoryEffects::Write::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
  effects.emplace_back(::mlir::MemoryEffects::Read::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
  effects.emplace_back(::mlir::MemoryEffects::Allocate::get(), 0, false, ::mlir::SideEffects::DefaultResource::get());
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FirRegOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::FromClockOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
FromClockOpGenericAdaptorBase::FromClockOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.from_clock", odsAttrs.getContext());
}

FromClockOpGenericAdaptorBase::FromClockOpGenericAdaptorBase(FromClockOp op) : FromClockOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> FromClockOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr FromClockOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
FromClockOpAdaptor::FromClockOpAdaptor(FromClockOp op) : FromClockOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult FromClockOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> FromClockOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range FromClockOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> FromClockOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(0).begin());
}

::mlir::OpOperand &FromClockOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> FromClockOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range FromClockOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> FromClockOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSResults(0).begin());
}

void FromClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input) {
  odsState.addOperands(input);
  odsState.addTypes(output);
}

void FromClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input) {
  odsState.addOperands(input);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(FromClockOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void FromClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input) {
  odsState.addOperands(input);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void FromClockOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void FromClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(FromClockOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult FromClockOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult FromClockOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void FromClockOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult FromClockOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getIntegerType(1);
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult FromClockOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getIntegerType(1);
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getType<::circt::seq::ClockType>();
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(inputOperands, odsBuildableType1, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void FromClockOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void FromClockOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::FromClockOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::HLMemOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
HLMemOpGenericAdaptorBase::HLMemOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.hlmem", odsAttrs.getContext());
}

HLMemOpGenericAdaptorBase::HLMemOpGenericAdaptorBase(HLMemOp op) : HLMemOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> HLMemOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr HLMemOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::StringAttr HLMemOpGenericAdaptorBase::getSymNameAttr() {
  auto attr = ::llvm::cast<::mlir::StringAttr>(getProperties().sym_name);
  return attr;
}

::llvm::StringRef HLMemOpGenericAdaptorBase::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

} // namespace detail
HLMemOpAdaptor::HLMemOpAdaptor(HLMemOp op) : HLMemOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult HLMemOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_sym_name = getProperties().sym_name; (void)tblgen_sym_name;
  if (!tblgen_sym_name) return emitError(loc, "'seq.hlmem' op ""requires attribute 'sym_name'");

  if (tblgen_sym_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_sym_name))))
    return emitError(loc, "'seq.hlmem' op ""attribute 'sym_name' failed to satisfy constraint: string attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> HLMemOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range HLMemOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> HLMemOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::mlir::IntegerType> HLMemOp::getRst() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(1).begin());
}

::mlir::OpOperand &HLMemOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &HLMemOp::getRstMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> HLMemOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range HLMemOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::HLMemType> HLMemOp::getHandle() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::HLMemType>>(*getODSResults(0).begin());
}

::mlir::LogicalResult HLMemOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.sym_name;
       auto attr = dict.get("sym_name");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for sym_name in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `sym_name` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute HLMemOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.sym_name;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("sym_name",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code HLMemOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.sym_name.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> HLMemOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "sym_name")
      return prop.sym_name;
  return std::nullopt;
}

void HLMemOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "sym_name") {
       prop.sym_name = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.sym_name)>>(value);
       return;
    }
}

void HLMemOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.sym_name) attrs.append("sym_name", prop.sym_name);
}

::mlir::LogicalResult HLMemOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getSymNameAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "sym_name", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult HLMemOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readAttribute(prop.sym_name)))
    return ::mlir::failure();
  return ::mlir::success();
}

void HLMemOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;
  writer.writeAttribute(prop.sym_name);
}

::mlir::StringAttr HLMemOp::getSymNameAttr() {
  return ::llvm::cast<::mlir::StringAttr>(getProperties().sym_name);
}

::llvm::StringRef HLMemOp::getSymName() {
  auto attr = getSymNameAttr();
  return attr.getValue();
}

void HLMemOp::setSymNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getSymNameAttrName(), attr);
}

void HLMemOp::setSymName(::llvm::StringRef attrValue) {
  (*this)->setAttr(getSymNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(attrValue));
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type handle, ::mlir::Value clk, ::mlir::Value rst, ::mlir::StringAttr sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().sym_name = sym_name;
  odsState.addTypes(handle);
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::mlir::StringAttr sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().sym_name = sym_name;
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type handle, ::mlir::Value clk, ::mlir::Value rst, ::llvm::StringRef sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().sym_name = odsBuilder.getStringAttr(sym_name);
  odsState.addTypes(handle);
}

void HLMemOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value clk, ::mlir::Value rst, ::llvm::StringRef sym_name) {
  odsState.addOperands(clk);
  odsState.addOperands(rst);
  odsState.getOrAddProperties<Properties>().sym_name = odsBuilder.getStringAttr(sym_name);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void HLMemOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 2u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult HLMemOp::verifyInvariantsImpl() {
  auto tblgen_sym_name = getProperties().sym_name; (void)tblgen_sym_name;
  if (!tblgen_sym_name) return emitOpError("requires attribute 'sym_name'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_sym_name, "sym_name")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq6(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult HLMemOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

::mlir::ParseResult HLMemOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::StringAttr sym_nameAttr;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand rstRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> rstOperands(rstRawOperands);  ::llvm::SMLoc rstOperandsLoc;
  (void)rstOperandsLoc;
  ::mlir::Type handleRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> handleTypes(handleRawTypes);

  if (parser.parseSymbolName(sym_nameAttr))
    return ::mlir::failure();
  if (sym_nameAttr) result.getOrAddProperties<HLMemOp::Properties>().sym_name = sym_nameAttr;

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  rstOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(rstRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::circt::seq::HLMemType type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    handleRawTypes[0] = type;
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(handleTypes);
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(rstOperands, odsBuildableType1, rstOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void HLMemOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter.printSymbolName(getSymNameAttr().getValue());
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getRst();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("sym_name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getHandle().getType();
    if (auto validType = ::llvm::dyn_cast<::circt::seq::HLMemType>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::HLMemOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ReadPortOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ReadPortOpGenericAdaptorBase::ReadPortOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.read", odsAttrs.getContext());
}

ReadPortOpGenericAdaptorBase::ReadPortOpGenericAdaptorBase(ReadPortOp op) : ReadPortOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ReadPortOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr ReadPortOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr ReadPortOpGenericAdaptorBase::getLatencyAttr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().latency);
  return attr;
}

uint64_t ReadPortOpGenericAdaptorBase::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
ReadPortOpAdaptor::ReadPortOpAdaptor(ReadPortOp op) : ReadPortOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ReadPortOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_latency = getProperties().latency; (void)tblgen_latency;
  if (!tblgen_latency) return emitError(loc, "'seq.read' op ""requires attribute 'latency'");

  if (tblgen_latency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_latency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_latency).getType().isSignlessInteger(64)))))
    return emitError(loc, "'seq.read' op ""attribute 'latency' failed to satisfy constraint: 64-bit signless integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ReadPortOp::getODSOperandIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range ReadPortOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::HLMemType> ReadPortOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::HLMemType>>(*getODSOperands(0).begin());
}

::mlir::Operation::operand_range ReadPortOp::getAddresses() {
  return getODSOperands(1);
}

::mlir::TypedValue<::mlir::IntegerType> ReadPortOp::getRdEn() {
  auto operands = getODSOperands(2);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::OpOperand &ReadPortOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange ReadPortOp::getAddressesMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(1u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange ReadPortOp::getRdEnMutable() {
  auto range = getODSOperandIndexAndLength(2);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(2u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

std::pair<unsigned, unsigned> ReadPortOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ReadPortOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ReadPortOp::getReadData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::LogicalResult ReadPortOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.latency;
       auto attr = dict.get("latency");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for latency in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `latency` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("operandSegmentSizes");   if (!attr) attr = dict.get("operand_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for operandSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.operandSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute ReadPortOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.latency;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("latency",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.operandSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("operandSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code ReadPortOp::computePropertiesHash(const Properties &prop) {
  auto hash_operandSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    llvm::hash_value(prop.latency.getAsOpaquePointer()), 
    hash_operandSegmentSizes(prop.operandSegmentSizes));
}

std::optional<mlir::Attribute> ReadPortOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "latency")
      return prop.latency;
    if (name == "operand_segment_sizes" || name == "operandSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes);
  return std::nullopt;
}

void ReadPortOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "latency") {
       prop.latency = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.latency)>>(value);
       return;
    }
        if (name == "operand_segment_sizes" || name == "operandSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.operandSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.operandSegmentSizes.begin());
       return;
    }
}

void ReadPortOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.latency) attrs.append("latency", prop.latency);
  attrs.append("operandSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes));
}

::mlir::LogicalResult ReadPortOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getLatencyAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq13(attr, "latency", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult ReadPortOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readAttribute(prop.latency)))
    return ::mlir::failure();

  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.operandSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.operandSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void ReadPortOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;
  writer.writeAttribute(prop.latency);

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.operandSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.operandSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

::mlir::IntegerAttr ReadPortOp::getLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().latency);
}

uint64_t ReadPortOp::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

void ReadPortOp::setLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getLatencyAttrName(), attr);
}

void ReadPortOp::setLatency(uint64_t attrValue) {
  (*this)->setAttr(getLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type readData, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().latency = latency;
  odsState.addTypes(readData);
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().latency = latency;
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type readData, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().latency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency);
  odsState.addTypes(readData);
}

void ReadPortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, /*optional*/::mlir::Value rdEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  if (rdEn)
    odsState.addOperands(rdEn);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, static_cast<int32_t>(addresses.size()), (rdEn ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().latency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ReadPortOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult ReadPortOp::verifyInvariantsImpl() {
  auto tblgen_latency = getProperties().latency; (void)tblgen_latency;
  if (!tblgen_latency) return emitOpError("requires attribute 'latency'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq13(*this, tblgen_latency, "latency")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq6(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq7(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    if (valueGroup2.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup2.size();
    }

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((isValidIndexValues((*this->getODSOperands(0).begin()), this->getODSOperands(1)))))
    return emitOpError("failed to verify that address bit widths should be identical to the clog2 of the shape of the HLMemType");
  return ::mlir::success();
}

::mlir::LogicalResult ReadPortOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ReadPortOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ShiftRegOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ShiftRegOpGenericAdaptorBase::ShiftRegOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.shiftreg", odsAttrs.getContext());
}

ShiftRegOpGenericAdaptorBase::ShiftRegOpGenericAdaptorBase(ShiftRegOp op) : ShiftRegOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ShiftRegOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::DictionaryAttr ShiftRegOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr ShiftRegOpGenericAdaptorBase::getNumElementsAttr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().numElements);
  return attr;
}

uint64_t ShiftRegOpGenericAdaptorBase::getNumElements() {
  auto attr = getNumElementsAttr();
  return attr.getValue().getZExtValue();
}

::mlir::StringAttr ShiftRegOpGenericAdaptorBase::getNameAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
  return attr;
}

::std::optional< ::llvm::StringRef > ShiftRegOpGenericAdaptorBase::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr ShiftRegOpGenericAdaptorBase::getInnerSymAttr() {
  auto attr = ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
  return attr;
}

::std::optional<::circt::hw::InnerSymAttr> ShiftRegOpGenericAdaptorBase::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

} // namespace detail
ShiftRegOpAdaptor::ShiftRegOpAdaptor(ShiftRegOp op) : ShiftRegOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ShiftRegOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;
  auto tblgen_numElements = getProperties().numElements; (void)tblgen_numElements;
  if (!tblgen_numElements) return emitError(loc, "'seq.shiftreg' op ""requires attribute 'numElements'");

  if (tblgen_numElements && !((((::llvm::isa<::mlir::IntegerAttr>(tblgen_numElements))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_numElements).getType().isSignlessInteger(64)))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_numElements).getInt() >= 1))))
    return emitError(loc, "'seq.shiftreg' op ""attribute 'numElements' failed to satisfy constraint: 64-bit signless integer attribute whose minimum value is 1");

  if (tblgen_name && !((::llvm::isa<::mlir::StringAttr>(tblgen_name))))
    return emitError(loc, "'seq.shiftreg' op ""attribute 'name' failed to satisfy constraint: string attribute");

  if (tblgen_inner_sym && !((::llvm::isa<::circt::hw::InnerSymAttr>(tblgen_inner_sym))))
    return emitError(loc, "'seq.shiftreg' op ""attribute 'inner_sym' failed to satisfy constraint: Inner symbol definition");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ShiftRegOp::getODSOperandIndexAndLength(unsigned index) {
  ::llvm::ArrayRef<int32_t> sizeAttr = getProperties().operandSegmentSizes;

  unsigned start = 0;
  for (unsigned i = 0; i < index; ++i)
    start += sizeAttr[i];
  return {start, sizeAttr[index]};
}

::mlir::Operation::operand_range ShiftRegOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ShiftRegOp::getInput() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(0).begin());
}

::mlir::TypedValue<::circt::seq::ClockType> ShiftRegOp::getClk() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSOperands(1).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ShiftRegOp::getClockEnable() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> ShiftRegOp::getReset() {
  auto operands = getODSOperands(3);
  return operands.empty() ? ::mlir::TypedValue<::mlir::IntegerType>{} : ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*operands.begin());
}

::mlir::Value ShiftRegOp::getResetValue() {
  auto operands = getODSOperands(4);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::Value ShiftRegOp::getPowerOnValue() {
  auto operands = getODSOperands(5);
  return operands.empty() ? ::mlir::Value{} : ::llvm::cast<::mlir::Value>(*operands.begin());
}

::mlir::OpOperand &ShiftRegOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ShiftRegOp::getClkMutable() {
  auto range = getODSOperandIndexAndLength(1);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &ShiftRegOp::getClockEnableMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange ShiftRegOp::getResetMutable() {
  auto range = getODSOperandIndexAndLength(3);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(3u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange ShiftRegOp::getResetValueMutable() {
  auto range = getODSOperandIndexAndLength(4);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(4u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

::mlir::MutableOperandRange ShiftRegOp::getPowerOnValueMutable() {
  auto range = getODSOperandIndexAndLength(5);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second, ::mlir::MutableOperandRange::OperandSegment(5u, {getOperandSegmentSizesAttrName(), ::mlir::DenseI32ArrayAttr::get(getContext(), getProperties().operandSegmentSizes)}));
  return mutableRange;
}

std::pair<unsigned, unsigned> ShiftRegOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ShiftRegOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::Value ShiftRegOp::getData() {
  return ::llvm::cast<::mlir::Value>(*getODSResults(0).begin());
}

::mlir::LogicalResult ShiftRegOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.inner_sym;
       auto attr = dict.get("inner_sym");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for inner_sym in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `inner_sym` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.name;
       auto attr = dict.get("name");
    if (attr || /*isRequired=*/false) {
      if (!attr) {
        emitError() << "expected key entry for name in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `name` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }

  {
    auto &propStorage = prop.numElements;
       auto attr = dict.get("numElements");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for numElements in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `numElements` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
;
    {
      auto setFromAttr = [] (auto &propStorage, ::mlir::Attribute propAttr,
               ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
        return convertFromAttribute(propStorage, propAttr, emitError);;
      };
         auto attr = dict.get("operandSegmentSizes");   if (!attr) attr = dict.get("operand_segment_sizes");;
      if (!attr) {
        emitError() << "expected key entry for operandSegmentSizes in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      if (::mlir::failed(setFromAttr(prop.operandSegmentSizes, attr, emitError)))
        return ::mlir::failure();
    }
  return ::mlir::success();
}

::mlir::Attribute ShiftRegOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.inner_sym;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("inner_sym",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.name;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("name",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.numElements;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("numElements",
                                       propStorage));
    }

    {
      const auto &propStorage = prop.operandSegmentSizes;
      attrs.push_back(odsBuilder.getNamedAttr("operandSegmentSizes",
                                              ::mlir::DenseI32ArrayAttr::get(ctx, propStorage)));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code ShiftRegOp::computePropertiesHash(const Properties &prop) {
  auto hash_operandSegmentSizes = [] (const auto &propStorage) -> llvm::hash_code {
    return ::llvm::hash_combine_range(std::begin(propStorage), std::end(propStorage));;
  };
  return llvm::hash_combine(
    llvm::hash_value(prop.inner_sym.getAsOpaquePointer()), 
    llvm::hash_value(prop.name.getAsOpaquePointer()), 
    llvm::hash_value(prop.numElements.getAsOpaquePointer()), 
    hash_operandSegmentSizes(prop.operandSegmentSizes));
}

std::optional<mlir::Attribute> ShiftRegOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "inner_sym")
      return prop.inner_sym;

    if (name == "name")
      return prop.name;

    if (name == "numElements")
      return prop.numElements;
    if (name == "operand_segment_sizes" || name == "operandSegmentSizes") return ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes);
  return std::nullopt;
}

void ShiftRegOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "inner_sym") {
       prop.inner_sym = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.inner_sym)>>(value);
       return;
    }

    if (name == "name") {
       prop.name = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.name)>>(value);
       return;
    }

    if (name == "numElements") {
       prop.numElements = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.numElements)>>(value);
       return;
    }
        if (name == "operand_segment_sizes" || name == "operandSegmentSizes") {
       auto arrAttr = ::llvm::dyn_cast_or_null<::mlir::DenseI32ArrayAttr>(value);
       if (!arrAttr) return;
       if (arrAttr.size() != sizeof(prop.operandSegmentSizes) / sizeof(int32_t))
         return;
       llvm::copy(arrAttr.asArrayRef(), prop.operandSegmentSizes.begin());
       return;
    }
}

void ShiftRegOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.inner_sym) attrs.append("inner_sym", prop.inner_sym);

    if (prop.name) attrs.append("name", prop.name);

    if (prop.numElements) attrs.append("numElements", prop.numElements);
  attrs.append("operandSegmentSizes", ::mlir::DenseI32ArrayAttr::get(ctx, prop.operandSegmentSizes));
}

::mlir::LogicalResult ShiftRegOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getInnerSymAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(attr, "inner_sym", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getNameAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(attr, "name", emitError)))
        return ::mlir::failure();
    }

    {
      ::mlir::Attribute attr = attrs.get(getNumElementsAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq4(attr, "numElements", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult ShiftRegOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readOptionalAttribute(prop.inner_sym)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readOptionalAttribute(prop.name)))
    return ::mlir::failure();

  if (::mlir::failed(reader.readAttribute(prop.numElements)))
    return ::mlir::failure();

  if (reader.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
    auto &propStorage = prop.operandSegmentSizes;
    ::mlir::DenseI32ArrayAttr attr;
    if (::mlir::failed(reader.readAttribute(attr))) return ::mlir::failure();
    if (attr.size() > static_cast<int64_t>(sizeof(propStorage) / sizeof(int32_t))) {
      reader.emitError("size mismatch for operand/result_segment_size");
      return ::mlir::failure();
    }
    ::llvm::copy(::llvm::ArrayRef<int32_t>(attr), propStorage.begin());
  }

  {
    auto &propStorage = prop.operandSegmentSizes;
    auto readProp = [&]() {

  if (reader.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    return reader.readSparseArray(::llvm::MutableArrayRef(propStorage));
;
      return ::mlir::success();
    };
    if (::mlir::failed(readProp()))
      return ::mlir::failure();
  }
  return ::mlir::success();
}

void ShiftRegOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;

  writer.writeOptionalAttribute(prop.inner_sym);

  writer.writeOptionalAttribute(prop.name);
  writer.writeAttribute(prop.numElements);

if (writer.getBytecodeVersion() < /*kNativePropertiesODSSegmentSize=*/6) {
  auto &propStorage = prop.operandSegmentSizes;
  writer.writeAttribute(::mlir::DenseI32ArrayAttr::get(this->getContext(), propStorage));
}

  {
    auto &propStorage = prop.operandSegmentSizes;

  if (writer.getBytecodeVersion() >= /*kNativePropertiesODSSegmentSize=*/6)
    writer.writeSparseArray(::llvm::ArrayRef(propStorage));
;
  }
}

::mlir::IntegerAttr ShiftRegOp::getNumElementsAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().numElements);
}

uint64_t ShiftRegOp::getNumElements() {
  auto attr = getNumElementsAttr();
  return attr.getValue().getZExtValue();
}

::mlir::StringAttr ShiftRegOp::getNameAttr() {
  return ::llvm::dyn_cast_or_null<::mlir::StringAttr>(getProperties().name);
}

::std::optional< ::llvm::StringRef > ShiftRegOp::getName() {
  auto attr = getNameAttr();
  return attr ? ::std::optional< ::llvm::StringRef >(attr.getValue()) : (::std::nullopt);
}

::circt::hw::InnerSymAttr ShiftRegOp::getInnerSymAttr() {
  return ::llvm::dyn_cast_or_null<::circt::hw::InnerSymAttr>(getProperties().inner_sym);
}

::std::optional<::circt::hw::InnerSymAttr> ShiftRegOp::getInnerSym() {
  auto attr = getInnerSymAttr();
  return attr ? ::std::optional<::circt::hw::InnerSymAttr>(::llvm::cast<::circt::hw::InnerSymAttr>(attr)) : (::std::nullopt);
}

void ShiftRegOp::setNumElementsAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getNumElementsAttrName(), attr);
}

void ShiftRegOp::setNumElements(uint64_t attrValue) {
  (*this)->setAttr(getNumElementsAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void ShiftRegOp::setNameAttr(::mlir::StringAttr attr) {
  (*this)->setAttr(getNameAttrName(), attr);
}

void ShiftRegOp::setName(::std::optional<::llvm::StringRef> attrValue) {
    if (attrValue)
      return (*this)->setAttr(getNameAttrName(), ::mlir::Builder((*this)->getContext()).getStringAttr(*attrValue));
    (*this)->removeAttr(getNameAttrName());
}

void ShiftRegOp::setInnerSymAttr(::circt::hw::InnerSymAttr attr) {
  (*this)->setAttr(getInnerSymAttrName(), attr);
}

::mlir::Attribute ShiftRegOp::removeNameAttr() {
    auto &attr = getProperties().name;
    attr = {};
    return attr;
}

::mlir::Attribute ShiftRegOp::removeInnerSymAttr() {
    auto &attr = getProperties().inner_sym;
    attr = {};
    return attr;
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, ::mlir::IntegerAttr numElements, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().numElements = numElements;
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  odsState.addTypes(data);
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::IntegerAttr numElements, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().numElements = numElements;
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ShiftRegOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::IntegerAttr numElements, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().numElements = numElements;
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type data, uint64_t numElements, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().numElements = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), numElements);
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  odsState.addTypes(data);
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, uint64_t numElements, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().numElements = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), numElements);
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ShiftRegOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, uint64_t numElements, ::mlir::Value input, ::mlir::Value clk, ::mlir::Value clockEnable, /*optional*/::mlir::StringAttr name, /*optional*/::mlir::Value reset, /*optional*/::mlir::Value resetValue, /*optional*/::mlir::Value powerOnValue, /*optional*/::circt::hw::InnerSymAttr inner_sym) {
  odsState.addOperands(input);
  odsState.addOperands(clk);
  odsState.addOperands(clockEnable);
  if (reset)
    odsState.addOperands(reset);
  if (resetValue)
    odsState.addOperands(resetValue);
  if (powerOnValue)
    odsState.addOperands(powerOnValue);
  ::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, (reset ? 1 : 0), (resetValue ? 1 : 0), (powerOnValue ? 1 : 0)}), odsState.getOrAddProperties<Properties>().operandSegmentSizes.begin());
  odsState.getOrAddProperties<Properties>().numElements = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), numElements);
  if (name) {
    odsState.getOrAddProperties<Properties>().name = name;
  }
  if (inner_sym) {
    odsState.getOrAddProperties<Properties>().inner_sym = inner_sym;
  }
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ShiftRegOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ShiftRegOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ShiftRegOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ShiftRegOp::verifyInvariantsImpl() {
  auto tblgen_inner_sym = getProperties().inner_sym; (void)tblgen_inner_sym;
  auto tblgen_name = getProperties().name; (void)tblgen_name;
  auto tblgen_numElements = getProperties().numElements; (void)tblgen_numElements;
  if (!tblgen_numElements) return emitOpError("requires attribute 'numElements'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq4(*this, tblgen_numElements, "numElements")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq2(*this, tblgen_name, "name")))
    return ::mlir::failure();

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq1(*this, tblgen_inner_sym, "inner_sym")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    if (valueGroup3.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup3.size();
    }

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup4 = getODSOperands(4);

    if (valueGroup4.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup4.size();
    }

    for (auto v : valueGroup4) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup5 = getODSOperands(5);

    if (valueGroup5.size() > 1) {
      return emitOpError("operand group starting at #") << index
          << " requires 0 or 1 element, but found " << valueGroup5.size();
    }

    for (auto v : valueGroup5) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  if (!((((*this->getODSOperands(0).begin()).getType()) == ((*this->getODSResults(0).begin()).getType()) && ((*this->getODSResults(0).begin()).getType()) == ((*this->getODSOperands(0).begin()).getType()))))
    return emitOpError("failed to verify that all of {input, data} have same type");
  return ::mlir::success();
}

::mlir::LogicalResult ShiftRegOp::verifyInvariants() {
  if(::mlir::succeeded(verifyInvariantsImpl()) && ::mlir::succeeded(verify()))
    return ::mlir::success();
  return ::mlir::failure();
}

::mlir::LogicalResult ShiftRegOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = operands[0].getType();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ShiftRegOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::IntegerAttr numElementsAttr;
  ::circt::hw::InnerSymAttr inner_symAttr;
  ::mlir::StringAttr nameAttr;
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clkRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clkOperands(clkRawOperands);  ::llvm::SMLoc clkOperandsLoc;
  (void)clkOperandsLoc;
  ::mlir::OpAsmParser::UnresolvedOperand clockEnableRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> clockEnableOperands(clockEnableRawOperands);  ::llvm::SMLoc clockEnableOperandsLoc;
  (void)clockEnableOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> resetOperands;
  ::llvm::SMLoc resetOperandsLoc;
  (void)resetOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> resetValueOperands;
  ::llvm::SMLoc resetValueOperandsLoc;
  (void)resetValueOperandsLoc;
  ::llvm::SmallVector<::mlir::OpAsmParser::UnresolvedOperand, 4> powerOnValueOperands;
  ::llvm::SMLoc powerOnValueOperandsLoc;
  (void)powerOnValueOperandsLoc;
  ::mlir::Type dataRawTypes[1];
  ::llvm::ArrayRef<::mlir::Type> dataTypes(dataRawTypes);
  ::llvm::SmallVector<::mlir::Type, 1> resetValueTypes;
  ::llvm::SmallVector<::mlir::Type, 1> powerOnValueTypes;
  if (parser.parseLSquare())
    return ::mlir::failure();

  if (parser.parseCustomAttributeWithFallback(numElementsAttr, parser.getBuilder().getIntegerType(64))) {
    return ::mlir::failure();
  }
  if (numElementsAttr) result.getOrAddProperties<ShiftRegOp::Properties>().numElements = numElementsAttr;
  if (parser.parseRSquare())
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("sym"))) {

  if (parser.parseCustomAttributeWithFallback(inner_symAttr, ::mlir::Type{})) {
    return ::mlir::failure();
  }
  if (inner_symAttr) result.getOrAddProperties<ShiftRegOp::Properties>().inner_sym = inner_symAttr;
  }
  {
    auto odsResult = parseImplicitSSAName(parser, nameAttr);
    if (odsResult) return ::mlir::failure();
    if (nameAttr)
      result.getOrAddProperties<ShiftRegOp::Properties>().name = nameAttr;
  }

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  clkOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clkRawOperands[0]))
    return ::mlir::failure();
  if (parser.parseComma())
    return ::mlir::failure();

  clockEnableOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(clockEnableRawOperands[0]))
    return ::mlir::failure();
  if (::mlir::succeeded(parser.parseOptionalKeyword("reset"))) {

  {
    resetOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      resetOperands.push_back(operand);
    }
  }
  if (parser.parseComma())
    return ::mlir::failure();

  {
    resetValueOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      resetValueOperands.push_back(operand);
    }
  }
  }
  if (::mlir::succeeded(parser.parseOptionalKeyword("powerOn"))) {

  {
    powerOnValueOperandsLoc = parser.getCurrentLocation();
    ::mlir::OpAsmParser::UnresolvedOperand operand;
    ::mlir::OptionalParseResult parseResult =
                                    parser.parseOptionalOperand(operand);
    if (parseResult.has_value()) {
      if (failed(*parseResult))
        return ::mlir::failure();
      powerOnValueOperands.push_back(operand);
    }
  }
  }
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
    if (failed(verifyInherentAttrs(result.name, result.attributes, [&]() {
        return parser.emitError(loc) << "'" << result.name.getStringRef() << "' op ";
      })))
      return ::mlir::failure();
  }
  if (parser.parseColon())
    return ::mlir::failure();

  {
    ::mlir::Type type;
    if (parser.parseCustomTypeWithFallback(type))
      return ::mlir::failure();
    dataRawTypes[0] = type;
  }
  {
    ::std::optional<::mlir::OpAsmParser::UnresolvedOperand> resetValueOperand = resetValueOperands.empty() ? ::std::optional<::mlir::OpAsmParser::UnresolvedOperand>() : resetValueOperands[0];
    ::mlir::Type resetValueType;
    auto odsResult = parseOptionalTypeMatch(parser, dataRawTypes[0], resetValueOperand, resetValueType);
    if (odsResult) return ::mlir::failure();
    if (resetValueType)
      resetValueTypes.push_back(resetValueType);
  }
  {
    ::std::optional<::mlir::OpAsmParser::UnresolvedOperand> powerOnValueOperand = powerOnValueOperands.empty() ? ::std::optional<::mlir::OpAsmParser::UnresolvedOperand>() : powerOnValueOperands[0];
    ::mlir::Type powerOnValueType;
    auto odsResult = parseOptionalTypeMatch(parser, dataRawTypes[0], powerOnValueOperand, powerOnValueType);
    if (odsResult) return ::mlir::failure();
    if (powerOnValueType)
      powerOnValueTypes.push_back(powerOnValueType);
  }
::llvm::copy(::llvm::ArrayRef<int32_t>({1, 1, 1, static_cast<int32_t>(resetOperands.size()), static_cast<int32_t>(resetValueOperands.size()), static_cast<int32_t>(powerOnValueOperands.size())}), result.getOrAddProperties<ShiftRegOp::Properties>().operandSegmentSizes.begin());
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(dataTypes);
  if (parser.resolveOperands(inputOperands, dataTypes[0], inputOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clkOperands, odsBuildableType0, clkOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(clockEnableOperands, odsBuildableType1, clockEnableOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(resetOperands, odsBuildableType1, resetOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(resetValueOperands, resetValueTypes, resetValueOperandsLoc, result.operands))
    return ::mlir::failure();
  if (parser.resolveOperands(powerOnValueOperands, powerOnValueTypes, powerOnValueOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ShiftRegOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << "[";
  _odsPrinter.printAttributeWithoutType(getNumElementsAttr());
  _odsPrinter << "]";
  if (getInnerSymAttr()) {
    _odsPrinter << ' ' << "sym";
    _odsPrinter << ' ';
  _odsPrinter.printStrippedAttrOrType(getInnerSymAttr());
  }
  _odsPrinter << ' ';
  printImplicitSSAName(_odsPrinter, *this, getNameAttr());
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getClk();
  _odsPrinter << ",";
  _odsPrinter << ' ';
  _odsPrinter << getClockEnable();
  if (getReset()) {
    _odsPrinter << ' ' << "reset";
    _odsPrinter << ' ';
    if (::mlir::Value value = getReset())
      _odsPrinter << value;
    _odsPrinter << ",";
    _odsPrinter << ' ';
    if (::mlir::Value value = getResetValue())
      _odsPrinter << value;
  }
  if (getPowerOnValue()) {
    _odsPrinter << ' ' << "powerOn";
    _odsPrinter << ' ';
    if (::mlir::Value value = getPowerOnValue())
      _odsPrinter << value;
  }
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  elidedAttrs.push_back("operandSegmentSizes");
  elidedAttrs.push_back("numElements");
  elidedAttrs.push_back("inner_sym");
  elidedAttrs.push_back("name");
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
  _odsPrinter << ' ' << ":";
  _odsPrinter << ' ';
  {
    auto type = getData().getType();
    if (auto validType = ::llvm::dyn_cast<::mlir::Type>(type))
      _odsPrinter.printStrippedAttrOrType(validType);
   else
     _odsPrinter << type;
  }
  _odsPrinter << ' ';
  printOptionalTypeMatch(_odsPrinter, *this, getData().getType(), getResetValue(), (getResetValue() ? getResetValue().getType() : ::mlir::Type()));
  _odsPrinter << ' ';
  printOptionalTypeMatch(_odsPrinter, *this, getData().getType(), getPowerOnValue(), (getPowerOnValue() ? getPowerOnValue().getType() : ::mlir::Type()));
}

void ShiftRegOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ShiftRegOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::ToClockOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
ToClockOpGenericAdaptorBase::ToClockOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const ::mlir::EmptyProperties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.to_clock", odsAttrs.getContext());
}

ToClockOpGenericAdaptorBase::ToClockOpGenericAdaptorBase(ToClockOp op) : ToClockOpGenericAdaptorBase(op->getAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> ToClockOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  return {index, 1};
}

::mlir::DictionaryAttr ToClockOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

} // namespace detail
ToClockOpAdaptor::ToClockOpAdaptor(ToClockOp op) : ToClockOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult ToClockOpAdaptor::verify(::mlir::Location loc) {
  return ::mlir::success();
}

std::pair<unsigned, unsigned> ToClockOp::getODSOperandIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::operand_range ToClockOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::mlir::IntegerType> ToClockOp::getInput() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(0).begin());
}

::mlir::OpOperand &ToClockOp::getInputMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> ToClockOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range ToClockOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::ClockType> ToClockOp::getOutput() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::ClockType>>(*getODSResults(0).begin());
}

void ToClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Type output, ::mlir::Value input) {
  odsState.addOperands(input);
  odsState.addTypes(output);
}

void ToClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value input) {
  odsState.addOperands(input);

        ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
        if (::mlir::succeeded(ToClockOp::inferReturnTypes(odsBuilder.getContext(),
                      odsState.location, odsState.operands,
                      odsState.attributes.getDictionary(odsState.getContext()),
                      odsState.getRawProperties(),
                      odsState.regions, inferredReturnTypes)))
          odsState.addTypes(inferredReturnTypes);
        else
          ::llvm::report_fatal_error("Failed to infer result type(s).");
}

void ToClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value input) {
  odsState.addOperands(input);
  assert(resultTypes.size() == 1u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void ToClockOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 1u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

void ToClockOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() == 1u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);

  ::llvm::SmallVector<::mlir::Type, 2> inferredReturnTypes;
  if (::mlir::succeeded(ToClockOp::inferReturnTypes(odsBuilder.getContext(),
          odsState.location, operands,
          odsState.attributes.getDictionary(odsState.getContext()),
          odsState.getRawProperties(),
          odsState.regions, inferredReturnTypes))) {
    assert(inferredReturnTypes.size() == 1u && "mismatched number of return types");
    odsState.addTypes(inferredReturnTypes);
  } else {
    ::llvm::report_fatal_error("Failed to infer result type(s).");
  }
}

::mlir::LogicalResult ToClockOp::verifyInvariantsImpl() {
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSResults(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq0(*this, v.getType(), "result", index++)))
        return ::mlir::failure();
    }
  }
  return ::mlir::success();
}

::mlir::LogicalResult ToClockOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

void ToClockOp::getCanonicalizationPatterns(::mlir::RewritePatternSet &results, ::mlir::MLIRContext *context) {
  results.add(canonicalize);
}

::mlir::LogicalResult ToClockOp::inferReturnTypes(::mlir::MLIRContext *context, ::std::optional<::mlir::Location> location, ::mlir::ValueRange operands, ::mlir::DictionaryAttr attributes, ::mlir::OpaqueProperties properties, ::mlir::RegionRange regions, ::llvm::SmallVectorImpl<::mlir::Type>&inferredReturnTypes) {
  inferredReturnTypes.resize(1);
  ::mlir::Builder odsBuilder(context);
  ::mlir::Type odsInferredType0 = odsBuilder.getType<::circt::seq::ClockType>();
  inferredReturnTypes[0] = odsInferredType0;
  return ::mlir::success();
}

::mlir::ParseResult ToClockOp::parse(::mlir::OpAsmParser &parser, ::mlir::OperationState &result) {
  ::mlir::OpAsmParser::UnresolvedOperand inputRawOperands[1];
  ::llvm::ArrayRef<::mlir::OpAsmParser::UnresolvedOperand> inputOperands(inputRawOperands);  ::llvm::SMLoc inputOperandsLoc;
  (void)inputOperandsLoc;

  inputOperandsLoc = parser.getCurrentLocation();
  if (parser.parseOperand(inputRawOperands[0]))
    return ::mlir::failure();
  {
    auto loc = parser.getCurrentLocation();(void)loc;
    if (parser.parseOptionalAttrDict(result.attributes))
      return ::mlir::failure();
  }
  ::mlir::Type odsBuildableType0 = parser.getBuilder().getType<::circt::seq::ClockType>();
  ::mlir::Type odsBuildableType1 = parser.getBuilder().getIntegerType(1);
  result.addTypes(odsBuildableType0);
  if (parser.resolveOperands(inputOperands, odsBuildableType1, inputOperandsLoc, result.operands))
    return ::mlir::failure();
  return ::mlir::success();
}

void ToClockOp::print(::mlir::OpAsmPrinter &_odsPrinter) {
  _odsPrinter << ' ';
  _odsPrinter << getInput();
  ::llvm::SmallVector<::llvm::StringRef, 2> elidedAttrs;
  _odsPrinter.printOptionalAttrDict((*this)->getAttrs(), elidedAttrs);
}

void ToClockOp::getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::MemoryEffects::Effect>> &effects) {
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::ToClockOp)

namespace circt {
namespace seq {

//===----------------------------------------------------------------------===//
// ::circt::seq::WritePortOp definitions
//===----------------------------------------------------------------------===//

namespace detail {
WritePortOpGenericAdaptorBase::WritePortOpGenericAdaptorBase(::mlir::DictionaryAttr attrs, const Properties &properties, ::mlir::RegionRange regions) : odsAttrs(attrs), properties(properties), odsRegions(regions) {  if (odsAttrs)
    odsOpName.emplace("seq.write", odsAttrs.getContext());
}

WritePortOpGenericAdaptorBase::WritePortOpGenericAdaptorBase(WritePortOp op) : WritePortOpGenericAdaptorBase(op->getDiscardableAttrDictionary(), op.getProperties(), op->getRegions()) {}

std::pair<unsigned, unsigned> WritePortOpGenericAdaptorBase::getODSOperandIndexAndLength(unsigned index, unsigned odsOperandsSize) {
  bool isVariadic[] = {false, true, false, false};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (odsOperandsSize - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::DictionaryAttr WritePortOpGenericAdaptorBase::getAttributes() {
  return odsAttrs;
}

::mlir::IntegerAttr WritePortOpGenericAdaptorBase::getLatencyAttr() {
  auto attr = ::llvm::cast<::mlir::IntegerAttr>(getProperties().latency);
  return attr;
}

uint64_t WritePortOpGenericAdaptorBase::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

} // namespace detail
WritePortOpAdaptor::WritePortOpAdaptor(WritePortOp op) : WritePortOpGenericAdaptor(op->getOperands(), op) {}

::mlir::LogicalResult WritePortOpAdaptor::verify(::mlir::Location loc) {
  auto tblgen_latency = getProperties().latency; (void)tblgen_latency;
  if (!tblgen_latency) return emitError(loc, "'seq.write' op ""requires attribute 'latency'");

  if (tblgen_latency && !(((::llvm::isa<::mlir::IntegerAttr>(tblgen_latency))) && ((::llvm::cast<::mlir::IntegerAttr>(tblgen_latency).getType().isSignlessInteger(64)))))
    return emitError(loc, "'seq.write' op ""attribute 'latency' failed to satisfy constraint: 64-bit signless integer attribute");
  return ::mlir::success();
}

std::pair<unsigned, unsigned> WritePortOp::getODSOperandIndexAndLength(unsigned index) {
  bool isVariadic[] = {false, true, false, false};
  int prevVariadicCount = 0;
  for (unsigned i = 0; i < index; ++i)
    if (isVariadic[i]) ++prevVariadicCount;

  // Calculate how many dynamic values a static variadic operand corresponds to.
  // This assumes all static variadic operands have the same dynamic value count.
  int variadicSize = (getOperation()->getNumOperands() - 3) / 1;
  // `index` passed in as the parameter is the static index which counts each
  // operand (variadic or not) as size 1. So here for each previous static variadic
  // operand, we need to offset by (variadicSize - 1) to get where the dynamic
  // value pack for this static operand starts.
  int start = index + (variadicSize - 1) * prevVariadicCount;
  int size = isVariadic[index] ? variadicSize : 1;
  return {start, size};
}

::mlir::Operation::operand_range WritePortOp::getODSOperands(unsigned index) {
  auto valueRange = getODSOperandIndexAndLength(index);
  return {std::next(getOperation()->operand_begin(), valueRange.first),
           std::next(getOperation()->operand_begin(), valueRange.first + valueRange.second)};
}

::mlir::TypedValue<::circt::seq::HLMemType> WritePortOp::getMemory() {
  return ::llvm::cast<::mlir::TypedValue<::circt::seq::HLMemType>>(*getODSOperands(0).begin());
}

::mlir::Operation::operand_range WritePortOp::getAddresses() {
  return getODSOperands(1);
}

::mlir::Value WritePortOp::getInData() {
  return ::llvm::cast<::mlir::Value>(*getODSOperands(2).begin());
}

::mlir::TypedValue<::mlir::IntegerType> WritePortOp::getWrEn() {
  return ::llvm::cast<::mlir::TypedValue<::mlir::IntegerType>>(*getODSOperands(3).begin());
}

::mlir::OpOperand &WritePortOp::getMemoryMutable() {
  auto range = getODSOperandIndexAndLength(0);
  return getOperation()->getOpOperand(range.first);
}

::mlir::MutableOperandRange WritePortOp::getAddressesMutable() {
  auto range = getODSOperandIndexAndLength(1);
  auto mutableRange = ::mlir::MutableOperandRange(getOperation(), range.first, range.second);
  return mutableRange;
}

::mlir::OpOperand &WritePortOp::getInDataMutable() {
  auto range = getODSOperandIndexAndLength(2);
  return getOperation()->getOpOperand(range.first);
}

::mlir::OpOperand &WritePortOp::getWrEnMutable() {
  auto range = getODSOperandIndexAndLength(3);
  return getOperation()->getOpOperand(range.first);
}

std::pair<unsigned, unsigned> WritePortOp::getODSResultIndexAndLength(unsigned index) {
  return {index, 1};
}

::mlir::Operation::result_range WritePortOp::getODSResults(unsigned index) {
  auto valueRange = getODSResultIndexAndLength(index);
  return {std::next(getOperation()->result_begin(), valueRange.first),
           std::next(getOperation()->result_begin(), valueRange.first + valueRange.second)};
}

::mlir::LogicalResult WritePortOp::setPropertiesFromAttr(Properties &prop, ::mlir::Attribute attr, ::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
  ::mlir::DictionaryAttr dict = ::llvm::dyn_cast<::mlir::DictionaryAttr>(attr);
  if (!dict) {
    emitError() << "expected DictionaryAttr to set properties";
    return ::mlir::failure();
  }

  {
    auto &propStorage = prop.latency;
       auto attr = dict.get("latency");
    if (attr || /*isRequired=*/true) {
      if (!attr) {
        emitError() << "expected key entry for latency in DictionaryAttr to set "
                   "Properties.";
        return ::mlir::failure();
      }
      auto convertedAttr = ::llvm::dyn_cast<std::remove_reference_t<decltype(propStorage)>>(attr);
      if (convertedAttr) {
        propStorage = convertedAttr;
      } else {
        emitError() << "Invalid attribute `latency` in property conversion: " << attr;
        return ::mlir::failure();
      }
    }
  }
  return ::mlir::success();
}

::mlir::Attribute WritePortOp::getPropertiesAsAttr(::mlir::MLIRContext *ctx, const Properties &prop) {
    ::mlir::SmallVector<::mlir::NamedAttribute> attrs;
    ::mlir::Builder odsBuilder{ctx};

    {
      const auto &propStorage = prop.latency;
      if (propStorage)
        attrs.push_back(odsBuilder.getNamedAttr("latency",
                                       propStorage));
    }

  if (!attrs.empty())
    return odsBuilder.getDictionaryAttr(attrs);
  return {};
}

llvm::hash_code WritePortOp::computePropertiesHash(const Properties &prop) {
  return llvm::hash_combine(
    llvm::hash_value(prop.latency.getAsOpaquePointer()));
}

std::optional<mlir::Attribute> WritePortOp::getInherentAttr(::mlir::MLIRContext *ctx, const Properties &prop, llvm::StringRef name) {
    if (name == "latency")
      return prop.latency;
  return std::nullopt;
}

void WritePortOp::setInherentAttr(Properties &prop, llvm::StringRef name, mlir::Attribute value) {
    if (name == "latency") {
       prop.latency = ::llvm::dyn_cast_or_null<std::remove_reference_t<decltype(prop.latency)>>(value);
       return;
    }
}

void WritePortOp::populateInherentAttrs(::mlir::MLIRContext *ctx, const Properties &prop, ::mlir::NamedAttrList &attrs) {
    if (prop.latency) attrs.append("latency", prop.latency);
}

::mlir::LogicalResult WritePortOp::verifyInherentAttrs(::mlir::OperationName opName, ::mlir::NamedAttrList &attrs, llvm::function_ref<::mlir::InFlightDiagnostic()> emitError) {
    {
      ::mlir::Attribute attr = attrs.get(getLatencyAttrName(opName));
      if (attr && ::mlir::failed(__mlir_ods_local_attr_constraint_Seq13(attr, "latency", emitError)))
        return ::mlir::failure();
    }
    return ::mlir::success();
}

::mlir::LogicalResult WritePortOp::readProperties(::mlir::DialectBytecodeReader &reader, ::mlir::OperationState &state) {
  auto &prop = state.getOrAddProperties<Properties>(); (void)prop;
  if (::mlir::failed(reader.readAttribute(prop.latency)))
    return ::mlir::failure();
  return ::mlir::success();
}

void WritePortOp::writeProperties(::mlir::DialectBytecodeWriter &writer) {
  auto &prop = getProperties(); (void)prop;
  writer.writeAttribute(prop.latency);
}

::mlir::IntegerAttr WritePortOp::getLatencyAttr() {
  return ::llvm::cast<::mlir::IntegerAttr>(getProperties().latency);
}

uint64_t WritePortOp::getLatency() {
  auto attr = getLatencyAttr();
  return attr.getValue().getZExtValue();
}

void WritePortOp::setLatencyAttr(::mlir::IntegerAttr attr) {
  (*this)->setAttr(getLatencyAttrName(), attr);
}

void WritePortOp::setLatency(uint64_t attrValue) {
  (*this)->setAttr(getLatencyAttrName(), ::mlir::Builder((*this)->getContext()).getIntegerAttr(::mlir::Builder((*this)->getContext()).getIntegerType(64), attrValue));
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.getOrAddProperties<Properties>().latency = latency;
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, ::mlir::IntegerAttr latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.getOrAddProperties<Properties>().latency = latency;
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.getOrAddProperties<Properties>().latency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency);
}

void WritePortOp::build(::mlir::OpBuilder &odsBuilder, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::Value memory, ::mlir::ValueRange addresses, ::mlir::Value inData, ::mlir::Value wrEn, uint64_t latency) {
  odsState.addOperands(memory);
  odsState.addOperands(addresses);
  odsState.addOperands(inData);
  odsState.addOperands(wrEn);
  odsState.getOrAddProperties<Properties>().latency = odsBuilder.getIntegerAttr(odsBuilder.getIntegerType(64), latency);
  assert(resultTypes.size() == 0u && "mismatched number of results");
  odsState.addTypes(resultTypes);
}

void WritePortOp::build(::mlir::OpBuilder &, ::mlir::OperationState &odsState, ::mlir::TypeRange resultTypes, ::mlir::ValueRange operands, ::llvm::ArrayRef<::mlir::NamedAttribute> attributes) {
  assert(operands.size() >= 3u && "mismatched number of parameters");
  odsState.addOperands(operands);
  odsState.addAttributes(attributes);
  assert(resultTypes.size() == 0u && "mismatched number of return types");
  odsState.addTypes(resultTypes);
}

::mlir::LogicalResult WritePortOp::verifyInvariantsImpl() {
  auto tblgen_latency = getProperties().latency; (void)tblgen_latency;
  if (!tblgen_latency) return emitOpError("requires attribute 'latency'");

  if (::mlir::failed(__mlir_ods_local_attr_constraint_Seq13(*this, tblgen_latency, "latency")))
    return ::mlir::failure();
  {
    unsigned index = 0; (void)index;
    auto valueGroup0 = getODSOperands(0);

    for (auto v : valueGroup0) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq6(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup1 = getODSOperands(1);

    for (auto v : valueGroup1) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq7(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup2 = getODSOperands(2);

    for (auto v : valueGroup2) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq2(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
    auto valueGroup3 = getODSOperands(3);

    for (auto v : valueGroup3) {
      if (::mlir::failed(__mlir_ods_local_type_constraint_Seq1(*this, v.getType(), "operand", index++)))
        return ::mlir::failure();
    }
  }
  if (!((std::equal_to<>()((*this->getODSOperands(0).begin()).getType().cast<HLMemType>().getElementType(), (*this->getODSOperands(2).begin()).getType()))))
    return emitOpError("failed to verify that type of 'value' matches element type of 'hlmemvalue'");
  if (!((isValidIndexValues((*this->getODSOperands(0).begin()), this->getODSOperands(1)))))
    return emitOpError("failed to verify that address bit widths should be identical to the clog2 of the shape of the HLMemType");
  return ::mlir::success();
}

::mlir::LogicalResult WritePortOp::verifyInvariants() {
  return verifyInvariantsImpl();
}

} // namespace seq
} // namespace circt
MLIR_DEFINE_EXPLICIT_TYPE_ID(::circt::seq::WritePortOp)


#endif  // GET_OP_CLASSES

